/*
 *  Copyright CNRS-AIST
 *
 *  Authors: Fumio Kanehiro, Florent Lamiraux, Olivier Stasse
 */
#include <iostream>
#include "hrp2-dynamics/hrp2OptHumanoidDynamicRobot.h"

using namespace dynamicsJRLJapan;

void Chrp2OptHumanoidDynamicRobot::computeJacobianCenterOfMass()
{
  double L[36*3],q[36];

  // Remap correctly the current configuration
  // and the one for the CoM Jacobian.
  const vectorN& cfg = currentConfiguration();

  // Waist(6) Configuration
  for(int i=0;i<6;i++)
    q[30+i] = cfg[i];

  // Joint configurations(legs(12), waist(2), neck(2) and right_arm(7)).
  for(int i=0;i<23;i++) q[i] = cfg[i+6];

  unsigned int leftArm = m_isKineoOrder ? (6+16+7+5) : (6+16+7);
  // Joint configurations(left arm(7)).
  for(int i=0;i<7;i++) q[i+23] = cfg[leftArm+i];

  //Long neck jacobian (does not take into account the added mass)
  double t1060;
  double t881;
  double t163;
  double t231;
  double t1007;
  double t210;
  double t664;
  double t34;
  double t1368;
  double t981;
  double t43;
  double t44;
  double t81;
  double t745;
  double t40;
  double t41;
  double t265;
  double t677;
  double t6;
  double t7;
  double t836;
  double t220;
  double t222;
  double t223;
  double t224;
  double t227;
  double t983;
  double t438;
  double t441;
  double t354;
  double t70;
  double t203;
  double t47;
  double t132;
  double t102;
  double t15;
  double t558;
  double t560;
  double t563;
  double t570;
  double t197;
  double t199;
  double t200;
  double t201;
  double t204;
  double t207;
  double t208;
  double t209;
  double t501;
  double t94;
  double t290;
  double t804;
  double t977;
  double t1011;
  double t957;
  double t963;
  double t975;
  double t734;
  double t198;
  double t202;
  double t1022;
  double t413;
  double t831;
  double t96;
  double t254;
  double t256;
  double t260;
  double t262;
  double t25;
  double t32;
  double t48;
  double t234;
  double t849;
  double t416;
  double t196;
  double t440;
  double t104;
  double t811;
  double t999;
  double t994;
  double t989;
  double t987;
  double t1063;
  double t382;
  double t951;
  double t778;
  double t514;
  double t518;
  double t355;
  double t549;
  double t1166;
  double t184;
  double t185;
  double t186;
  double t187;
  double t188;
  double t189;
  double t319;
  double t460;
  double t1048;
  double t352;
  double t356;
  double t2;
  double t228;
  double t728;
  double t1069;
  double t49;
  double t50;
  double t136;
  double t371;
  double t609;
  double t61;
  double t206;
  double t215;
  double t270;
  double t1139;
  double t843;
  double t755;
  double t130;
  double t351;
  double t624;
  double t446;
  double t1072;
  double t668;
  double t395;
  double t1027;
  double t1066;
  double t823;
  double t406;
  double t347;
  double t437;
  double t191;
  double t1053;
  double t1075;
  double t248;
  double t62;
  double t304;
  double t309;
  double t641;
  double t456;
  double t1078;
  double t497;
  double t495;
  double t489;
  double t1029;
  double t767;
  double t432;
  double t458;
  double t35;
  double t36;
  double t51;
  double t52;
  double t602;
  double t780;
  double t1083;
  double t1295;
  double t221;
  double t372;
  double t373;
  double t375;
  double t376;
  double t461;
  double t758;
  double t762;
  double t468;
  double t481;
  double t443;
  double t444;
  double t445;
  double t447;
  double t448;
  double t449;
  double t450;
  double t451;
  double t452;
  double t453;
  double t873;
  double t812;
  double t528;
  double t272;
  double t1031;
  double t122;
  double t124;
  double t126;
  double t362;
  double t939;
  double t1043;
  double t683;
  double t171;
  double t176;
  double t374;
  double t106;
  double t276;
  double t459;
  double t799;
  double t138;
  double t67;
  double t212;
  double t213;
  double t214;
  double t216;
  double t217;
  double t218;
  double t219;
  double t211;
  double t64;
  double t327;
  double t16;
  double t851;
  double t885;
  double t315;
  double t10;
  double t415;
  double t1041;
  double t325;
  double t88;
  double t90;
  double t350;
  double t490;
  double t492;
  double t493;
  double t494;
  double t502;
  double t353;
  double t357;
  double t360;
  double t361;
  double t409;
  double t410;
  double t411;
  double t414;
  double t419;
  double t420;
  double t421;
  double t422;
  double t408;
  double t337;
  double t404;
  double t143;
  double t205;
  double t358;
  double t418;
  double t53;
  double t37;
  double t1088;
  double t714;
  double t466;
  double t57;
  double t56;
  double t12;
  double t13;
  double t29;
  double t30;
  double t225;
  double t702;
  double t782;
  double t786;
  double t788;
  double t792;
  double t794;
  double t439;
  double t167;
  double t708;
  double t897;
  double t719;
  double t773;
  double t732;
  double t359;
  double t915;
  double t471;
  double t292;
  double t892;
  double t27;
  double t28;
  double t38;
  double t226;
  double t407;
  double t364;
  double t597;
  double t149;
  double t363;
  double t365;
  double t366;
  double t368;
  double t369;
  double t268;
  double t8;
  double t619;
  double t17;
  double t18;
  double t229;
  double t235;
  double t673;
  double t955;
  double t685;
  double t506;
  double t508;
  double t511;
  double t917;
  double t383;
  double t973;
  double t302;
  double t632;
  double t475;
  double t862;
  double t724;
  double t455;
  double t457;
  double t464;
  double t465;
  double t467;
  double t9;
  double t58;
  double t21;
  double t22;
  double t278;
  double t283;
  double t230;
  double t692;
  double t1016;
  double t710;
  double t507;
  double t65;
  double t690;
  double t613;
  double t425;
  double t82;
  double t169;
  double t505;
  double t19;
  double t600;
  double t868;
  double t1096;
  double t913;
  double t26;
  double t697;
  double t750;
  double t153;
  double t159;
  double t161;
  double t71;
  double t72;
  double t342;
  double t463;
  double t932;
  double t856;
  double t858;
  double t66;
  double t462;
  double t946;
  double t807;
  double t877;
  double t574;
  double t20;
  double t85;
  double t45;
  double t809;
  double t934;
  double t941;
  double t726;
  double t1018;
  double t706;
  double t367;
  double t1;
  double t1103;
  double t384;
  double t385;
  double t389;
  double t390;
  double t391;
  double t392;
  double t377;
  double t288;
  double t296;
  double t423;
  double t500;
  double t829;
  double t487;
  double t1035;
  double t33;
  double t582;
  double t587;
  double t594;
  double t181;
  double t424;
  double t427;
  double t428;
  double t429;
  double t430;
  double t431;
  double t329;
  double t253;
  double t236;
  double t562;
  double t5;
  double t14;
  double t59;
  double t520;
  double t522;
  double t469;
  double t470;
  double t473;
  double t474;
  double t476;
  double t477;
  double t479;
  double t480;
  double t555;
  double t666;
  double t31;
  double t578;
  double t968;
  double t488;
  double t240;
  double t241;
  double t482;
  double t483;
  double t484;
  double t485;
  double t486;
  double t472;
  double t11;
  double t535;
  double t537;
  double t539;
  double t412;
  double t496;
  double t426;
  double t370;
  double t478;
  double t769;
  double t239;
  double t23;
  double t24;
  double t1056;
  double t607;
  double t819;
  double t827;
  double t648;
  double t650;
  double t655;
  double t660;
  double t87;
  double t959;
  double t242;
  double t628;
  double t634;
  double t636;
  double t491;
  double t73;
  double t890;
  double t899;
  double t904;
  double t909;
  double t643;
  double t883;
  double t417;
  double t1037;
  double t99;
  double t580;
  double t393;
  double t394;
  double t396;
  double t397;
  double t398;
  double t399;
  double t400;
  double t401;
  double t402;
  double t403;
  double t405;
  double t543;
  double t39;
  double t117;
  double t386;
  double t42;
  double t251;
  double t1286;
  double t46;
  double t298;
  double t190;
  double t192;
  double t193;
  double t194;
  double t195;
  double t738;
  double t740;
  double t1004;
  double t3;
  double t4;
  double t454;
  double t333;
  double t335;
  double t679;
  double t922;
  double t926;
  double t928;
  double t388;
  double t846;
  double t110;
  double t112;
  t1 = q[35];
  t2 = cos(t1);
  t3 = q[34];
  t4 = cos(t3);
  t5 = t2 * t4;
  t6 = q[0];
  t7 = sin(t6);
  t8 = q[2];
  t9 = cos(t8);
  t10 = q[3];
  t11 = cos(t10);
  t12 = q[4];
  t13 = cos(t12);
  t14 = 0.4318600466e-2 * t13;
  t15 = sin(t12);
  t16 = q[5];
  t17 = sin(t16);
  t18 = 0.7684553059e-2 * t17;
  t19 = cos(t16);
  t20 = 0.1071449130e0 * t19;
  t21 = -0.1580767500e-2 - t18 - t20;
  t22 = t15 * t21;
  t23 = 0.3143585651e-1 + t14 + t22;
  t24 = t11 * t23;
  t25 = sin(t10);
  t26 = 0.4318600466e-2 * t15;
  t27 = t13 * t21;
  t28 = -0.9296094464e0 - t26 + t27;
  t29 = t25 * t28;
  t30 = 0.7182945987e-2 + t24 + t29;
  t31 = t9 * t30;
  t32 = sin(t8);
  t33 = t25 * t23;
  t34 = t11 * t28;
  t35 = -0.1526986523e1 - t33 + t34;
  t36 = t32 * t35;
  t37 = -0.1354459759e-1 + t31 + t36;
  t38 = t7 * t37;
  t39 = cos(t6);
  t40 = q[1];
  t41 = cos(t40);
  t42 = 0.7684553059e-2 * t19;
  t43 = 0.1071449130e0 * t17;
  t44 = -0.3652058335e0 - t42 + t43;
  t45 = t41 * t44;
  t46 = sin(t40);
  t47 = t32 * t30;
  t48 = t9 * t35;
  t49 = -0.2353404227e-2 - t47 + t48;
  t50 = t46 * t49;
  t51 = 0.5692054037e-2 + t45 - t50;
  t52 = t39 * t51;
  t53 = -t38 - t52;
  t56 = sin(t3);
  t57 = t2 * t56;
  t58 = q[33];
  t59 = sin(t58);
  t61 = sin(t1);
  t62 = cos(t58);
  t64 = t57 * t59 - t61 * t62;
  t65 = t39 * t37;
  t66 = t7 * t51;
  t67 = t65 - t66;
  L[0] = 0.1758459731e-1 * t5 * t53 + 0.1758459731e-1 * t64 * t67;
  t70 = t46 * t44;
  t71 = t41 * t49;
  t72 = -t70 - t71;
  t73 = t7 * t72;
  t81 = t57 * t62 + t61 * t59;
  t82 = t45 - t50;
  L[1] = -0.1758459731e-1 * t5 * t73 + 0.1758459731e-1 * t64 * t39 * t72 + 0.1758459731e-1 * t81 * t82;
  t85 = -t47 + t48;
  t87 = t7 * t46;
  t88 = -t31 - t36;
  t90 = t39 * t85 + t87 * t88;
  t94 = t39 * t46;
  t96 = t7 * t85 - t94 * t88;
  t99 = t81 * t41;
  L[2] = 0.1758459731e-1 * t5 * t90 + 0.1758459731e-1 * t64 * t96 + 0.1758459731e-1 * t99 * t88;
  t102 = -t33 + t34;
  t104 = -t24 - t29;
  t106 = t9 * t102 + t32 * t104;
  t110 = -t32 * t102 + t9 * t104;
  t112 = t39 * t106 + t87 * t110;
  t117 = t7 * t106 - t94 * t110;
  L[3] = 0.1758459731e-1 * t5 * t112 + 0.1758459731e-1 * t64 * t117 + 0.1758459731e-1 * t99 * t110;
  t122 = -t26 + t27;
  t124 = -t14 - t22;
  t126 = t11 * t122 + t25 * t124;
  t130 = -t25 * t122 + t11 * t124;
  t132 = t9 * t126 + t32 * t130;
  t136 = -t32 * t126 + t9 * t130;
  t138 = t39 * t132 + t87 * t136;
  t143 = t7 * t132 - t94 * t136;
  L[4] = 0.1758459731e-1 * t5 * t138 + 0.1758459731e-1 * t64 * t143 + 0.1758459731e-1 * t99 * t136;
  t149 = -t42 + t43;
  t153 = t11 * t15 * t149 + t25 * t13 * t149;
  t159 = -t25 * t15 * t149 + t11 * t13 * t149;
  t161 = t9 * t153 + t32 * t159;
  t163 = t18 + t20;
  t167 = -t32 * t153 + t9 * t159;
  t169 = t41 * t163 - t46 * t167;
  t171 = t39 * t161 - t7 * t169;
  t176 = t7 * t161 + t39 * t169;
  t181 = t46 * t163 + t41 * t167;
  L[5] = 0.1758459731e-1 * t5 * t171 + 0.1758459731e-1 * t64 * t176 + 0.1758459731e-1 * t81 * t181;
  t184 = q[6];
  t185 = sin(t184);
  t186 = q[8];
  t187 = cos(t186);
  t188 = q[9];
  t189 = cos(t188);
  t190 = q[10];
  t191 = cos(t190);
  t192 = 0.4318600466e-2 * t191;
  t193 = sin(t190);
  t194 = q[11];
  t195 = sin(t194);
  t196 = 0.7684553059e-2 * t195;
  t197 = cos(t194);
  t198 = 0.1071449130e0 * t197;
  t199 = -0.1580767500e-2 + t196 - t198;
  t200 = t193 * t199;
  t201 = 0.3143585651e-1 + t192 + t200;
  t202 = t189 * t201;
  t203 = sin(t188);
  t204 = 0.4318600466e-2 * t193;
  t205 = t191 * t199;
  t206 = -0.9296094464e0 - t204 + t205;
  t207 = t203 * t206;
  t208 = 0.7182945987e-2 + t202 + t207;
  t209 = t187 * t208;
  t210 = sin(t186);
  t211 = t203 * t201;
  t212 = t189 * t206;
  t213 = -0.1526986523e1 - t211 + t212;
  t214 = t210 * t213;
  t215 = -0.1354459759e-1 + t209 + t214;
  t216 = t185 * t215;
  t217 = cos(t184);
  t218 = q[7];
  t219 = cos(t218);
  t220 = 0.7684553059e-2 * t197;
  t221 = 0.1071449130e0 * t195;
  t222 = 0.3652058335e0 + t220 + t221;
  t223 = t219 * t222;
  t224 = sin(t218);
  t225 = t210 * t208;
  t226 = t187 * t213;
  t227 = -0.2353404227e-2 - t225 + t226;
  t228 = t224 * t227;
  t229 = -0.5692054037e-2 + t223 - t228;
  t230 = t217 * t229;
  t231 = -t216 - t230;
  t234 = t217 * t215;
  t235 = t185 * t229;
  t236 = t234 - t235;
  L[6] = 0.1758459731e-1 * t5 * t231 + 0.1758459731e-1 * t64 * t236;
  t239 = t224 * t222;
  t240 = t219 * t227;
  t241 = -t239 - t240;
  t242 = t185 * t241;
  t248 = t223 - t228;
  L[7] = -0.1758459731e-1 * t5 * t242 + 0.1758459731e-1 * t64 * t217 * t241 + 0.1758459731e-1 * t81 * t248;
  t251 = -t225 + t226;
  t253 = t185 * t224;
  t254 = -t209 - t214;
  t256 = t217 * t251 + t253 * t254;
  t260 = t217 * t224;
  t262 = t185 * t251 - t260 * t254;
  t265 = t81 * t219;
  L[8] = 0.1758459731e-1 * t5 * t256 + 0.1758459731e-1 * t64 * t262 + 0.1758459731e-1 * t265 * t254;
  t268 = -t211 + t212;
  t270 = -t202 - t207;
  t272 = t187 * t268 + t210 * t270;
  t276 = -t210 * t268 + t187 * t270;
  t278 = t217 * t272 + t253 * t276;
  t283 = t185 * t272 - t260 * t276;
  L[9] = 0.1758459731e-1 * t5 * t278 + 0.1758459731e-1 * t64 * t283 + 0.1758459731e-1 * t265 * t276;
  t288 = -t204 + t205;
  t290 = -t192 - t200;
  t292 = t189 * t288 + t203 * t290;
  t296 = -t203 * t288 + t189 * t290;
  t298 = t187 * t292 + t210 * t296;
  t302 = -t210 * t292 + t187 * t296;
  t304 = t217 * t298 + t253 * t302;
  t309 = t185 * t298 - t260 * t302;
  L[10] = 0.1758459731e-1 * t5 * t304 + 0.1758459731e-1 * t64 * t309 + 0.1758459731e-1 * t265 * t302;
  t315 = t220 + t221;
  t319 = t189 * t193 * t315 + t203 * t191 * t315;
  t325 = -t203 * t193 * t315 + t189 * t191 * t315;
  t327 = t187 * t319 + t210 * t325;
  t329 = -t196 + t198;
  t333 = -t210 * t319 + t187 * t325;
  t335 = t219 * t329 - t224 * t333;
  t337 = t217 * t327 - t185 * t335;
  t342 = t185 * t327 + t217 * t335;
  t347 = t224 * t329 + t219 * t333;
  L[11] = 0.1758459731e-1 * t5 * t337 + 0.1758459731e-1 * t64 * t342 + 0.1758459731e-1 * t81 * t347;
  t350 = q[12];
  t351 = sin(t350);
  t352 = q[13];
  t353 = cos(t352);
  t354 = q[14];
  t355 = cos(t354);
  t356 = q[15];
  t357 = cos(t356);
  t358 = 0.1290214844e-1 * t357;
  t359 = sin(t356);
  t360 = 0.1080378388e0 * t359;
  t361 = -0.3280443429e-3 + t358 + t360;
  t362 = t355 * t361;
  t363 = sin(t354);
  t364 = 0.1682729166e-2 * t363;
  t365 = q[16];
  t366 = cos(t365);
  t367 = q[18];
  t368 = cos(t367);
  t369 = q[19];
  t370 = cos(t369);
  t371 = q[20];
  t372 = cos(t371);
  t373 = q[21];
  t374 = cos(t373);
  t375 = 0.4140505304e-2 * t374;
  t376 = sin(t373);
  t377 = q[22];
  t382 = -0.1071654925e0 + 0.5726476e0 * (0.6383874596e-2 + 0.9266914736e-2 * t377) * t377;
  t383 = t376 * t382;
  t384 = -0.1912846705e-2 + t375 + t383;
  t385 = t372 * t384;
  t386 = sin(t371);
  t388 = -0.2297276272e-2 - 0.5360279276e-3 * t377;
  t389 = t386 * t388;
  t390 = -0.7205107036e-5 + t385 - t389;
  t391 = t370 * t390;
  t392 = sin(t369);
  t393 = 0.4140505304e-2 * t376;
  t394 = t374 * t382;
  t395 = -0.4510018277e0 - t393 + t394;
  t396 = t392 * t395;
  t397 = -0.8685296189e-2 + t391 + t396;
  t398 = t368 * t397;
  t399 = sin(t367);
  t400 = t386 * t384;
  t401 = t372 * t388;
  t402 = -0.2024021021e-1 + t400 + t401;
  t403 = t399 * t402;
  t404 = -0.1894413517e-1 + t398 - t403;
  t405 = t366 * t404;
  t406 = sin(t365);
  t407 = q[17];
  t408 = sin(t407);
  t409 = t399 * t397;
  t410 = t368 * t402;
  t411 = -0.1245819092e-1 + t409 + t410;
  t412 = t408 * t411;
  t413 = cos(t407);
  t414 = t392 * t390;
  t415 = t370 * t395;
  t416 = -0.8962806183e0 - t414 + t415;
  t417 = t413 * t416;
  t418 = -0.1240711988e-3 + t412 + t417;
  t419 = t406 * t418;
  t420 = q[23];
  t421 = cos(t420);
  t422 = q[25];
  t423 = cos(t422);
  t424 = q[26];
  t425 = cos(t424);
  t426 = q[27];
  t427 = cos(t426);
  t428 = q[28];
  t429 = cos(t428);
  t430 = 0.4140505304e-2 * t429;
  t431 = sin(t428);
  t432 = q[29];
  t437 = -0.1071654925e0 + 0.5726476e0 * (0.6383874596e-2 + 0.9266914736e-2 * t432) * t432;
  t438 = t431 * t437;
  t439 = 0.1373880793e-2 + t430 + t438;
  t440 = t427 * t439;
  t441 = sin(t426);
  t443 = 0.2297276272e-2 + 0.5360279276e-3 * t432;
  t444 = t441 * t443;
  t445 = -0.7205107036e-5 + t440 - t444;
  t446 = t425 * t445;
  t447 = sin(t424);
  t448 = 0.4140505304e-2 * t431;
  t449 = t429 * t437;
  t450 = -0.4510018277e0 - t448 + t449;
  t451 = t447 * t450;
  t452 = -0.8685296189e-2 + t446 + t451;
  t453 = t423 * t452;
  t454 = sin(t422);
  t455 = t441 * t439;
  t456 = t427 * t443;
  t457 = 0.2024021021e-1 + t455 + t456;
  t458 = t454 * t457;
  t459 = -0.1894413517e-1 + t453 - t458;
  t460 = t421 * t459;
  t461 = sin(t420);
  t462 = q[24];
  t463 = sin(t462);
  t464 = t454 * t452;
  t465 = t423 * t457;
  t466 = 0.1245819092e-1 + t464 + t465;
  t467 = t463 * t466;
  t468 = cos(t462);
  t469 = t447 * t445;
  t470 = t425 * t450;
  t471 = -0.8962806183e0 - t469 + t470;
  t472 = t468 * t471;
  t473 = -0.1240711988e-3 + t467 + t472;
  t474 = t461 * t473;
  t475 = -0.2496056670e0 + t362 - t364 + t405 + t419 + t460 + t474;
  t476 = t353 * t475;
  t477 = sin(t352);
  t478 = 0.1290214844e-1 * t359;
  t479 = 0.1080378388e0 * t357;
  t480 = t406 * t404;
  t481 = t366 * t418;
  t482 = t461 * t459;
  t483 = t421 * t473;
  t484 = 0.3942337429e1 - t478 + t479 - t480 + t481 - t482 + t483;
  t485 = t477 * t484;
  t486 = -0.1242588400e-1 + t476 + t485;
  t487 = t351 * t486;
  t488 = cos(t350);
  t489 = t363 * t361;
  t490 = 0.1682729166e-2 * t355;
  t491 = t413 * t411;
  t492 = t408 * t416;
  t493 = t468 * t466;
  t494 = t463 * t471;
  t495 = 0.8672745802e-1 + t489 + t490 + t491 - t492 + t493 - t494;
  t496 = t488 * t495;
  t497 = -t487 - t496;
  t500 = t488 * t486;
  t501 = t351 * t495;
  t502 = t500 - t501;
  L[12] = 0.1758459731e-1 * t5 * t497 + 0.1758459731e-1 * t64 * t502;
  t505 = t477 * t475;
  t506 = t353 * t484;
  t507 = -t505 + t506;
  t508 = t488 * t507;
  t511 = t64 * t351;
  t514 = -t476 - t485;
  L[13] = 0.1758459731e-1 * t5 * t508 + 0.1758459731e-1 * t511 * t507 + 0.1758459731e-1 * t81 * t514;
  t518 = -t489 - t490;
  t520 = t362 - t364;
  t522 = t488 * t353 * t518 - t351 * t520;
  t528 = t351 * t353 * t518 + t488 * t520;
  L[14] = 0.1758459731e-1 * t5 * t522 + 0.1758459731e-1 * t64 * t528 - 0.1758459731e-1 * t81 * t477 * t518;
  t535 = -t478 + t479;
  t537 = -t358 - t360;
  t539 = t353 * t355 * t535 + t477 * t537;
  t543 = t488 * t539 - t351 * t363 * t535;
  t549 = t351 * t539 + t488 * t363 * t535;
  t555 = -t477 * t355 * t535 + t353 * t537;
  L[15] = 0.1758459731e-1 * t5 * t543 + 0.1758459731e-1 * t64 * t549 + 0.1758459731e-1 * t81 * t555;
  t558 = -t480 + t481;
  t560 = -t405 - t419;
  t562 = t353 * t558 + t477 * t560;
  t563 = t488 * t562;
  t570 = -t477 * t558 + t353 * t560;
  L[16] = 0.1758459731e-1 * t5 * t563 + 0.1758459731e-1 * t511 * t562 + 0.1758459731e-1 * t81 * t570;
  t574 = t491 - t492;
  t578 = t353 * t406 * t574 + t477 * t366 * t574;
  t580 = -t412 - t417;
  t582 = t488 * t578 - t351 * t580;
  t587 = t351 * t578 + t488 * t580;
  t594 = -t477 * t406 * t574 + t353 * t366 * t574;
  L[17] = 0.1758459731e-1 * t5 * t582 + 0.1758459731e-1 * t64 * t587 + 0.1758459731e-1 * t81 * t594;
  t597 = -t409 - t410;
  t600 = t398 - t403;
  t602 = t366 * t597 + t406 * t408 * t600;
  t607 = -t406 * t597 + t366 * t408 * t600;
  t609 = t353 * t602 + t477 * t607;
  t613 = t488 * t609 - t351 * t413 * t600;
  t619 = t351 * t609 + t488 * t413 * t600;
  t624 = -t477 * t602 + t353 * t607;
  L[18] = 0.1758459731e-1 * t5 * t613 + 0.1758459731e-1 * t64 * t619 + 0.1758459731e-1 * t81 * t624;
  t628 = -t414 + t415;
  t632 = -t391 - t396;
  t634 = t408 * t399 * t628 + t413 * t632;
  t636 = t366 * t368 * t628 + t406 * t634;
  t641 = -t406 * t368 * t628 + t366 * t634;
  t643 = t353 * t636 + t477 * t641;
  t648 = t413 * t399 * t628 - t408 * t632;
  t650 = t488 * t643 - t351 * t648;
  t655 = t351 * t643 + t488 * t648;
  t660 = -t477 * t636 + t353 * t641;
  L[19] = 0.1758459731e-1 * t5 * t650 + 0.1758459731e-1 * t64 * t655 + 0.1758459731e-1 * t81 * t660;
  t664 = -t400 - t401;
  t666 = t385 - t389;
  t668 = t368 * t370 * t664 - t399 * t666;
  t673 = t399 * t370 * t664 + t368 * t666;
  t677 = t408 * t673 - t413 * t392 * t664;
  t679 = t366 * t668 + t406 * t677;
  t683 = -t406 * t668 + t366 * t677;
  t685 = t353 * t679 + t477 * t683;
  t690 = t413 * t673 + t408 * t392 * t664;
  t692 = t488 * t685 - t351 * t690;
  t697 = t351 * t685 + t488 * t690;
  t702 = -t477 * t679 + t353 * t683;
  L[20] = 0.1758459731e-1 * t5 * t692 + 0.1758459731e-1 * t64 * t697 + 0.1758459731e-1 * t81 * t702;
  t706 = -t393 + t394;
  t708 = -t375 - t383;
  t710 = t370 * t372 * t706 + t392 * t708;
  t714 = t368 * t710 - t399 * t386 * t706;
  t719 = t399 * t710 + t368 * t386 * t706;
  t724 = -t392 * t372 * t706 + t370 * t708;
  t726 = t408 * t719 + t413 * t724;
  t728 = t366 * t714 + t406 * t726;
  t732 = -t406 * t714 + t366 * t726;
  t734 = t353 * t728 + t477 * t732;
  t738 = t413 * t719 - t408 * t724;
  t740 = t488 * t734 - t351 * t738;
  t745 = t351 * t734 + t488 * t738;
  t750 = -t477 * t728 + t353 * t732;
  L[21] = 0.1758459731e-1 * t5 * t740 + 0.1758459731e-1 * t64 * t745 + 0.1758459731e-1 * t81 * t750;
  t755 = 0.1061335296e-1 * t377 + 0.3655710466e-2;
  t758 = t372 * t376 * t755 + 0.5360279276e-3 * t386;
  t762 = t370 * t758 + t392 * t374 * t755;
  t767 = t386 * t376 * t755 - 0.5360279276e-3 * t372;
  t769 = t368 * t762 - t399 * t767;
  t773 = t399 * t762 + t368 * t767;
  t778 = -t392 * t758 + t370 * t374 * t755;
  t780 = t408 * t773 + t413 * t778;
  t782 = t366 * t769 + t406 * t780;
  t786 = -t406 * t769 + t366 * t780;
  t788 = t353 * t782 + t477 * t786;
  t792 = t413 * t773 - t408 * t778;
  t794 = t488 * t788 - t351 * t792;
  t799 = t351 * t788 + t488 * t792;
  t804 = -t477 * t782 + t353 * t786;
  L[22] = 0.1758459731e-1 * t5 * t794 + 0.1758459731e-1 * t64 * t799 + 0.1758459731e-1 * t81 * t804;
  t807 = -t482 + t483;
  t809 = -t460 - t474;
  t811 = t353 * t807 + t477 * t809;
  t812 = t488 * t811;
  t819 = -t477 * t807 + t353 * t809;
  L[23] = 0.1758459731e-1 * t5 * t812 + 0.1758459731e-1 * t511 * t811 + 0.1758459731e-1 * t81 * t819;
  t823 = t493 - t494;
  t827 = t353 * t461 * t823 + t477 * t421 * t823;
  t829 = -t467 - t472;
  t831 = t488 * t827 - t351 * t829;
  t836 = t351 * t827 + t488 * t829;
  t843 = -t477 * t461 * t823 + t353 * t421 * t823;
  L[24] = 0.1758459731e-1 * t5 * t831 + 0.1758459731e-1 * t64 * t836 + 0.1758459731e-1 * t81 * t843;
  t846 = -t464 - t465;
  t849 = t453 - t458;
  t851 = t421 * t846 + t461 * t463 * t849;
  t856 = -t461 * t846 + t421 * t463 * t849;
  t858 = t353 * t851 + t477 * t856;
  t862 = t488 * t858 - t351 * t468 * t849;
  t868 = t351 * t858 + t488 * t468 * t849;
  t873 = -t477 * t851 + t353 * t856;
  L[25] = 0.1758459731e-1 * t5 * t862 + 0.1758459731e-1 * t64 * t868 + 0.1758459731e-1 * t81 * t873;
  t877 = -t469 + t470;
  t881 = -t446 - t451;
  t883 = t463 * t454 * t877 + t468 * t881;
  t885 = t421 * t423 * t877 + t461 * t883;
  t890 = -t461 * t423 * t877 + t421 * t883;
  t892 = t353 * t885 + t477 * t890;
  t897 = t468 * t454 * t877 - t463 * t881;
  t899 = t488 * t892 - t351 * t897;
  t904 = t351 * t892 + t488 * t897;
  t909 = -t477 * t885 + t353 * t890;
  L[26] = 0.1758459731e-1 * t5 * t899 + 0.1758459731e-1 * t64 * t904 + 0.1758459731e-1 * t81 * t909;
  t913 = -t455 - t456;
  t915 = t440 - t444;
  t917 = t423 * t425 * t913 - t454 * t915;
  t922 = t454 * t425 * t913 + t423 * t915;
  t926 = t463 * t922 - t468 * t447 * t913;
  t928 = t421 * t917 + t461 * t926;
  t932 = -t461 * t917 + t421 * t926;
  t934 = t353 * t928 + t477 * t932;
  t939 = t468 * t922 + t463 * t447 * t913;
  t941 = t488 * t934 - t351 * t939;
  t946 = t351 * t934 + t488 * t939;
  t951 = -t477 * t928 + t353 * t932;
  L[27] = 0.1758459731e-1 * t5 * t941 + 0.1758459731e-1 * t64 * t946 + 0.1758459731e-1 * t81 * t951;
  t955 = -t448 + t449;
  t957 = -t430 - t438;
  t959 = t425 * t427 * t955 + t447 * t957;
  t963 = t423 * t959 - t454 * t441 * t955;
  t968 = t454 * t959 + t423 * t441 * t955;
  t973 = -t447 * t427 * t955 + t425 * t957;
  t975 = t463 * t968 + t468 * t973;
  t977 = t421 * t963 + t461 * t975;
  t981 = -t461 * t963 + t421 * t975;
  t983 = t353 * t977 + t477 * t981;
  t987 = t468 * t968 - t463 * t973;
  t989 = t488 * t983 - t351 * t987;
  t994 = t351 * t983 + t488 * t987;
  t999 = -t477 * t977 + t353 * t981;
  L[28] = 0.1758459731e-1 * t5 * t989 + 0.1758459731e-1 * t64 * t994 + 0.1758459731e-1 * t81 * t999;
  t1004 = 0.1061335296e-1 * t432 + 0.3655710466e-2;
  t1007 = t427 * t431 * t1004 - 0.5360279276e-3 * t441;
  t1011 = t425 * t1007 + t447 * t429 * t1004;
  t1016 = t441 * t431 * t1004 + 0.5360279276e-3 * t427;
  t1018 = t423 * t1011 - t454 * t1016;
  t1022 = t454 * t1011 + t423 * t1016;
  t1027 = -t447 * t1007 + t425 * t429 * t1004;
  t1029 = t463 * t1022 + t468 * t1027;
  t1031 = t421 * t1018 + t461 * t1029;
  t1035 = -t461 * t1018 + t421 * t1029;
  t1037 = t353 * t1031 + t477 * t1035;
  t1041 = t468 * t1022 - t463 * t1027;
  t1043 = t488 * t1037 - t351 * t1041;
  t1048 = t351 * t1037 + t488 * t1041;
  t1053 = -t477 * t1031 + t353 * t1035;
  L[29] = 0.1758459731e-1 * t5 * t1043 + 0.1758459731e-1 * t64 * t1048 + 0.1758459731e-1 * t81 * t1053;
  L[30] = 0.9999999997e0;
  L[31] = 0.0e0;
  L[32] = 0.0e0;
  t1056 = 0.18035e-5 + t38 + t52 + t216 + t230 + t487 + t496;
  t1060 = 0.1245067264e2 + t70 + t71 + t239 + t240 - t505 + t506;
  L[33] = 0.1758459731e-1 * t81 * t1056 - 0.1758459731e-1 * t64 * t1060;
  t1063 = 0.6010581150e0 + t65 - t66 + t234 - t235 + t500 - t501;
  t1066 = t59 * t1056;
  t1069 = t62 * t1060;
  L[34] = -0.1758459731e-1 * t57 * t1063 + 0.1758459731e-1 * t5 * t1066 + 0.1758459731e-1 * t5 * t1069;
  t1072 = t61 * t4;
  t1075 = t61 * t56;
  t1078 = -t1075 * t59 - t2 * t62;
  t1083 = -t1075 * t62 + t2 * t59;
  L[35] = -0.1758459731e-1 * t1072 * t1063 + 0.1758459731e-1 * t1078 * t1056 + 0.1758459731e-1 * t1083 * t1060;
  t1088 = -t1078;
  L[36] = 0.1758459731e-1 * t1072 * t53 + 0.1758459731e-1 * t1088 * t67;
  t1096 = -t1083;
  L[37] = -0.1758459731e-1 * t1072 * t73 + 0.1758459731e-1 * t1088 * t39 * t72 + 0.1758459731e-1 * t1096 * t82;
  t1103 = t1096 * t41;
  L[38] = 0.1758459731e-1 * t1072 * t90 + 0.1758459731e-1 * t1088 * t96 + 0.1758459731e-1 * t1103 * t88;
  L[39] = 0.1758459731e-1 * t1072 * t112 + 0.1758459731e-1 * t1088 * t117 + 0.1758459731e-1 * t1103 * t110;
  L[40] = 0.1758459731e-1 * t1072 * t138 + 0.1758459731e-1 * t1088 * t143 + 0.1758459731e-1 * t1103 * t136;
  L[41] = 0.1758459731e-1 * t1072 * t171 + 0.1758459731e-1 * t1088 * t176 + 0.1758459731e-1 * t1096 * t181;
  L[42] = 0.1758459731e-1 * t1072 * t231 + 0.1758459731e-1 * t1088 * t236;
  L[43] = -0.1758459731e-1 * t1072 * t242 + 0.1758459731e-1 * t1088 * t217 * t241 + 0.1758459731e-1 * t1096 * t248;
  t1139 = t1096 * t219;
  L[44] = 0.1758459731e-1 * t1072 * t256 + 0.1758459731e-1 * t1088 * t262 + 0.1758459731e-1 * t1139 * t254;
  L[45] = 0.1758459731e-1 * t1072 * t278 + 0.1758459731e-1 * t1088 * t283 + 0.1758459731e-1 * t1139 * t276;
  L[46] = 0.1758459731e-1 * t1072 * t304 + 0.1758459731e-1 * t1088 * t309 + 0.1758459731e-1 * t1139 * t302;
  L[47] = 0.1758459731e-1 * t1072 * t337 + 0.1758459731e-1 * t1088 * t342 + 0.1758459731e-1 * t1096 * t347;
  L[48] = 0.1758459731e-1 * t1072 * t497 + 0.1758459731e-1 * t1088 * t502;
  t1166 = t1088 * t351;
  L[49] = 0.1758459731e-1 * t1072 * t508 + 0.1758459731e-1 * t1166 * t507 + 0.1758459731e-1 * t1096 * t514;
  L[50] = 0.1758459731e-1 * t1072 * t522 + 0.1758459731e-1 * t1088 * t528 - 0.1758459731e-1 * t1096 * t477 * t518;
  L[51] = 0.1758459731e-1 * t1072 * t543 + 0.1758459731e-1 * t1088 * t549 + 0.1758459731e-1 * t1096 * t555;
  L[52] = 0.1758459731e-1 * t1072 * t563 + 0.1758459731e-1 * t1166 * t562 + 0.1758459731e-1 * t1096 * t570;
  L[53] = 0.1758459731e-1 * t1072 * t582 + 0.1758459731e-1 * t1088 * t587 + 0.1758459731e-1 * t1096 * t594;
  L[54] = 0.1758459731e-1 * t1072 * t613 + 0.1758459731e-1 * t1088 * t619 + 0.1758459731e-1 * t1096 * t624;
  L[55] = 0.1758459731e-1 * t1072 * t650 + 0.1758459731e-1 * t1088 * t655 + 0.1758459731e-1 * t1096 * t660;
  L[56] = 0.1758459731e-1 * t1072 * t692 + 0.1758459731e-1 * t1088 * t697 + 0.1758459731e-1 * t1096 * t702;
  L[57] = 0.1758459731e-1 * t1072 * t740 + 0.1758459731e-1 * t1088 * t745 + 0.1758459731e-1 * t1096 * t750;
  L[58] = 0.1758459731e-1 * t1072 * t794 + 0.1758459731e-1 * t1088 * t799 + 0.1758459731e-1 * t1096 * t804;
  L[59] = 0.1758459731e-1 * t1072 * t812 + 0.1758459731e-1 * t1166 * t811 + 0.1758459731e-1 * t1096 * t819;
  L[60] = 0.1758459731e-1 * t1072 * t831 + 0.1758459731e-1 * t1088 * t836 + 0.1758459731e-1 * t1096 * t843;
  L[61] = 0.1758459731e-1 * t1072 * t862 + 0.1758459731e-1 * t1088 * t868 + 0.1758459731e-1 * t1096 * t873;
  L[62] = 0.1758459731e-1 * t1072 * t899 + 0.1758459731e-1 * t1088 * t904 + 0.1758459731e-1 * t1096 * t909;
  L[63] = 0.1758459731e-1 * t1072 * t941 + 0.1758459731e-1 * t1088 * t946 + 0.1758459731e-1 * t1096 * t951;
  L[64] = 0.1758459731e-1 * t1072 * t989 + 0.1758459731e-1 * t1088 * t994 + 0.1758459731e-1 * t1096 * t999;
  L[65] = 0.1758459731e-1 * t1072 * t1043 + 0.1758459731e-1 * t1088 * t1048 + 0.1758459731e-1 * t1096 * t1053;
  L[66] = 0.0e0;
  L[67] = 0.9999999997e0;
  L[68] = 0.0e0;
  L[69] = 0.1758459731e-1 * t1096 * t1056 + 0.1758459731e-1 * t1078 * t1060;
  L[70] = -0.1758459731e-1 * t1075 * t1063 + 0.1758459731e-1 * t1072 * t1066 + 0.1758459731e-1 * t1072 * t1069;
  L[71] = 0.1758459731e-1 * t5 * t1063 + 0.1758459731e-1 * t64 * t1056 + 0.1758459731e-1 * t81 * t1060;
  t1286 = t4 * t59;
  L[72] = -0.1758459731e-1 * t56 * t53 + 0.1758459731e-1 * t1286 * t67;
  t1295 = t4 * t62;
  L[73] = 0.1758459731e-1 * t56 * t7 * t72 + 0.1758459731e-1 * t1286 * t39 * t72 + 0.1758459731e-1 * t1295 * t82;
  L[74] = -0.1758459731e-1 * t56 * t90 + 0.1758459731e-1 * t1286 * t96 + 0.1758459731e-1 * t1295 * t41 * t88;
  L[75] = -0.1758459731e-1 * t56 * t112 + 0.1758459731e-1 * t1286 * t117 + 0.1758459731e-1 * t1295 * t41 * t110;
  L[76] = -0.1758459731e-1 * t56 * t138 + 0.1758459731e-1 * t1286 * t143 + 0.1758459731e-1 * t1295 * t41 * t136;
  L[77] = -0.1758459731e-1 * t56 * t171 + 0.1758459731e-1 * t1286 * t176 + 0.1758459731e-1 * t1295 * t181;
  L[78] = -0.1758459731e-1 * t56 * t231 + 0.1758459731e-1 * t1286 * t236;
  L[79] = 0.1758459731e-1 * t56 * t185 * t241 + 0.1758459731e-1 * t1286 * t217 * t241 + 0.1758459731e-1 * t1295 * t248;
  L[80] = -0.1758459731e-1 * t56 * t256 + 0.1758459731e-1 * t1286 * t262 + 0.1758459731e-1 * t1295 * t219 * t254;
  L[81] = -0.1758459731e-1 * t56 * t278 + 0.1758459731e-1 * t1286 * t283 + 0.1758459731e-1 * t1295 * t219 * t276;
  L[82] = -0.1758459731e-1 * t56 * t304 + 0.1758459731e-1 * t1286 * t309 + 0.1758459731e-1 * t1295 * t219 * t302;
  L[83] = -0.1758459731e-1 * t56 * t337 + 0.1758459731e-1 * t1286 * t342 + 0.1758459731e-1 * t1295 * t347;
  L[84] = -0.1758459731e-1 * t56 * t497 + 0.1758459731e-1 * t1286 * t502;
  t1368 = t56 * t488;
  L[85] = -0.1758459731e-1 * t1368 * t507 + 0.1758459731e-1 * t1286 * t351 * t507 + 0.1758459731e-1 * t1295 * t514;
  L[86] = -0.1758459731e-1 * t56 * t522 + 0.1758459731e-1 * t1286 * t528 - 0.1758459731e-1 * t1295 * t477 * t518;
  L[87] = -0.1758459731e-1 * t56 * t543 + 0.1758459731e-1 * t1286 * t549 + 0.1758459731e-1 * t1295 * t555;
  L[88] = -0.1758459731e-1 * t1368 * t562 + 0.1758459731e-1 * t1286 * t351 * t562 + 0.1758459731e-1 * t1295 * t570;
  L[89] = -0.1758459731e-1 * t56 * t582 + 0.1758459731e-1 * t1286 * t587 + 0.1758459731e-1 * t1295 * t594;
  L[90] = -0.1758459731e-1 * t56 * t613 + 0.1758459731e-1 * t1286 * t619 + 0.1758459731e-1 * t1295 * t624;
  L[91] = -0.1758459731e-1 * t56 * t650 + 0.1758459731e-1 * t1286 * t655 + 0.1758459731e-1 * t1295 * t660;
  L[92] = -0.1758459731e-1 * t56 * t692 + 0.1758459731e-1 * t1286 * t697 + 0.1758459731e-1 * t1295 * t702;
  L[93] = -0.1758459731e-1 * t56 * t740 + 0.1758459731e-1 * t1286 * t745 + 0.1758459731e-1 * t1295 * t750;
  L[94] = -0.1758459731e-1 * t56 * t794 + 0.1758459731e-1 * t1286 * t799 + 0.1758459731e-1 * t1295 * t804;
  L[95] = -0.1758459731e-1 * t1368 * t811 + 0.1758459731e-1 * t1286 * t351 * t811 + 0.1758459731e-1 * t1295 * t819;
  L[96] = -0.1758459731e-1 * t56 * t831 + 0.1758459731e-1 * t1286 * t836 + 0.1758459731e-1 * t1295 * t843;
  L[97] = -0.1758459731e-1 * t56 * t862 + 0.1758459731e-1 * t1286 * t868 + 0.1758459731e-1 * t1295 * t873;
  L[98] = -0.1758459731e-1 * t56 * t899 + 0.1758459731e-1 * t1286 * t904 + 0.1758459731e-1 * t1295 * t909;
  L[99] = -0.1758459731e-1 * t56 * t941 + 0.1758459731e-1 * t1286 * t946 + 0.1758459731e-1 * t1295 * t951;
  L[100] = -0.1758459731e-1 * t56 * t989 + 0.1758459731e-1 * t1286 * t994 + 0.1758459731e-1 * t1295 * t999;
  L[101] = -0.1758459731e-1 * t56 * t1043 + 0.1758459731e-1 * t1286 * t1048 + 0.1758459731e-1 * t1295 * t1053;
  L[102] = 0.0e0;
  L[103] = 0.0e0;
  L[104] = 0.9999999997e0;
  L[105] = 0.1758459731e-1 * t1295 * t1056 - 0.1758459731e-1 * t1286 * t1060;
  L[106] = -0.1758459731e-1 * t4 * t1063 - 0.1758459731e-1 * t56 * t59 * t1056 - 0.1758459731e-1 * t56 * t62 * t1060;
  L[107] = 0.0e0;

  if ((MAL_MATRIX_NB_COLS(m_jcom)!=3) ||
      (MAL_MATRIX_NB_COLS(m_jcom)!=numberDof()))
    MAL_MATRIX_RESIZE(m_jcom,3,numberDof());

  //jrlDelegate::dynamicRobot::getJacobianCenterOfMass(*waist(),m_jcom);
  unsigned int rightHand = m_isKineoOrder ? (6+16+7) : (6+16+7+7);

  for(int i=0;i<3;i++)
    {
      // root(6)
      for(int j=0;j<6;j++)
	m_jcom(i,j) = L[i*36+j+30];

      // legs(12), waist(2), neck(2) and right_arm(7)
      for(int j=0;j<16+7;j++)
	m_jcom(i,j+6) = L[i*36+j];

      // left_arm(7)
      for(int j=0;j<7;j++)
	m_jcom(i,leftArm+j) = L[i*36+16+7+j];

      if((MAL_MATRIX_NB_COLS(m_jcom) >= rightHand+4) && (MAL_MATRIX_NB_COLS(m_jcom) >= LEFT_HAND+4)) {
	// hands(5,5)
	for(unsigned int j=0;j<5;j++){
	  m_jcom(i,rightHand+j) = 0.0;
	  m_jcom(i,LEFT_HAND+j) = 0.0;
	}
      }
    }
}


bool Chrp2OptHumanoidDynamicRobot::getJacobianCenterOfMass(const CjrlJoint& inStartJoint,
        matrixNxP& outjacobian,
        unsigned int offset,
        bool inIncludeStartFreeFlyer)
{
    if ((&inStartJoint != rootJoint()) || (offset !=0) || (inIncludeStartFreeFlyer != true))
        return jrlDelegate::humanoidDynamicRobot::getJacobianCenterOfMass(inStartJoint,outjacobian,offset,inIncludeStartFreeFlyer);
    else
    {
        if ((outjacobian.size1()!=3) || (outjacobian.size2()!=numberDof()))
        {
            std::cout << "Chrp2OptHumanoidDynamicRobot::getJacobianCenterOfMass -Error: bad matrix size" << std::endl;
            return false;
        }
        computeJacobianCenterOfMass();
        boost::numeric::ublas::noalias(outjacobian) = m_jcom;
        return true;
    }
}
