/*
 *  Copyright CNRS-AIST
 *
 *  Authors:  Olivier Stasse
 */
#include <iostream>

#include "TestingSuite.h"

using namespace std;

// Test of the getSpecializedInverseKinematics 
void hrp2Opt::TestingSuite::TestgetSpecializedInverseKinematics(Chrp2OptHumanoidDynamicRobot *aHDR)
{
  CjrlJoint *waist = aHDR->waist();
  CjrlJoint *lankle = aHDR->leftAnkle();
  
  matrix4d waistpose;
  matrix4d leftanklepose;
  MAL_S4x4_MATRIX_SET_IDENTITY(waistpose);
  MAL_S4x4_MATRIX_SET_IDENTITY(leftanklepose);
  
  MAL_S4x4_MATRIX_ACCESS_I_J(leftanklepose,1,3)=0.095;
  MAL_S4x4_MATRIX_ACCESS_I_J(leftanklepose,2,3)=-0.54;
  
  vectorN legsq;
  MAL_VECTOR_FILL(legsq,0.0);
  cout << "Specialized Inverse Kinematics q=(" << legsq << ")" <<endl;
  aHDR->getSpecializedInverseKinematics(*waist,*lankle,waistpose,leftanklepose,legsq);
  cout << legsq*180/M_PI << endl;
}

