/*
 *  Copyright CNRS-AIST
 *
 *  Authors:  Olivier Stasse
 */

/*! Systems includes */
#include <iostream>
#include <fstream>

/*! Framework related includes */
#include "TestingSuite.h"

using namespace dynamicsJRLJapan;
using namespace std;
void hrp2Opt::TestingSuite::TestInertiaMatrix(Chrp2OptHumanoidDynamicRobot *aHDR)
{
  matrixNxP OptInertiaMatrix;
  aHDR->computeInertiaMatrix();
  OptInertiaMatrix = aHDR->inertiaMatrix();
 
  cout << "InertiaMatrix("
       << MAL_MATRIX_NB_ROWS(OptInertiaMatrix)<< "," 
       << MAL_MATRIX_NB_COLS(OptInertiaMatrix)<< ")"<< endl;

  cout << OptInertiaMatrix << endl;
  
  ofstream aof;
  aof.open("InertiaMatrix.dat");
  for(unsigned int i=0;i<MAL_MATRIX_NB_ROWS(OptInertiaMatrix);i++)
    {
      for(unsigned int j=0;j<MAL_MATRIX_NB_COLS(OptInertiaMatrix);j++)
       {
         aof << OptInertiaMatrix(i,j) << " ";
       }
      aof << endl;
    }
  aof.close();


  aHDR->humanoidDynamicRobot::computeInertiaMatrix();
  matrixNxP InertiaMatrix = aHDR->humanoidDynamicRobot::inertiaMatrix();
  cout << "Around here" << endl;

  aof.open("InertiaMatrixDB.dat");
  for(unsigned int i=0;i<MAL_MATRIX_NB_ROWS(InertiaMatrix);i++)
    {
      for(unsigned int j=0;j<MAL_MATRIX_NB_COLS(InertiaMatrix);j++)
       {
         aof << InertiaMatrix(i,j) << " ";
       }
      aof << endl;
    }
  aof.close();

  aof.open("CompareIM.dat");
  aof.precision(5);
  aof.setf(ios::fixed, ios::floatfield) ;
  aof.setf(ios::showpos);
  unsigned int startcol = 6, endcol=36;
  unsigned int startrow = 0, endrow=6;

  for(unsigned int i=startrow;i<endrow;i++)
    {
      for(unsigned int j=startcol;j<endcol;j++)
       {
         aof << OptInertiaMatrix(i,j) << " ";
       }
      aof << endl;
    }
  aof << "***************************************" << endl;
  for(unsigned int i=startrow;i<endrow;i++)
    {
      for(unsigned int j=startcol;j<endcol;j++)
       {
         aof << InertiaMatrix(i,j) << " ";
       }
      aof << endl;
    }
  aof.close();

  double maxerr=0.0,lerr=0.0,accumerr=0.0;
  for( unsigned int i=0;i<MAL_MATRIX_NB_ROWS(OptInertiaMatrix);i++)
    {
       for( unsigned int j=0;j<MAL_MATRIX_NB_ROWS(OptInertiaMatrix);j++)
	{
	  lerr = fabs(OptInertiaMatrix(i,j)- InertiaMatrix(i,j));
	  if (lerr > maxerr)
	    maxerr=lerr;
	  accumerr += lerr;
	}
    }
  cout << "Total Maxerr: " << maxerr << endl;
  cout << "Total Accumulated Error: " << accumerr << endl;

  maxerr=0.0; lerr=0.0; accumerr= 0.0;
  for( unsigned int i=startrow;i<endrow;i++)
    {
       for( unsigned int j=startcol;j<endcol;j++)
	{
	  lerr = fabs(OptInertiaMatrix(i,j)- InertiaMatrix(i,j));
	  if (lerr > maxerr)
	    maxerr=lerr;
	  accumerr += lerr;
	}
    }
  cout << "Partial Maxerr: " << maxerr << endl;
  cout << "Partial Accumulated Error: " << accumerr << endl;
  cout << "****************************" << endl;
}
