/*
 *  Copyright CNRS-AIST
 *
 *  Authors:  Olivier Stasse
 */

/*! Systems includes */
#include <iostream>
#include <fstream>

/*! Framework related includes */
#include "TestingSuite.h"

using namespace dynamicsJRLJapan;
using namespace std;

void
hrp2Opt::TestingSuite::TestJacobianOfCoM(Chrp2OptHumanoidDynamicRobot *aHDR)
{
 CjrlJoint *aJoint;

  /* Center of mass Jacobian */ 
  aJoint = aHDR->waist();
  cout << "****************************" << endl;
  matrixNxP OptJcom;
  MAL_MATRIX_RESIZE(OptJcom,3,aHDR->numberDof());

  aHDR->getJacobianCenterOfMass(*aHDR->rootJoint(),OptJcom);
  cout << "Value of the CoM's Jacobian:" << endl;
  DisplayMatrix(OptJcom);

  matrixNxP NOptJcom;
  MAL_MATRIX_RESIZE(NOptJcom,3,aHDR->numberDof());
  aHDR->humanoidDynamicRobot::getJacobianCenterOfMass(*aHDR->rootJoint(),
						      NOptJcom);
  cout << "****************************" << endl;
  cout << "Value of the CoM's Jacobian:" << endl;
  DisplayMatrix(NOptJcom);
  cout << "****************************" << endl;

  double maxerr=0.0,lerr=0.0,accumerr=0.0;
  for( unsigned int i=0;i<MAL_MATRIX_NB_ROWS(NOptJcom);i++)
    {
      for( unsigned int j=0;j<MAL_MATRIX_NB_ROWS(NOptJcom);j++)
	{
	  lerr = fabs(OptJcom(i,j)- NOptJcom(i,j));
	  if (lerr > maxerr)
	    maxerr=lerr;
	  accumerr += lerr;
	}
    }

  cout << "Maxerr: " << maxerr << endl;
  cout << "Accumulated Error: " << accumerr << endl;
  cout << "****************************" << endl;
}
