/*
 *  Copyright CNRS-AIST
 *
 *  Authors: Fumio Kanehiro, Florent Lamiraux, Olivier Stasse
 */

#include <iostream>
#include "hrp2-dynamics/hrp2OptHumanoidDynamicRobot.h"

#include <Debug.h>

using namespace dynamicsJRLJapan;
void Chrp2OptHumanoidDynamicRobot::computeInertiaMatrix()
{
  double M[1296];
  double q[36];

  // Remap correctly the current configuration
  // and the one for the CoM Jacobian.
  const vectorN& cfg = currentConfiguration();

  // Waist(6) Configuration
  for(int i=0;i<6;i++)
    q[30+i] = cfg[i];

  // Joint configurations(legs(12), waist(2), neck(2) and right_arm(7)).
  for(int i=0;i<23;i++) q[i] = cfg[i+6];

  unsigned int leftArm = m_isKineoOrder ? (6+16+7+5) : (6+16+7);
  // Joint configurations(left arm(7)).
  for(int i=0;i<7;i++) q[i+23] = cfg[leftArm+i];
  double C0 = cos(q[0]);
  double S0 = sin(q[0]);
  double C1 = cos(q[1]);
  double S1 = sin(q[1]);
  double C2 = cos(q[2]);
  double S2 = sin(q[2]);
  double C3 = cos(q[3]);
  double S3 = sin(q[3]);
  double C4 = cos(q[4]);
  double S4 = sin(q[4]);
  double C5 = cos(q[5]);
  double S5 = sin(q[5]);
  double C6 = cos(q[6]);
  double S6 = sin(q[6]);
  double C7 = cos(q[7]);
  double S7 = sin(q[7]);
  double C8 = cos(q[8]);
  double S8 = sin(q[8]);
  double C9 = cos(q[9]);
  double S9 = sin(q[9]);
  double C10 = cos(q[10]);
  double S10 = sin(q[10]);
  double C11 = cos(q[11]);
  double S11 = sin(q[11]);
  double C12 = cos(q[12]);
  double S12 = sin(q[12]);
  double C13 = cos(q[13]);
  double S13 = sin(q[13]);
  double C14 = cos(q[14]);
  double S14 = sin(q[14]);
  double C15 = cos(q[15]);
  double S15 = sin(q[15]);
  double C16 = cos(q[16]);
  double S16 = sin(q[16]);
  double C17 = cos(q[17]);
  double S17 = sin(q[17]);
  double C18 = cos(q[18]);
  double S18 = sin(q[18]);
  double C19 = cos(q[19]);
  double S19 = sin(q[19]);
  double C20 = cos(q[20]);
  double S20 = sin(q[20]);
  double C21 = cos(q[21]);
  double S21 = sin(q[21]);
  double C22 = cos(q[22]);
  double S22 = sin(q[22]);
  double C23 = cos(q[23]);
  double S23 = sin(q[23]);
  double C24 = cos(q[24]);
  double S24 = sin(q[24]);
  double C25 = cos(q[25]);
  double S25 = sin(q[25]);
  double C26 = cos(q[26]);
  double S26 = sin(q[26]);
  double C27 = cos(q[27]);
  double S27 = sin(q[27]);
  double C28 = cos(q[28]);
  double S28 = sin(q[28]);
  double C29 = cos(q[29]);
  double S29 = sin(q[29]);
  double C30 = cos(q[30]);
  double S30 = sin(q[30]);
  double C31 = cos(q[31]);
  double S31 = sin(q[31]);
  double C32 = cos(q[32]);
  double S32 = sin(q[32]);
  double C33 = cos(q[33]);
  double S33 = sin(q[33]);
  double C34 = cos(q[34]);
  double S34 = sin(q[34]);
  double C35 = cos(q[35]);
  double S35 = sin(q[35]);
  double tmp1 = 0.3998117160e-8 + 0.7684553059e-2 * cos(q[5] + 0.314159e1) - 0.1071449130e0 * sin(q[5] + 0.314159e1);
  double tmp2 = -0.1088454646e-2 + 0.2822693951e-7 * cos(q[5] + 0.314159e1) - 0.3935652412e-6 * sin(q[5] + 0.314159e1);
  double tmp3 = -0.7684553059e-2 * sin(q[5] + 0.314159e1) - 0.1071449130e0 * cos(q[5] + 0.314159e1);
  double tmp4 = 0.1071449130e0 * sin(q[5] + 0.314159e1) - 0.7684553059e-2 * cos(q[5] + 0.314159e1);
  double tmp5 = -0.3935652412e-6 * cos(q[5] + 0.314159e1) - 0.2822693951e-7 * sin(q[5] + 0.314159e1);
  double tmp6 = -0.7684553059e-2 * sin(q[5] + 0.314159e1) - 0.1071449130e0 * cos(q[5] + 0.314159e1);
  double tmp7 = -0.6878360690e-3 * sin(q[5] + 0.314159e1) + 0.7151917501e-2 * cos(q[5] + 0.314159e1);
  double tmp8 = 0.7217854202e-3 + 0.2526562959e-8 * cos(q[5] + 0.314159e1) + 0.2627045986e-7 * sin(q[5] + 0.314159e1);
  double tmp9 = -0.2651265889e-8 + 0.6878360690e-3 * cos(q[5] + 0.314159e1) + 0.7151917501e-2 * sin(q[5] + 0.314159e1);
  double tmp10 = 0.1388210664e-1 * sin(q[5] + 0.314159e1) - 0.6878360690e-3 * cos(q[5] + 0.314159e1);
  double tmp11 = 0.9472599670e-4 - 0.5099182495e-7 * cos(q[5] + 0.314159e1) - 0.2526562959e-8 * sin(q[5] + 0.314159e1);
  double tmp12 = 0.9472599670e-4 * sin(q[5] + 0.314159e1) + 0.7217854202e-3 * cos(q[5] + 0.314159e1);
  double tmp13 = -0.3479480145e-9 - 0.1388210664e-1 * cos(q[5] + 0.314159e1) - 0.6878360690e-3 * sin(q[5] + 0.314159e1);
  double tmp14 = -0.4055978148e-7 - 0.9472599670e-4 * cos(q[5] + 0.314159e1) + 0.7217854202e-3 * sin(q[5] + 0.314159e1);
  double tmp15 = 0.1104206826e-1 - 0.3479480145e-9 * cos(q[5] + 0.314159e1) + 0.2651265889e-8 * sin(q[5] + 0.314159e1);
  double tmp16 = -0.8714552875e-3 + tmp1;
  double tmp17 = 0.5407055112e-2 + tmp2;
  double tmp18 = 0.158076750e-2 + tmp3;
  double tmp19 = 0.9062724922e-3 + sin(q[5] + 0.314159e1) * tmp10 + cos(q[5] + 0.314159e1) * tmp7;
  double tmp20 = -0.2661425926e-4 + sin(q[5] + 0.314159e1) * tmp11 + cos(q[5] + 0.314159e1) * tmp8;
  double tmp21 = 0.5697178885e-5 + sin(q[5] + 0.314159e1) * tmp13 + cos(q[5] + 0.314159e1) * tmp9;
  double tmp22 = -0.2661425926e-4 + 0.1000000000e1 * tmp12 - 0.3673205103e-5 * cos(q[5] + 0.314159e1) * tmp10 + 0.3673205103e-5 * sin(q[5] + 0.314159e1) * tmp7;
  double tmp23 = 0.2827139544e-3 + 0.1000000000e1 * tmp15 - 0.3673205103e-5 * cos(q[5] + 0.314159e1) * tmp11 + 0.3673205103e-5 * sin(q[5] + 0.314159e1) * tmp8;
  double tmp24 = 0.5697178885e-5 - 0.3673205103e-5 * tmp12 - 0.1000000000e1 * cos(q[5] + 0.314159e1) * tmp10 + 0.1000000000e1 * sin(q[5] + 0.314159e1) * tmp7;
  double tmp25 = 0.1947658537e-5 + 0.1000000000e1 * tmp14 - 0.3673205103e-5 * cos(q[5] + 0.314159e1) * tmp13 + 0.3673205103e-5 * sin(q[5] + 0.314159e1) * tmp9;
  double tmp26 = 0.8382031294e-3 - 0.3673205103e-5 * tmp14 - 0.1000000000e1 * cos(q[5] + 0.314159e1) * tmp13 + 0.1000000000e1 * sin(q[5] + 0.314159e1) * tmp9;
  double tmp27 = 0.1947658537e-5 - 0.3673205103e-5 * tmp15 - 0.1000000000e1 * cos(q[5] + 0.314159e1) * tmp11 + 0.1000000000e1 * sin(q[5] + 0.314159e1) * tmp8;
  double tmp28 = 0.9472599670e-4 * sin(q[5] + 0.314159e1) + 0.7217854202e-3 * cos(q[5] + 0.314159e1);
  double tmp29 = 0.1104206826e-1 - 0.3479480145e-9 * cos(q[5] + 0.314159e1) + 0.2651265889e-8 * sin(q[5] + 0.314159e1);
  double tmp30 = -0.4055978148e-7 - 0.9472599670e-4 * cos(q[5] + 0.314159e1) + 0.7217854202e-3 * sin(q[5] + 0.314159e1);
  double tmp31 = C4 * tmp17 - S4 * tmp18;
  double tmp32 = S4 * tmp17 + C4 * tmp18;
  double tmp33 = S4 * tmp5 + C4 * tmp4;
  double tmp34 = C4 * tmp5 - S4 * tmp4;
  double tmp35 = C4 * tmp17 - S4 * tmp18;
  double tmp36 = -S4 * tmp17 - C4 * tmp18;
  double tmp37 = 0.35e-1 * tmp16;
  double tmp38 = -0.35e-1 * tmp32;
  double tmp39 = 0.3e0 * tmp31;
  double tmp40 = -0.3e0 * tmp32 + 0.35e-1 * tmp16;
  double tmp41 = 0.3e0 * tmp16;
  double tmp42 = -0.35e-1 * tmp31;
  double tmp43 = -0.3e0 * tmp32;
  double tmp44 = tmp20 * S4 + tmp19 * C4;
  double tmp45 = tmp20 * C4 - tmp19 * S4;
  double tmp46 = tmp23 * S4 + tmp22 * C4;
  double tmp47 = tmp23 * C4 - tmp22 * S4;
  double tmp48 = tmp27 * S4 + tmp24 * C4;
  double tmp49 = tmp27 * C4 - tmp24 * S4;
  double tmp50 = -0.1814540590e0 + tmp16;
  double tmp51 = 0.3143583904e-1 + tmp31;
  double tmp52 = 0.9296091318e0 + tmp32;
  double tmp53 = 0.1379028676e-1 + S4 * tmp46 + C4 * tmp44 - 2 * tmp37;
  double tmp54 = -0.2102655764e-2 + S4 * tmp47 + C4 * tmp45 - tmp39;
  double tmp55 = 0.3882398272e-1 + S4 * tmp25 + C4 * tmp21 - tmp38 - tmp41;
  double tmp56 = -0.2102645764e-2 + C4 * tmp46 - S4 * tmp44 - tmp39;
  double tmp57 = 0.2707940501e0 + C4 * tmp47 - S4 * tmp45 - 2 * tmp40;
  double tmp58 = 0.3882399272e-1 + tmp48 - tmp41 - tmp38;
  double tmp59 = 0.1726720628e-2 + C4 * tmp25 - S4 * tmp21 - tmp42;
  double tmp60 = 0.2628683165e0 + tmp26 - 2 * tmp43;
  double tmp61 = 0.1726720628e-2 + tmp49 - tmp42;
  double tmp62 = tmp26 - 0.3e0 * tmp36;
  double tmp63 = S4 * tmp29 + C4 * tmp28 - 0.35e-1 * tmp34;
  double tmp64 = C4 * tmp29 - S4 * tmp28 + 0.3e0 * tmp6 + 0.35e-1 * tmp33;
  double tmp65 = S4 * tmp25 + C4 * tmp21 - 0.35e-1 * tmp36;
  double tmp66 = tmp30 - 0.3e0 * tmp34;
  double tmp67 = C4 * tmp25 - S4 * tmp21 + 0.35e-1 * tmp35;
  double tmp68 = C3 * tmp51 - S3 * tmp52;
  double tmp69 = S3 * tmp51 + C3 * tmp52;
  double tmp70 = C3 * tmp51 - S3 * tmp52;
  double tmp71 = S3 * tmp34 + C3 * tmp33;
  double tmp72 = C3 * tmp34 - S3 * tmp33;
  double tmp73 = S3 * tmp36 + C3 * tmp35;
  double tmp74 = -S3 * tmp51 - C3 * tmp52;
  double tmp75 = C3 * tmp36 - S3 * tmp35;
  double tmp76 = 0.3e0 * tmp68;
  double tmp77 = -0.3e0 * tmp69;
  double tmp78 = 0.3e0 * tmp50;
  double tmp79 = -0.3e0 * tmp69;
  double tmp80 = tmp54 * S3 + tmp53 * C3;
  double tmp81 = tmp54 * C3 - tmp53 * S3;
  double tmp82 = tmp57 * S3 + tmp56 * C3;
  double tmp83 = tmp57 * C3 - tmp56 * S3;
  double tmp84 = tmp61 * S3 + tmp58 * C3;
  double tmp85 = tmp61 * C3 - tmp58 * S3;
  double tmp86 = -0.1618329487e0 + tmp50;
  double tmp87 = 0.7182945987e-2 + tmp68;
  double tmp88 = 0.1526986523e1 + tmp69;
  double tmp89 = 0.1640285517e-1 + S3 * tmp82 + C3 * tmp80;
  double tmp90 = -0.1663047979e-2 + S3 * tmp83 + C3 * tmp81 - tmp76;
  double tmp91 = 0.2387738898e-1 + S3 * tmp59 + C3 * tmp55 - tmp78;
  double tmp92 = -0.1663047979e-2 + C3 * tmp82 - S3 * tmp80 - tmp76;
  double tmp93 = 0.4501958611e0 + C3 * tmp83 - S3 * tmp81 - 2 * tmp77;
  double tmp94 = 0.2387739898e-1 + tmp84 - tmp78;
  double tmp95 = 0.5203146127e-3 + C3 * tmp59 - S3 * tmp55;
  double tmp96 = 0.4363329941e0 + tmp60 - 2 * tmp79;
  double tmp97 = 0.5203146127e-3 + tmp85;
  double tmp98 = tmp62 - 0.3e0 * tmp75;
  double tmp99 = S3 * tmp59 + C3 * tmp55;
  double tmp100 = S3 * tmp64 + C3 * tmp63;
  double tmp101 = C3 * tmp64 - S3 * tmp63 + 0.3e0 * tmp6;
  double tmp102 = tmp60 - 0.3e0 * tmp74;
  double tmp103 = S3 * tmp67 + C3 * tmp65;
  double tmp104 = tmp66 - 0.3e0 * tmp72;
  double tmp105 = C3 * tmp59 - S3 * tmp55;
  double tmp106 = C3 * tmp67 - S3 * tmp65;
  double tmp107 = -0.3673205103e-5 * tmp86 - 0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp87 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp88;
  double tmp108 = 0.1000000000e1 * tmp86 - 0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp87 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp88;
  double tmp109 = sin(q[2] + 0.314159e1) * tmp87 + cos(q[2] + 0.314159e1) * tmp88;
  double tmp110 = -sin(q[2] + 0.314159e1) * tmp88 + cos(q[2] + 0.314159e1) * tmp87;
  double tmp111 = -0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp75 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp73;
  double tmp112 = sin(q[2] + 0.314159e1) * tmp74 + cos(q[2] + 0.314159e1) * tmp70;
  double tmp113 = sin(q[2] + 0.314159e1) * tmp72 + cos(q[2] + 0.314159e1) * tmp71;
  double tmp114 = 0.1000000000e1 * tmp6 - 0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp72 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp71;
  double tmp115 = 0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp88 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp87;
  double tmp116 = -0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp74 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp70;
  double tmp117 = sin(q[2] + 0.314159e1) * tmp75 + cos(q[2] + 0.314159e1) * tmp73;
  double tmp118 = -0.3673205103e-5 * tmp6 - 0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp72 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp71;
  double tmp119 = 0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp88 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp87;
  double tmp120 = -0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp74 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp70;
  double tmp121 = -0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp75 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp73;
  double tmp122 = tmp90 * sin(q[2] + 0.314159e1) + tmp89 * cos(q[2] + 0.314159e1);
  double tmp123 = 0.1000000000e1 * tmp91 - 0.3673205103e-5 * tmp90 * cos(q[2] + 0.314159e1) + 0.3673205103e-5 * tmp89 * sin(q[2] + 0.314159e1);
  double tmp124 = -0.3673205103e-5 * tmp91 - 0.1000000000e1 * tmp90 * cos(q[2] + 0.314159e1) + 0.1000000000e1 * tmp89 * sin(q[2] + 0.314159e1);
  double tmp125 = tmp93 * sin(q[2] + 0.314159e1) + tmp92 * cos(q[2] + 0.314159e1);
  double tmp126 = 0.1000000000e1 * tmp95 - 0.3673205103e-5 * tmp93 * cos(q[2] + 0.314159e1) + 0.3673205103e-5 * tmp92 * sin(q[2] + 0.314159e1);
  double tmp127 = tmp97 * sin(q[2] + 0.314159e1) + tmp94 * cos(q[2] + 0.314159e1);
  double tmp128 = -0.3673205103e-5 * tmp95 - 0.1000000000e1 * tmp93 * cos(q[2] + 0.314159e1) + 0.1000000000e1 * tmp92 * sin(q[2] + 0.314159e1);
  double tmp129 = -0.3673205103e-5 * tmp96 - 0.1000000000e1 * tmp97 * cos(q[2] + 0.314159e1) + 0.1000000000e1 * tmp94 * sin(q[2] + 0.314159e1);
  double tmp130 = 0.1000000000e1 * tmp96 - 0.3673205103e-5 * tmp97 * cos(q[2] + 0.314159e1) + 0.3673205103e-5 * tmp94 * sin(q[2] + 0.314159e1);
  double tmp131 = -0.3208103778e-3 + tmp107;
  double tmp132 = -0.2104745171e-1 + tmp108;
  double tmp133 = -0.2353404227e-2 + tmp109;
  double tmp134 = 0.1870280317e-2 + sin(q[2] + 0.314159e1) * tmp125 + cos(q[2] + 0.314159e1) * tmp122;
  double tmp135 = 0.788860698e-5 + sin(q[2] + 0.314159e1) * tmp126 + cos(q[2] + 0.314159e1) * tmp123;
  double tmp136 = 0.7027332323e-6 + sin(q[2] + 0.314159e1) * tmp128 + cos(q[2] + 0.314159e1) * tmp124;
  double tmp137 = 0.788860698e-5 + 0.1000000000e1 * tmp127 - 0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp125 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp122;
  double tmp138 = 0.5135633776e-3 + 0.1000000000e1 * tmp130 - 0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp126 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp123;
  double tmp139 = 0.7027332323e-6 - 0.3673205103e-5 * tmp127 - 0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp125 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp122;
  double tmp140 = 0.3727641883e-5 + 0.1000000000e1 * tmp129 - 0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp128 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp124;
  double tmp141 = 0.1823648163e-2 - 0.3673205103e-5 * tmp129 - 0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp128 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp124;
  double tmp142 = 0.3727641883e-5 - 0.3673205103e-5 * tmp130 - 0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp126 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp123;
  double tmp143 = sin(q[2] + 0.314159e1) * tmp95 + cos(q[2] + 0.314159e1) * tmp91;
  double tmp144 = -0.3673205103e-5 * tmp98 - 0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp106 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp103;
  double tmp145 = sin(q[2] + 0.314159e1) * tmp105 + cos(q[2] + 0.314159e1) * tmp99;
  double tmp146 = sin(q[2] + 0.314159e1) * tmp101 + cos(q[2] + 0.314159e1) * tmp100;
  double tmp147 = 0.1000000000e1 * tmp104 - 0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp101 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp100;
  double tmp148 = 0.1000000000e1 * tmp96 - 0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp95 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp91;
  double tmp149 = -0.3673205103e-5 * tmp102 - 0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp105 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp99;
  double tmp150 = sin(q[2] + 0.314159e1) * tmp106 + cos(q[2] + 0.314159e1) * tmp103;
  double tmp151 = -0.3673205103e-5 * tmp104 - 0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp101 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp100;
  double tmp152 = -0.3673205103e-5 * tmp96 - 0.1000000000e1 * cos(q[2] + 0.314159e1) * tmp95 + 0.1000000000e1 * sin(q[2] + 0.314159e1) * tmp91;
  double tmp153 = 0.1000000000e1 * tmp102 - 0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp105 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp99;
  double tmp154 = 0.1000000000e1 * tmp98 - 0.3673205103e-5 * cos(q[2] + 0.314159e1) * tmp106 + 0.3673205103e-5 * sin(q[2] + 0.314159e1) * tmp103;
  double tmp155 = -0.3673205103e-5 * tmp131 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp132 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp133;
  double tmp156 = 0.1000000000e1 * tmp131 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp132 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp133;
  double tmp157 = sin(q[1] + 0.15708e1) * tmp132 + cos(q[1] + 0.15708e1) * tmp133;
  double tmp158 = sin(q[1] + 0.15708e1) * tmp115 + cos(q[1] + 0.15708e1) * tmp110;
  double tmp159 = -0.3673205103e-5 * tmp111 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp121 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp117;
  double tmp160 = -sin(q[1] + 0.15708e1) * tmp133 + cos(q[1] + 0.15708e1) * tmp132;
  double tmp161 = sin(q[1] + 0.15708e1) * tmp120 + cos(q[1] + 0.15708e1) * tmp112;
  double tmp162 = sin(q[1] + 0.15708e1) * tmp114 + cos(q[1] + 0.15708e1) * tmp113;
  double tmp163 = 0.1000000000e1 * tmp118 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp114 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp113;
  double tmp164 = 0.1000000000e1 * tmp119 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp115 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp110;
  double tmp165 = -0.3673205103e-5 * tmp116 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp120 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp112;
  double tmp166 = sin(q[1] + 0.15708e1) * tmp121 + cos(q[1] + 0.15708e1) * tmp117;
  double tmp167 = 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp133 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp132;
  double tmp168 = -0.3673205103e-5 * tmp118 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp114 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp113;
  double tmp169 = -0.3673205103e-5 * tmp119 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp115 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp110;
  double tmp170 = 0.1000000000e1 * tmp116 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp120 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp112;
  double tmp171 = 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp133 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp132;
  double tmp172 = 0.1000000000e1 * tmp111 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp121 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp117;
  double tmp173 = tmp135 * sin(q[1] + 0.15708e1) + tmp134 * cos(q[1] + 0.15708e1);
  double tmp174 = 0.1000000000e1 * tmp136 - 0.3673205103e-5 * tmp135 * cos(q[1] + 0.15708e1) + 0.3673205103e-5 * tmp134 * sin(q[1] + 0.15708e1);
  double tmp175 = -0.3673205103e-5 * tmp136 - 0.1000000000e1 * tmp135 * cos(q[1] + 0.15708e1) + 0.1000000000e1 * tmp134 * sin(q[1] + 0.15708e1);
  double tmp176 = tmp138 * sin(q[1] + 0.15708e1) + tmp137 * cos(q[1] + 0.15708e1);
  double tmp177 = 0.1000000000e1 * tmp140 - 0.3673205103e-5 * tmp138 * cos(q[1] + 0.15708e1) + 0.3673205103e-5 * tmp137 * sin(q[1] + 0.15708e1);
  double tmp178 = tmp142 * sin(q[1] + 0.15708e1) + tmp139 * cos(q[1] + 0.15708e1);
  double tmp179 = -0.3673205103e-5 * tmp140 - 0.1000000000e1 * tmp138 * cos(q[1] + 0.15708e1) + 0.1000000000e1 * tmp137 * sin(q[1] + 0.15708e1);
  double tmp180 = -0.3673205103e-5 * tmp141 - 0.1000000000e1 * tmp142 * cos(q[1] + 0.15708e1) + 0.1000000000e1 * tmp139 * sin(q[1] + 0.15708e1);
  double tmp181 = 0.1000000000e1 * tmp141 - 0.3673205103e-5 * tmp142 * cos(q[1] + 0.15708e1) + 0.3673205103e-5 * tmp139 * sin(q[1] + 0.15708e1);
  double tmp182 = 0.8332756634e-1 + tmp155;
  double tmp183 = -0.1322383663e-1 + tmp156;
  double tmp184 = 0.5692054037e-2 + tmp157;
  double tmp185 = 0.9514659389e-2 + sin(q[1] + 0.15708e1) * tmp176 + cos(q[1] + 0.15708e1) * tmp173;
  double tmp186 = 0.4534433117e-4 + sin(q[1] + 0.15708e1) * tmp177 + cos(q[1] + 0.15708e1) * tmp174;
  double tmp187 = -0.3614034306e-3 + sin(q[1] + 0.15708e1) * tmp179 + cos(q[1] + 0.15708e1) * tmp175;
  double tmp188 = 0.4534433117e-4 + 0.1000000000e1 * tmp178 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp176 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp173;
  double tmp189 = 0.8693183579e-2 + 0.1000000000e1 * tmp181 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp177 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp174;
  double tmp190 = -0.3614034306e-3 - 0.3673205103e-5 * tmp178 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp176 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp173;
  double tmp191 = 0.3411182736e-3 + 0.1000000000e1 * tmp180 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp179 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp175;
  double tmp192 = 0.1706504217e-2 - 0.3673205103e-5 * tmp180 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp179 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp175;
  double tmp193 = 0.3411182736e-3 - 0.3673205103e-5 * tmp181 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp177 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp174;
  double tmp194 = sin(q[1] + 0.15708e1) * tmp148 + cos(q[1] + 0.15708e1) * tmp143;
  double tmp195 = -0.3673205103e-5 * tmp144 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp154 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp150;
  double tmp196 = sin(q[1] + 0.15708e1) * tmp140 + cos(q[1] + 0.15708e1) * tmp136;
  double tmp197 = sin(q[1] + 0.15708e1) * tmp153 + cos(q[1] + 0.15708e1) * tmp145;
  double tmp198 = sin(q[1] + 0.15708e1) * tmp147 + cos(q[1] + 0.15708e1) * tmp146;
  double tmp199 = 0.1000000000e1 * tmp151 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp147 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp146;
  double tmp200 = 0.1000000000e1 * tmp152 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp148 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp143;
  double tmp201 = -0.3673205103e-5 * tmp149 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp153 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp145;
  double tmp202 = sin(q[1] + 0.15708e1) * tmp154 + cos(q[1] + 0.15708e1) * tmp150;
  double tmp203 = 0.1000000000e1 * tmp141 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp140 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp136;
  double tmp204 = -0.3673205103e-5 * tmp151 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp147 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp146;
  double tmp205 = -0.3673205103e-5 * tmp152 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp148 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp143;
  double tmp206 = 0.1000000000e1 * tmp149 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp153 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp145;
  double tmp207 = -0.3673205103e-5 * tmp141 - 0.1000000000e1 * cos(q[1] + 0.15708e1) * tmp140 + 0.1000000000e1 * sin(q[1] + 0.15708e1) * tmp136;
  double tmp208 = 0.1000000000e1 * tmp144 - 0.3673205103e-5 * cos(q[1] + 0.15708e1) * tmp154 + 0.3673205103e-5 * sin(q[1] + 0.15708e1) * tmp150;
  double tmp209 = -0.3673205103e-5 * tmp182 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp183 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp184;
  double tmp210 = cos(q[0] - 0.15708e1) * tmp183 - sin(q[0] - 0.15708e1) * tmp184;
  double tmp211 = 0.1000000000e1 * tmp182 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp183 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp184;
  double tmp212 = 0.1000000000e1 * tmp169 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp164 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp158;
  double tmp213 = -0.3673205103e-5 * tmp159 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp172 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp166;
  double tmp214 = 0.1000000000e1 * tmp171 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp167 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp160;
  double tmp215 = 0.1000000000e1 * tmp165 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp170 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp161;
  double tmp216 = 0.1000000000e1 * tmp168 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp163 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp162;
  double tmp217 = 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp184 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp183;
  double tmp218 = cos(q[0] - 0.15708e1) * tmp163 - sin(q[0] - 0.15708e1) * tmp162;
  double tmp219 = cos(q[0] - 0.15708e1) * tmp164 - sin(q[0] - 0.15708e1) * tmp158;
  double tmp220 = -0.3673205103e-5 * tmp165 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp170 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp161;
  double tmp221 = 0.1000000000e1 * tmp159 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp172 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp166;
  double tmp222 = cos(q[0] - 0.15708e1) * tmp167 - sin(q[0] - 0.15708e1) * tmp160;
  double tmp223 = -0.3673205103e-5 * tmp168 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp163 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp162;
  double tmp224 = -0.3673205103e-5 * tmp169 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp164 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp158;
  double tmp225 = -cos(q[0] - 0.15708e1) * tmp184 - sin(q[0] - 0.15708e1) * tmp183;
  double tmp226 = cos(q[0] - 0.15708e1) * tmp170 - sin(q[0] - 0.15708e1) * tmp161;
  double tmp227 = 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp184 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp183;
  double tmp228 = -0.3673205103e-5 * tmp171 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp167 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp160;
  double tmp229 = cos(q[0] - 0.15708e1) * tmp172 - sin(q[0] - 0.15708e1) * tmp166;
  double tmp230 = 0.6e-1 * tmp210;
  double tmp231 = -0.6e-1 * tmp211;
  double tmp232 = 0.6e-1 * tmp210;
  double tmp233 = -0.6e-1 * tmp209;
  double tmp234 = 0.1000000000e1 * tmp187 - 0.3673205103e-5 * tmp186 * sin(q[0] - 0.15708e1) - 0.3673205103e-5 * tmp185 * cos(q[0] - 0.15708e1);
  double tmp235 = tmp186 * cos(q[0] - 0.15708e1) - tmp185 * sin(q[0] - 0.15708e1);
  double tmp236 = -0.3673205103e-5 * tmp187 - 0.1000000000e1 * tmp186 * sin(q[0] - 0.15708e1) - 0.1000000000e1 * tmp185 * cos(q[0] - 0.15708e1);
  double tmp237 = 0.1000000000e1 * tmp191 - 0.3673205103e-5 * tmp189 * sin(q[0] - 0.15708e1) - 0.3673205103e-5 * tmp188 * cos(q[0] - 0.15708e1);
  double tmp238 = tmp189 * cos(q[0] - 0.15708e1) - tmp188 * sin(q[0] - 0.15708e1);
  double tmp239 = 0.1000000000e1 * tmp192 - 0.3673205103e-5 * tmp193 * sin(q[0] - 0.15708e1) - 0.3673205103e-5 * tmp190 * cos(q[0] - 0.15708e1);
  double tmp240 = -0.3673205103e-5 * tmp191 - 0.1000000000e1 * tmp189 * sin(q[0] - 0.15708e1) - 0.1000000000e1 * tmp188 * cos(q[0] - 0.15708e1);
  double tmp241 = -0.3673205103e-5 * tmp192 - 0.1000000000e1 * tmp193 * sin(q[0] - 0.15708e1) - 0.1000000000e1 * tmp190 * cos(q[0] - 0.15708e1);
  double tmp242 = tmp193 * cos(q[0] - 0.15708e1) - tmp190 * sin(q[0] - 0.15708e1);
  double tmp243 = -0.2156943663e0 + tmp209;
  double tmp244 = -0.4894463965e0 + tmp210;
  double tmp245 = 0.3352735772e1 + tmp211;
  double tmp246 = 0.2243764081e0 + 0.1000000000e1 * tmp239 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp237 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp234 - 2 * tmp230;
  double tmp247 = -0.6023282926e-6 + 0.1000000000e1 * tmp242 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp238 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp235 - tmp231;
  double tmp248 = 0.4882341215e-1 + 0.1000000000e1 * tmp241 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp240 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp236;
  double tmp249 = -0.5923282926e-6 + cos(q[0] - 0.15708e1) * tmp237 - sin(q[0] - 0.15708e1) * tmp234 - tmp231;
  double tmp250 = 0.8462937538e0 + cos(q[0] - 0.15708e1) * tmp238 - sin(q[0] - 0.15708e1) * tmp235;
  double tmp251 = 0.4882341215e-1 - 0.3673205103e-5 * tmp239 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp237 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp234;
  double tmp252 = -0.2441166760e-6 + cos(q[0] - 0.15708e1) * tmp240 - sin(q[0] - 0.15708e1) * tmp236 - tmp233;
  double tmp253 = 0.9383111297e0 - 0.3673205103e-5 * tmp241 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp240 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp236 - 2 * tmp232;
  double tmp254 = -0.2341166760e-6 - 0.3673205103e-5 * tmp242 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp238 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp235 - tmp233;
  double tmp255 = 0.1000000000e1 * tmp205 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp200 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp194 + 0.6e-1 * tmp224;
  double tmp256 = -0.3673205103e-5 * tmp195 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp208 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp202 - 0.6e-1 * tmp221;
  double tmp257 = 0.1000000000e1 * tmp207 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp203 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp196 + 0.6e-1 * tmp228;
  double tmp258 = 0.1000000000e1 * tmp201 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp206 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp197 + 0.6e-1 * tmp220;
  double tmp259 = 0.1000000000e1 * tmp204 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp199 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp198 + 0.6e-1 * tmp223;
  double tmp260 = 0.1000000000e1 * tmp192 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp191 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp187 + 0.6e-1 * tmp227;
  double tmp261 = cos(q[0] - 0.15708e1) * tmp199 - sin(q[0] - 0.15708e1) * tmp198;
  double tmp262 = cos(q[0] - 0.15708e1) * tmp200 - sin(q[0] - 0.15708e1) * tmp194;
  double tmp263 = -0.3673205103e-5 * tmp201 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp206 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp197 - 0.6e-1 * tmp215;
  double tmp264 = 0.1000000000e1 * tmp195 - 0.3673205103e-5 * sin(q[0] - 0.15708e1) * tmp208 - 0.3673205103e-5 * cos(q[0] - 0.15708e1) * tmp202 + 0.6e-1 * tmp213;
  double tmp265 = cos(q[0] - 0.15708e1) * tmp203 - sin(q[0] - 0.15708e1) * tmp196;
  double tmp266 = -0.3673205103e-5 * tmp204 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp199 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp198 - 0.6e-1 * tmp216;
  double tmp267 = -0.3673205103e-5 * tmp205 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp200 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp194 - 0.6e-1 * tmp212;
  double tmp268 = cos(q[0] - 0.15708e1) * tmp191 - sin(q[0] - 0.15708e1) * tmp187;
  double tmp269 = cos(q[0] - 0.15708e1) * tmp206 - sin(q[0] - 0.15708e1) * tmp197;
  double tmp270 = -0.3673205103e-5 * tmp192 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp191 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp187 - 0.6e-1 * tmp217;
  double tmp271 = -0.3673205103e-5 * tmp207 - 0.1000000000e1 * sin(q[0] - 0.15708e1) * tmp203 - 0.1000000000e1 * cos(q[0] - 0.15708e1) * tmp196 - 0.6e-1 * tmp214;
  double tmp272 = cos(q[0] - 0.15708e1) * tmp208 - sin(q[0] - 0.15708e1) * tmp202;
  double tmp273 = 0.3998117160e-8 - 0.7684553059e-2 * cos(q[11] + 0.314159e1) - 0.1071449130e0 * sin(q[11] + 0.314159e1);
  double tmp274 = -0.1088454646e-2 - 0.2822693951e-7 * cos(q[11] + 0.314159e1) - 0.3935652412e-6 * sin(q[11] + 0.314159e1);
  double tmp275 = 0.7684553059e-2 * sin(q[11] + 0.314159e1) - 0.1071449130e0 * cos(q[11] + 0.314159e1);
  double tmp276 = 0.7684553059e-2 * sin(q[11] + 0.314159e1) - 0.1071449130e0 * cos(q[11] + 0.314159e1);
  double tmp277 = 0.1071449130e0 * sin(q[11] + 0.314159e1) + 0.7684553059e-2 * cos(q[11] + 0.314159e1);
  double tmp278 = -0.3935652412e-6 * cos(q[11] + 0.314159e1) + 0.2822693951e-7 * sin(q[11] + 0.314159e1);
  double tmp279 = 0.6878360690e-3 * sin(q[11] + 0.314159e1) + 0.7151917501e-2 * cos(q[11] + 0.314159e1);
  double tmp280 = 0.7217854202e-3 - 0.2526562959e-8 * cos(q[11] + 0.314159e1) + 0.2627045986e-7 * sin(q[11] + 0.314159e1);
  double tmp281 = -0.2651265889e-8 - 0.6878360690e-3 * cos(q[11] + 0.314159e1) + 0.7151917501e-2 * sin(q[11] + 0.314159e1);
  double tmp282 = 0.1388210664e-1 * sin(q[11] + 0.314159e1) + 0.6878360690e-3 * cos(q[11] + 0.314159e1);
  double tmp283 = -0.9472599670e-4 - 0.5099182495e-7 * cos(q[11] + 0.314159e1) + 0.2526562959e-8 * sin(q[11] + 0.314159e1);
  double tmp284 = -0.9472599670e-4 * sin(q[11] + 0.314159e1) + 0.7217854202e-3 * cos(q[11] + 0.314159e1);
  double tmp285 = 0.3479480145e-9 - 0.1388210664e-1 * cos(q[11] + 0.314159e1) + 0.6878360690e-3 * sin(q[11] + 0.314159e1);
  double tmp286 = -0.4055978148e-7 + 0.9472599670e-4 * cos(q[11] + 0.314159e1) + 0.7217854202e-3 * sin(q[11] + 0.314159e1);
  double tmp287 = 0.1104206826e-1 + 0.3479480145e-9 * cos(q[11] + 0.314159e1) + 0.2651265889e-8 * sin(q[11] + 0.314159e1);
  double tmp288 = 0.8714552875e-3 + tmp273;
  double tmp289 = 0.5407055112e-2 + tmp274;
  double tmp290 = 0.158076750e-2 + tmp275;
  double tmp291 = 0.9062724922e-3 + sin(q[11] + 0.314159e1) * tmp282 + cos(q[11] + 0.314159e1) * tmp279;
  double tmp292 = -0.2661425926e-4 + sin(q[11] + 0.314159e1) * tmp283 + cos(q[11] + 0.314159e1) * tmp280;
  double tmp293 = -0.5697178885e-5 + sin(q[11] + 0.314159e1) * tmp285 + cos(q[11] + 0.314159e1) * tmp281;
  double tmp294 = -0.2661425926e-4 + 0.1000000000e1 * tmp284 - 0.3673205103e-5 * cos(q[11] + 0.314159e1) * tmp282 + 0.3673205103e-5 * sin(q[11] + 0.314159e1) * tmp279;
  double tmp295 = 0.2827139544e-3 + 0.1000000000e1 * tmp287 - 0.3673205103e-5 * cos(q[11] + 0.314159e1) * tmp283 + 0.3673205103e-5 * sin(q[11] + 0.314159e1) * tmp280;
  double tmp296 = -0.5697178885e-5 - 0.3673205103e-5 * tmp284 - 0.1000000000e1 * cos(q[11] + 0.314159e1) * tmp282 + 0.1000000000e1 * sin(q[11] + 0.314159e1) * tmp279;
  double tmp297 = -0.1947658537e-5 + 0.1000000000e1 * tmp286 - 0.3673205103e-5 * cos(q[11] + 0.314159e1) * tmp285 + 0.3673205103e-5 * sin(q[11] + 0.314159e1) * tmp281;
  double tmp298 = 0.8382031294e-3 - 0.3673205103e-5 * tmp286 - 0.1000000000e1 * cos(q[11] + 0.314159e1) * tmp285 + 0.1000000000e1 * sin(q[11] + 0.314159e1) * tmp281;
  double tmp299 = -0.1947658537e-5 - 0.3673205103e-5 * tmp287 - 0.1000000000e1 * cos(q[11] + 0.314159e1) * tmp283 + 0.1000000000e1 * sin(q[11] + 0.314159e1) * tmp280;
  double tmp300 = -0.4055978148e-7 + 0.9472599670e-4 * cos(q[11] + 0.314159e1) + 0.7217854202e-3 * sin(q[11] + 0.314159e1);
  double tmp301 = -0.9472599670e-4 * sin(q[11] + 0.314159e1) + 0.7217854202e-3 * cos(q[11] + 0.314159e1);
  double tmp302 = 0.1104206826e-1 + 0.3479480145e-9 * cos(q[11] + 0.314159e1) + 0.2651265889e-8 * sin(q[11] + 0.314159e1);
  double tmp303 = C10 * tmp289 - S10 * tmp290;
  double tmp304 = S10 * tmp289 + C10 * tmp290;
  double tmp305 = S10 * tmp278 + C10 * tmp277;
  double tmp306 = C10 * tmp278 - S10 * tmp277;
  double tmp307 = -S10 * tmp289 - C10 * tmp290;
  double tmp308 = C10 * tmp289 - S10 * tmp290;
  double tmp309 = -0.35e-1 * tmp288;
  double tmp310 = 0.35e-1 * tmp304;
  double tmp311 = 0.3e0 * tmp303;
  double tmp312 = -0.3e0 * tmp304 - 0.35e-1 * tmp288;
  double tmp313 = 0.3e0 * tmp288;
  double tmp314 = 0.35e-1 * tmp303;
  double tmp315 = -0.3e0 * tmp304;
  double tmp316 = tmp292 * S10 + tmp291 * C10;
  double tmp317 = tmp292 * C10 - tmp291 * S10;
  double tmp318 = tmp295 * S10 + tmp294 * C10;
  double tmp319 = tmp295 * C10 - tmp294 * S10;
  double tmp320 = tmp299 * S10 + tmp296 * C10;
  double tmp321 = tmp299 * C10 - tmp296 * S10;
  double tmp322 = 0.1814540590e0 + tmp288;
  double tmp323 = 0.3143583904e-1 + tmp303;
  double tmp324 = 0.9296091318e0 + tmp304;
  double tmp325 = 0.1379028676e-1 + S10 * tmp318 + C10 * tmp316 - 2 * tmp309;
  double tmp326 = -0.2102655764e-2 + S10 * tmp319 + C10 * tmp317 - tmp311;
  double tmp327 = -0.3882398272e-1 + S10 * tmp297 + C10 * tmp293 - tmp310 - tmp313;
  double tmp328 = -0.2102645764e-2 + C10 * tmp318 - S10 * tmp316 - tmp311;
  double tmp329 = 0.2707940501e0 + C10 * tmp319 - S10 * tmp317 - 2 * tmp312;
  double tmp330 = -0.3882399272e-1 + tmp320 - tmp313 - tmp310;
  double tmp331 = -0.1726720628e-2 + C10 * tmp297 - S10 * tmp293 - tmp314;
  double tmp332 = 0.2628683165e0 + tmp298 - 2 * tmp315;
  double tmp333 = -0.1726720628e-2 + tmp321 - tmp314;
  double tmp334 = tmp300 - 0.3e0 * tmp306;
  double tmp335 = S10 * tmp302 + C10 * tmp301 + 0.35e-1 * tmp306;
  double tmp336 = C10 * tmp302 - S10 * tmp301 + 0.3e0 * tmp276 - 0.35e-1 * tmp305;
  double tmp337 = tmp298 - 0.3e0 * tmp307;
  double tmp338 = C10 * tmp297 - S10 * tmp293 - 0.35e-1 * tmp308;
  double tmp339 = S10 * tmp297 + C10 * tmp293 + 0.35e-1 * tmp307;
  double tmp340 = C9 * tmp323 - S9 * tmp324;
  double tmp341 = S9 * tmp323 + C9 * tmp324;
  double tmp342 = S9 * tmp306 + C9 * tmp305;
  double tmp343 = C9 * tmp306 - S9 * tmp305;
  double tmp344 = -S9 * tmp323 - C9 * tmp324;
  double tmp345 = C9 * tmp323 - S9 * tmp324;
  double tmp346 = C9 * tmp307 - S9 * tmp308;
  double tmp347 = S9 * tmp307 + C9 * tmp308;
  double tmp348 = 0.3e0 * tmp340;
  double tmp349 = -0.3e0 * tmp341;
  double tmp350 = 0.3e0 * tmp322;
  double tmp351 = -0.3e0 * tmp341;
  double tmp352 = tmp326 * S9 + tmp325 * C9;
  double tmp353 = tmp326 * C9 - tmp325 * S9;
  double tmp354 = tmp329 * S9 + tmp328 * C9;
  double tmp355 = tmp329 * C9 - tmp328 * S9;
  double tmp356 = tmp333 * S9 + tmp330 * C9;
  double tmp357 = tmp333 * C9 - tmp330 * S9;
  double tmp358 = 0.1618329487e0 + tmp322;
  double tmp359 = 0.7182945987e-2 + tmp340;
  double tmp360 = 0.1526986523e1 + tmp341;
  double tmp361 = 0.1640285517e-1 + S9 * tmp354 + C9 * tmp352;
  double tmp362 = -0.1663047979e-2 + S9 * tmp355 + C9 * tmp353 - tmp348;
  double tmp363 = -0.2387738898e-1 + S9 * tmp331 + C9 * tmp327 - tmp350;
  double tmp364 = -0.1663047979e-2 + C9 * tmp354 - S9 * tmp352 - tmp348;
  double tmp365 = 0.4501958611e0 + C9 * tmp355 - S9 * tmp353 - 2 * tmp349;
  double tmp366 = -0.2387739898e-1 + tmp356 - tmp350;
  double tmp367 = -0.5203146127e-3 + C9 * tmp331 - S9 * tmp327;
  double tmp368 = 0.4363329941e0 + tmp332 - 2 * tmp351;
  double tmp369 = -0.5203146127e-3 + tmp357;
  double tmp370 = tmp334 - 0.3e0 * tmp343;
  double tmp371 = S9 * tmp336 + C9 * tmp335;
  double tmp372 = C9 * tmp336 - S9 * tmp335 + 0.3e0 * tmp276;
  double tmp373 = tmp337 - 0.3e0 * tmp346;
  double tmp374 = C9 * tmp331 - S9 * tmp327;
  double tmp375 = tmp332 - 0.3e0 * tmp344;
  double tmp376 = S9 * tmp331 + C9 * tmp327;
  double tmp377 = C9 * tmp338 - S9 * tmp339;
  double tmp378 = S9 * tmp338 + C9 * tmp339;
  double tmp379 = -0.3673205103e-5 * tmp358 - 0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp359 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp360;
  double tmp380 = 0.1000000000e1 * tmp358 - 0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp359 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp360;
  double tmp381 = sin(q[8] + 0.314159e1) * tmp359 + cos(q[8] + 0.314159e1) * tmp360;
  double tmp382 = -0.3673205103e-5 * tmp276 - 0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp343 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp342;
  double tmp383 = sin(q[8] + 0.314159e1) * tmp343 + cos(q[8] + 0.314159e1) * tmp342;
  double tmp384 = 0.1000000000e1 * tmp276 - 0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp343 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp342;
  double tmp385 = -0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp346 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp347;
  double tmp386 = -0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp344 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp345;
  double tmp387 = -sin(q[8] + 0.314159e1) * tmp360 + cos(q[8] + 0.314159e1) * tmp359;
  double tmp388 = -0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp344 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp345;
  double tmp389 = 0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp360 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp359;
  double tmp390 = sin(q[8] + 0.314159e1) * tmp344 + cos(q[8] + 0.314159e1) * tmp345;
  double tmp391 = -0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp346 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp347;
  double tmp392 = sin(q[8] + 0.314159e1) * tmp346 + cos(q[8] + 0.314159e1) * tmp347;
  double tmp393 = 0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp360 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp359;
  double tmp394 = tmp362 * sin(q[8] + 0.314159e1) + tmp361 * cos(q[8] + 0.314159e1);
  double tmp395 = 0.1000000000e1 * tmp363 - 0.3673205103e-5 * tmp362 * cos(q[8] + 0.314159e1) + 0.3673205103e-5 * tmp361 * sin(q[8] + 0.314159e1);
  double tmp396 = -0.3673205103e-5 * tmp363 - 0.1000000000e1 * tmp362 * cos(q[8] + 0.314159e1) + 0.1000000000e1 * tmp361 * sin(q[8] + 0.314159e1);
  double tmp397 = tmp365 * sin(q[8] + 0.314159e1) + tmp364 * cos(q[8] + 0.314159e1);
  double tmp398 = 0.1000000000e1 * tmp367 - 0.3673205103e-5 * tmp365 * cos(q[8] + 0.314159e1) + 0.3673205103e-5 * tmp364 * sin(q[8] + 0.314159e1);
  double tmp399 = tmp369 * sin(q[8] + 0.314159e1) + tmp366 * cos(q[8] + 0.314159e1);
  double tmp400 = -0.3673205103e-5 * tmp367 - 0.1000000000e1 * tmp365 * cos(q[8] + 0.314159e1) + 0.1000000000e1 * tmp364 * sin(q[8] + 0.314159e1);
  double tmp401 = -0.3673205103e-5 * tmp368 - 0.1000000000e1 * tmp369 * cos(q[8] + 0.314159e1) + 0.1000000000e1 * tmp366 * sin(q[8] + 0.314159e1);
  double tmp402 = 0.1000000000e1 * tmp368 - 0.3673205103e-5 * tmp369 * cos(q[8] + 0.314159e1) + 0.3673205103e-5 * tmp366 * sin(q[8] + 0.314159e1);
  double tmp403 = -0.3208103778e-3 + tmp379;
  double tmp404 = 0.2104745171e-1 + tmp380;
  double tmp405 = -0.2353404227e-2 + tmp381;
  double tmp406 = 0.1870280317e-2 + sin(q[8] + 0.314159e1) * tmp397 + cos(q[8] + 0.314159e1) * tmp394;
  double tmp407 = -0.788860698e-5 + sin(q[8] + 0.314159e1) * tmp398 + cos(q[8] + 0.314159e1) * tmp395;
  double tmp408 = 0.7027332323e-6 + sin(q[8] + 0.314159e1) * tmp400 + cos(q[8] + 0.314159e1) * tmp396;
  double tmp409 = -0.788860698e-5 + 0.1000000000e1 * tmp399 - 0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp397 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp394;
  double tmp410 = 0.5135633776e-3 + 0.1000000000e1 * tmp402 - 0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp398 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp395;
  double tmp411 = 0.7027332323e-6 - 0.3673205103e-5 * tmp399 - 0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp397 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp394;
  double tmp412 = -0.3727641883e-5 + 0.1000000000e1 * tmp401 - 0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp400 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp396;
  double tmp413 = 0.1823648163e-2 - 0.3673205103e-5 * tmp401 - 0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp400 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp396;
  double tmp414 = -0.3727641883e-5 - 0.3673205103e-5 * tmp402 - 0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp398 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp395;
  double tmp415 = -0.3673205103e-5 * tmp370 - 0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp372 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp371;
  double tmp416 = sin(q[8] + 0.314159e1) * tmp372 + cos(q[8] + 0.314159e1) * tmp371;
  double tmp417 = 0.1000000000e1 * tmp370 - 0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp372 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp371;
  double tmp418 = -0.3673205103e-5 * tmp373 - 0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp377 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp378;
  double tmp419 = 0.1000000000e1 * tmp375 - 0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp374 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp376;
  double tmp420 = sin(q[8] + 0.314159e1) * tmp367 + cos(q[8] + 0.314159e1) * tmp363;
  double tmp421 = -0.3673205103e-5 * tmp375 - 0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp374 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp376;
  double tmp422 = 0.1000000000e1 * tmp368 - 0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp367 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp363;
  double tmp423 = sin(q[8] + 0.314159e1) * tmp374 + cos(q[8] + 0.314159e1) * tmp376;
  double tmp424 = 0.1000000000e1 * tmp373 - 0.3673205103e-5 * cos(q[8] + 0.314159e1) * tmp377 + 0.3673205103e-5 * sin(q[8] + 0.314159e1) * tmp378;
  double tmp425 = sin(q[8] + 0.314159e1) * tmp377 + cos(q[8] + 0.314159e1) * tmp378;
  double tmp426 = -0.3673205103e-5 * tmp368 - 0.1000000000e1 * cos(q[8] + 0.314159e1) * tmp367 + 0.1000000000e1 * sin(q[8] + 0.314159e1) * tmp363;
  double tmp427 = -0.3673205103e-5 * tmp403 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp404 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp405;
  double tmp428 = 0.1000000000e1 * tmp403 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp404 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp405;
  double tmp429 = sin(q[7] + 0.15708e1) * tmp404 + cos(q[7] + 0.15708e1) * tmp405;
  double tmp430 = -0.3673205103e-5 * tmp382 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp384 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp383;
  double tmp431 = sin(q[7] + 0.15708e1) * tmp384 + cos(q[7] + 0.15708e1) * tmp383;
  double tmp432 = 0.1000000000e1 * tmp382 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp384 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp383;
  double tmp433 = 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp405 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp404;
  double tmp434 = -sin(q[7] + 0.15708e1) * tmp405 + cos(q[7] + 0.15708e1) * tmp404;
  double tmp435 = -0.3673205103e-5 * tmp385 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp391 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp392;
  double tmp436 = 0.1000000000e1 * tmp388 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp386 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp390;
  double tmp437 = sin(q[7] + 0.15708e1) * tmp389 + cos(q[7] + 0.15708e1) * tmp387;
  double tmp438 = -0.3673205103e-5 * tmp388 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp386 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp390;
  double tmp439 = 0.1000000000e1 * tmp393 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp389 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp387;
  double tmp440 = sin(q[7] + 0.15708e1) * tmp386 + cos(q[7] + 0.15708e1) * tmp390;
  double tmp441 = 0.1000000000e1 * tmp385 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp391 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp392;
  double tmp442 = 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp405 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp404;
  double tmp443 = sin(q[7] + 0.15708e1) * tmp391 + cos(q[7] + 0.15708e1) * tmp392;
  double tmp444 = -0.3673205103e-5 * tmp393 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp389 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp387;
  double tmp445 = tmp407 * sin(q[7] + 0.15708e1) + tmp406 * cos(q[7] + 0.15708e1);
  double tmp446 = 0.1000000000e1 * tmp408 - 0.3673205103e-5 * tmp407 * cos(q[7] + 0.15708e1) + 0.3673205103e-5 * tmp406 * sin(q[7] + 0.15708e1);
  double tmp447 = -0.3673205103e-5 * tmp408 - 0.1000000000e1 * tmp407 * cos(q[7] + 0.15708e1) + 0.1000000000e1 * tmp406 * sin(q[7] + 0.15708e1);
  double tmp448 = tmp410 * sin(q[7] + 0.15708e1) + tmp409 * cos(q[7] + 0.15708e1);
  double tmp449 = 0.1000000000e1 * tmp412 - 0.3673205103e-5 * tmp410 * cos(q[7] + 0.15708e1) + 0.3673205103e-5 * tmp409 * sin(q[7] + 0.15708e1);
  double tmp450 = tmp414 * sin(q[7] + 0.15708e1) + tmp411 * cos(q[7] + 0.15708e1);
  double tmp451 = -0.3673205103e-5 * tmp412 - 0.1000000000e1 * tmp410 * cos(q[7] + 0.15708e1) + 0.1000000000e1 * tmp409 * sin(q[7] + 0.15708e1);
  double tmp452 = -0.3673205103e-5 * tmp413 - 0.1000000000e1 * tmp414 * cos(q[7] + 0.15708e1) + 0.1000000000e1 * tmp411 * sin(q[7] + 0.15708e1);
  double tmp453 = 0.1000000000e1 * tmp413 - 0.3673205103e-5 * tmp414 * cos(q[7] + 0.15708e1) + 0.3673205103e-5 * tmp411 * sin(q[7] + 0.15708e1);
  double tmp454 = 0.8332756634e-1 + tmp427;
  double tmp455 = -0.1322383663e-1 + tmp428;
  double tmp456 = -0.5692054037e-2 + tmp429;
  double tmp457 = 0.9514659389e-2 + sin(q[7] + 0.15708e1) * tmp448 + cos(q[7] + 0.15708e1) * tmp445;
  double tmp458 = -0.4534433117e-4 + sin(q[7] + 0.15708e1) * tmp449 + cos(q[7] + 0.15708e1) * tmp446;
  double tmp459 = 0.3614034306e-3 + sin(q[7] + 0.15708e1) * tmp451 + cos(q[7] + 0.15708e1) * tmp447;
  double tmp460 = -0.4534433117e-4 + 0.1000000000e1 * tmp450 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp448 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp445;
  double tmp461 = 0.8693183579e-2 + 0.1000000000e1 * tmp453 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp449 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp446;
  double tmp462 = 0.3614034306e-3 - 0.3673205103e-5 * tmp450 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp448 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp445;
  double tmp463 = 0.3411182736e-3 + 0.1000000000e1 * tmp452 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp451 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp447;
  double tmp464 = 0.1706504217e-2 - 0.3673205103e-5 * tmp452 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp451 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp447;
  double tmp465 = 0.3411182736e-3 - 0.3673205103e-5 * tmp453 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp449 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp446;
  double tmp466 = -0.3673205103e-5 * tmp415 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp417 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp416;
  double tmp467 = sin(q[7] + 0.15708e1) * tmp417 + cos(q[7] + 0.15708e1) * tmp416;
  double tmp468 = 0.1000000000e1 * tmp415 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp417 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp416;
  double tmp469 = -0.3673205103e-5 * tmp413 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp412 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp408;
  double tmp470 = sin(q[7] + 0.15708e1) * tmp412 + cos(q[7] + 0.15708e1) * tmp408;
  double tmp471 = -0.3673205103e-5 * tmp418 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp424 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp425;
  double tmp472 = 0.1000000000e1 * tmp421 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp419 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp423;
  double tmp473 = sin(q[7] + 0.15708e1) * tmp422 + cos(q[7] + 0.15708e1) * tmp420;
  double tmp474 = -0.3673205103e-5 * tmp421 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp419 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp423;
  double tmp475 = 0.1000000000e1 * tmp426 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp422 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp420;
  double tmp476 = sin(q[7] + 0.15708e1) * tmp419 + cos(q[7] + 0.15708e1) * tmp423;
  double tmp477 = 0.1000000000e1 * tmp418 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp424 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp425;
  double tmp478 = 0.1000000000e1 * tmp413 - 0.3673205103e-5 * cos(q[7] + 0.15708e1) * tmp412 + 0.3673205103e-5 * sin(q[7] + 0.15708e1) * tmp408;
  double tmp479 = sin(q[7] + 0.15708e1) * tmp424 + cos(q[7] + 0.15708e1) * tmp425;
  double tmp480 = -0.3673205103e-5 * tmp426 - 0.1000000000e1 * cos(q[7] + 0.15708e1) * tmp422 + 0.1000000000e1 * sin(q[7] + 0.15708e1) * tmp420;
  double tmp481 = -0.3673205103e-5 * tmp454 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp455 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp456;
  double tmp482 = cos(q[6] - 0.15708e1) * tmp455 - sin(q[6] - 0.15708e1) * tmp456;
  double tmp483 = 0.1000000000e1 * tmp454 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp455 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp456;
  double tmp484 = 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp456 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp455;
  double tmp485 = -0.3673205103e-5 * tmp430 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp432 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp431;
  double tmp486 = -cos(q[6] - 0.15708e1) * tmp456 - sin(q[6] - 0.15708e1) * tmp455;
  double tmp487 = 0.1000000000e1 * tmp430 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp432 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp431;
  double tmp488 = 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp456 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp455;
  double tmp489 = cos(q[6] - 0.15708e1) * tmp432 - sin(q[6] - 0.15708e1) * tmp431;
  double tmp490 = -0.3673205103e-5 * tmp433 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp442 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp434;
  double tmp491 = 0.1000000000e1 * tmp433 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp442 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp434;
  double tmp492 = -0.3673205103e-5 * tmp435 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp441 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp443;
  double tmp493 = cos(q[6] - 0.15708e1) * tmp436 - sin(q[6] - 0.15708e1) * tmp440;
  double tmp494 = 0.1000000000e1 * tmp444 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp439 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp437;
  double tmp495 = -0.3673205103e-5 * tmp438 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp436 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp440;
  double tmp496 = cos(q[6] - 0.15708e1) * tmp439 - sin(q[6] - 0.15708e1) * tmp437;
  double tmp497 = 0.1000000000e1 * tmp438 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp436 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp440;
  double tmp498 = cos(q[6] - 0.15708e1) * tmp441 - sin(q[6] - 0.15708e1) * tmp443;
  double tmp499 = cos(q[6] - 0.15708e1) * tmp442 - sin(q[6] - 0.15708e1) * tmp434;
  double tmp500 = 0.1000000000e1 * tmp435 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp441 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp443;
  double tmp501 = -0.3673205103e-5 * tmp444 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp439 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp437;
  double tmp502 = -0.6e-1 * tmp482;
  double tmp503 = 0.6e-1 * tmp483;
  double tmp504 = -0.6e-1 * tmp482;
  double tmp505 = 0.6e-1 * tmp481;
  double tmp506 = 0.1000000000e1 * tmp459 - 0.3673205103e-5 * tmp458 * sin(q[6] - 0.15708e1) - 0.3673205103e-5 * tmp457 * cos(q[6] - 0.15708e1);
  double tmp507 = tmp458 * cos(q[6] - 0.15708e1) - tmp457 * sin(q[6] - 0.15708e1);
  double tmp508 = -0.3673205103e-5 * tmp459 - 0.1000000000e1 * tmp458 * sin(q[6] - 0.15708e1) - 0.1000000000e1 * tmp457 * cos(q[6] - 0.15708e1);
  double tmp509 = 0.1000000000e1 * tmp463 - 0.3673205103e-5 * tmp461 * sin(q[6] - 0.15708e1) - 0.3673205103e-5 * tmp460 * cos(q[6] - 0.15708e1);
  double tmp510 = tmp461 * cos(q[6] - 0.15708e1) - tmp460 * sin(q[6] - 0.15708e1);
  double tmp511 = 0.1000000000e1 * tmp464 - 0.3673205103e-5 * tmp465 * sin(q[6] - 0.15708e1) - 0.3673205103e-5 * tmp462 * cos(q[6] - 0.15708e1);
  double tmp512 = -0.3673205103e-5 * tmp463 - 0.1000000000e1 * tmp461 * sin(q[6] - 0.15708e1) - 0.1000000000e1 * tmp460 * cos(q[6] - 0.15708e1);
  double tmp513 = -0.3673205103e-5 * tmp464 - 0.1000000000e1 * tmp465 * sin(q[6] - 0.15708e1) - 0.1000000000e1 * tmp462 * cos(q[6] - 0.15708e1);
  double tmp514 = tmp465 * cos(q[6] - 0.15708e1) - tmp462 * sin(q[6] - 0.15708e1);
  double tmp515 = tmp243 + tmp481;
  double tmp516 = tmp244 + tmp482 + 0.4894482e0;
  double tmp517 = tmp245 + tmp483;
  double tmp518 = tmp246 + 0.1000000000e1 * tmp511 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp509 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp506 + 0.29366892e-1 - 2 * tmp502;
  double tmp519 = tmp247 + 0.1000000000e1 * tmp514 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp510 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp507 - tmp503;
  double tmp520 = tmp248 + 0.1000000000e1 * tmp513 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp512 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp508;
  double tmp521 = tmp249 + cos(q[6] - 0.15708e1) * tmp509 - sin(q[6] - 0.15708e1) * tmp506 - tmp503;
  double tmp522 = tmp250 + cos(q[6] - 0.15708e1) * tmp510 - sin(q[6] - 0.15708e1) * tmp507;
  double tmp523 = tmp251 - 0.3673205103e-5 * tmp511 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp509 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp506;
  double tmp524 = tmp252 + cos(q[6] - 0.15708e1) * tmp512 - sin(q[6] - 0.15708e1) * tmp508 - tmp505;
  double tmp525 = tmp253 - 0.3673205103e-5 * tmp513 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp512 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp508 + 0.29366892e-1 - 2 * tmp504;
  double tmp526 = tmp254 - 0.3673205103e-5 * tmp514 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp510 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp507 - tmp505;
  double tmp527 = 0.1000000000e1 * tmp464 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp463 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp459 - 0.6e-1 * tmp488;
  double tmp528 = -0.3673205103e-5 * tmp466 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp468 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp467 + 0.6e-1 * tmp487;
  double tmp529 = cos(q[6] - 0.15708e1) * tmp463 - sin(q[6] - 0.15708e1) * tmp459;
  double tmp530 = 0.1000000000e1 * tmp466 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp468 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp467 - 0.6e-1 * tmp485;
  double tmp531 = -0.3673205103e-5 * tmp464 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp463 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp459 + 0.6e-1 * tmp484;
  double tmp532 = cos(q[6] - 0.15708e1) * tmp468 - sin(q[6] - 0.15708e1) * tmp467;
  double tmp533 = -0.3673205103e-5 * tmp469 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp478 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp470 + 0.6e-1 * tmp491;
  double tmp534 = 0.1000000000e1 * tmp469 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp478 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp470 - 0.6e-1 * tmp490;
  double tmp535 = -0.3673205103e-5 * tmp471 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp477 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp479 + 0.6e-1 * tmp500;
  double tmp536 = cos(q[6] - 0.15708e1) * tmp472 - sin(q[6] - 0.15708e1) * tmp476;
  double tmp537 = 0.1000000000e1 * tmp480 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp475 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp473 - 0.6e-1 * tmp501;
  double tmp538 = -0.3673205103e-5 * tmp474 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp472 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp476 + 0.6e-1 * tmp497;
  double tmp539 = cos(q[6] - 0.15708e1) * tmp475 - sin(q[6] - 0.15708e1) * tmp473;
  double tmp540 = 0.1000000000e1 * tmp474 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp472 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp476 - 0.6e-1 * tmp495;
  double tmp541 = cos(q[6] - 0.15708e1) * tmp477 - sin(q[6] - 0.15708e1) * tmp479;
  double tmp542 = cos(q[6] - 0.15708e1) * tmp478 - sin(q[6] - 0.15708e1) * tmp470;
  double tmp543 = 0.1000000000e1 * tmp471 - 0.3673205103e-5 * sin(q[6] - 0.15708e1) * tmp477 - 0.3673205103e-5 * cos(q[6] - 0.15708e1) * tmp479 - 0.6e-1 * tmp492;
  double tmp544 = -0.3673205103e-5 * tmp480 - 0.1000000000e1 * sin(q[6] - 0.15708e1) * tmp475 - 0.1000000000e1 * cos(q[6] - 0.15708e1) * tmp473 + 0.6e-1 * tmp494;
  double tmp545 = -0.3139789522e-9 - 0.1290219142e-1 * S15 + 0.7823723581e-1 * C15;
  double tmp546 = 0.1290219142e-1 * C15 + 0.7823723581e-1 * S15;
  double tmp547 = 0.8547819775e-4 - 0.4739239536e-7 * S15 + 0.2873814138e-6 * C15;
  double tmp548 = -0.2873814138e-6 * S15 - 0.4739239536e-7 * C15;
  double tmp549 = 0.7823723581e-1 * C15 - 0.1290219142e-1 * S15;
  double tmp550 = -0.1290219142e-1 * C15 - 0.7823723581e-1 * S15;
  double tmp551 = 0.7045231414e-4 - 0.1186020394e-8 * S15 - 0.2231254451e-7 * C15;
  double tmp552 = 0.322884337e-3 * C15 - 0.6074407469e-2 * S15;
  double tmp553 = -0.2587857998e-9 - 0.3228843370e-3 * S15 - 0.6074407469e-2 * C15;
  double tmp554 = -0.2276023357e-4 - 0.4245927198e-7 * S15 - 0.1186020394e-8 * C15;
  double tmp555 = 0.1155918899e-1 * C15 - 0.322884337e-3 * S15;
  double tmp556 = 0.1090452175e-1 + 0.8360300609e-10 * S15 - 0.2587857998e-9 * C15;
  double tmp557 = 0.8360300609e-10 - 0.1155918899e-1 * S15 - 0.3228843370e-3 * C15;
  double tmp558 = -0.4005454494e-7 + 0.2276023357e-4 * S15 - 0.7045231414e-4 * C15;
  double tmp559 = -0.2276023357e-4 * C15 - 0.7045231414e-4 * S15;
  double tmp560 = -0.3008422822e-2 + tmp545;
  double tmp561 = -0.3280439228e-3 + tmp546;
  double tmp562 = 0.1597248944e-2 + tmp547;
  double tmp563 = 0.2500171706e-3 + 0.1000000000e1 * tmp556 - 0.3673205103e-5 * S15 * tmp554 - 0.3673205103e-5 * C15 * tmp551;
  double tmp564 = 0.408119919e-6 + 0.1000000000e1 * tmp559 - 0.3673205103e-5 * S15 * tmp555 - 0.3673205103e-5 * C15 * tmp552;
  double tmp565 = 0.101186798e-5 + 0.1000000000e1 * tmp558 - 0.3673205103e-5 * S15 * tmp557 - 0.3673205103e-5 * C15 * tmp553;
  double tmp566 = 0.408119919e-6 + C15 * tmp554 - S15 * tmp551;
  double tmp567 = 0.4304074830e-3 + C15 * tmp555 - S15 * tmp552;
  double tmp568 = 0.101186798e-5 - 0.3673205103e-5 * tmp556 - 0.1000000000e1 * S15 * tmp554 - 0.1000000000e1 * C15 * tmp551;
  double tmp569 = -0.373362749e-6 + C15 * tmp557 - S15 * tmp553;
  double tmp570 = 0.3695546057e-3 - 0.3673205103e-5 * tmp558 - 0.1000000000e1 * S15 * tmp557 - 0.1000000000e1 * C15 * tmp553;
  double tmp571 = -0.373362749e-6 - 0.3673205103e-5 * tmp559 - 0.1000000000e1 * S15 * tmp555 - 0.1000000000e1 * C15 * tmp552;
  double tmp572 = 0.1090452175e-1 + 0.8360300609e-10 * S15 - 0.2587857998e-9 * C15;
  double tmp573 = -0.2276023357e-4 * C15 - 0.7045231414e-4 * S15;
  double tmp574 = -0.4005454494e-7 + 0.2276023357e-4 * S15 - 0.7045231414e-4 * C15;
  double tmp575 = -0.3673205103e-5 * tmp560 + 0.1000000000e1 * S14 * tmp561 + 0.1000000000e1 * C14 * tmp562;
  double tmp576 = C14 * tmp561 - S14 * tmp562;
  double tmp577 = -0.1000000000e1 * tmp560 - 0.3673205103e-5 * S14 * tmp561 - 0.3673205103e-5 * C14 * tmp562;
  double tmp578 = -0.1000000000e1 * tmp550 - 0.3673205103e-5 * S14 * tmp549 - 0.3673205103e-5 * C14 * tmp548;
  double tmp579 = C14 * tmp549 - S14 * tmp548;
  double tmp580 = -C14 * tmp562 - S14 * tmp561;
  double tmp581 = -0.1000000000e1 * S14 * tmp562 + 0.1000000000e1 * C14 * tmp561;
  double tmp582 = 0.3673205103e-5 * S14 * tmp562 - 0.3673205103e-5 * C14 * tmp561;
  double tmp583 = -0.3673205103e-5 * tmp550 + 0.1000000000e1 * S14 * tmp549 + 0.1000000000e1 * C14 * tmp548;
  double tmp584 = 0.7e-2 * tmp576;
  double tmp585 = -0.7e-2 * tmp577;
  double tmp586 = -0.2973e0 * tmp576;
  double tmp587 = 0.2973e0 * tmp577;
  double tmp588 = -0.2973e0 * tmp575;
  double tmp589 = 0.2973e0 * tmp577 + 0.7e-2 * tmp576;
  double tmp590 = -0.7e-2 * tmp575;
  double tmp591 = -0.1000000000e1 * tmp565 - 0.3673205103e-5 * tmp564 * S14 - 0.3673205103e-5 * tmp563 * C14;
  double tmp592 = tmp564 * C14 - tmp563 * S14;
  double tmp593 = -0.3673205103e-5 * tmp565 + 0.1000000000e1 * tmp564 * S14 + 0.1000000000e1 * tmp563 * C14;
  double tmp594 = -0.1000000000e1 * tmp569 - 0.3673205103e-5 * tmp567 * S14 - 0.3673205103e-5 * tmp566 * C14;
  double tmp595 = tmp567 * C14 - tmp566 * S14;
  double tmp596 = -0.1000000000e1 * tmp570 - 0.3673205103e-5 * tmp571 * S14 - 0.3673205103e-5 * tmp568 * C14;
  double tmp597 = -0.3673205103e-5 * tmp569 + 0.1000000000e1 * tmp567 * S14 + 0.1000000000e1 * tmp566 * C14;
  double tmp598 = -0.3673205103e-5 * tmp570 + 0.1000000000e1 * tmp571 * S14 + 0.1000000000e1 * tmp568 * C14;
  double tmp599 = tmp571 * C14 - tmp568 * S14;
  double tmp600 = 0.8256350211e-1 + tmp575;
  double tmp601 = -0.3443618672e0 + tmp576;
  double tmp602 = -0.1801507088e1 + tmp577;
  double tmp603 = 0.1920529028e0 - 0.1000000000e1 * tmp596 - 0.3673205103e-5 * S14 * tmp594 - 0.3673205103e-5 * C14 * tmp591 - 2 * tmp584;
  double tmp604 = -0.3921962367e-1 - 0.1000000000e1 * tmp599 - 0.3673205103e-5 * S14 * tmp595 - 0.3673205103e-5 * C14 * tmp592 - tmp585 - tmp586;
  double tmp605 = 0.6111867843e-2 - 0.1000000000e1 * tmp598 - 0.3673205103e-5 * S14 * tmp597 - 0.3673205103e-5 * C14 * tmp593 - tmp588;
  double tmp606 = -0.3921962367e-1 + C14 * tmp594 - S14 * tmp591 - tmp586 - tmp585;
  double tmp607 = 0.4507934012e0 + C14 * tmp595 - S14 * tmp592 - 2 * tmp587;
  double tmp608 = 0.6111897843e-2 - 0.3673205103e-5 * tmp596 + 0.1000000000e1 * S14 * tmp594 + 0.1000000000e1 * C14 * tmp591 - tmp588;
  double tmp609 = 0.1039116711e-2 + C14 * tmp597 - S14 * tmp593 - tmp590;
  double tmp610 = 0.4363643160e0 - 0.3673205103e-5 * tmp598 + 0.1000000000e1 * S14 * tmp597 + 0.1000000000e1 * C14 * tmp593 - 2 * tmp589;
  double tmp611 = 0.1039106711e-2 - 0.3673205103e-5 * tmp599 + 0.1000000000e1 * S14 * tmp595 + 0.1000000000e1 * C14 * tmp592 - tmp590;
  double tmp612 = -0.1000000000e1 * tmp574 - 0.3673205103e-5 * S14 * tmp573 - 0.3673205103e-5 * C14 * tmp572 + 0.7e-2 * tmp583;
  double tmp613 = C14 * tmp573 - S14 * tmp572 - 0.2973e0 * tmp583;
  double tmp614 = C14 * tmp569 - S14 * tmp565 - 0.2973e0 * tmp581;
  double tmp615 = -0.3673205103e-5 * tmp570 + 0.1000000000e1 * S14 * tmp569 + 0.1000000000e1 * C14 * tmp565 + 0.2973e0 * tmp580 - 0.7e-2 * tmp582;
  double tmp616 = -0.1000000000e1 * tmp570 - 0.3673205103e-5 * S14 * tmp569 - 0.3673205103e-5 * C14 * tmp565 + 0.7e-2 * tmp581;
  double tmp617 = -0.3673205103e-5 * tmp574 + 0.1000000000e1 * S14 * tmp573 + 0.1000000000e1 * C14 * tmp572 + 0.2973e0 * tmp579 - 0.7e-2 * tmp578;
  double tmp618 = -0.7772649316e-8 + 0.7187638876e-3 * cos(q[22] + 0.314159e1) - 0.9188905377e-2 * sin(q[22] + 0.314159e1);
  double tmp619 = 0.2116040106e-2 + 0.2640167180e-8 * cos(q[22] + 0.314159e1) - 0.3375273412e-7 * sin(q[22] + 0.314159e1);
  double tmp620 = -0.7187638876e-3 * sin(q[22] + 0.314159e1) - 0.9188905377e-2 * cos(q[22] + 0.314159e1);
  double tmp621 = -0.3375273412e-7 * cos(q[22] + 0.314159e1) - 0.2640167180e-8 * sin(q[22] + 0.314159e1);
  double tmp622 = 0.9188905377e-2 * sin(q[22] + 0.314159e1) - 0.7187638876e-3 * cos(q[22] + 0.314159e1);
  double tmp623 = -0.7187638876e-3 * sin(q[22] + 0.314159e1) - 0.9188905377e-2 * cos(q[22] + 0.314159e1);
  double tmp624 = -0.2e-1 * tmp618;
  double tmp625 = 0.2e-1 * tmp620;
  double tmp626 = 0.95e-1 * tmp619;
  double tmp627 = -0.95e-1 * tmp620 - 0.2e-1 * tmp618;
  double tmp628 = 0.95e-1 * tmp618;
  double tmp629 = 0.2e-1 * tmp619;
  double tmp630 = -0.95e-1 * tmp620;
  double tmp631 = -0.4846081086e-4 * sin(q[22] + 0.314159e1) + 0.1068540576e-3 * cos(q[22] + 0.314159e1);
  double tmp632 = 0.1009090221e-3 + 0.1780064977e-9 * cos(q[22] + 0.314159e1) + 0.3924968697e-9 * sin(q[22] + 0.314159e1);
  double tmp633 = -0.3706595349e-9 + 0.4846081086e-4 * cos(q[22] + 0.314159e1) + 0.1068540576e-3 * sin(q[22] + 0.314159e1);
  double tmp634 = 0.7390581571e-3 * sin(q[22] + 0.314159e1) - 0.4846081086e-4 * cos(q[22] + 0.314159e1);
  double tmp635 = 0.5091515060e-6 - 0.2714712194e-8 * cos(q[22] + 0.314159e1) - 0.1780064977e-9 * sin(q[22] + 0.314159e1);
  double tmp636 = 0.509151506e-6 * sin(q[22] + 0.314159e1) + 0.1009090221e-3 * cos(q[22] + 0.314159e1);
  double tmp637 = -0.1870217910e-11 - 0.7390581571e-3 * cos(q[22] + 0.314159e1) - 0.4846081086e-4 * sin(q[22] + 0.314159e1);
  double tmp638 = -0.2482293117e-8 - 0.5091515060e-6 * cos(q[22] + 0.314159e1) + 0.1009090221e-3 * sin(q[22] + 0.314159e1);
  double tmp639 = 0.6757839673e-3 - 0.1870217910e-11 * cos(q[22] + 0.314159e1) + 0.3706595349e-9 * sin(q[22] + 0.314159e1);
  double tmp640 = 0.1029233145e-2 + tmp618;
  double tmp641 = 0.2024462280e-2 + tmp619;
  double tmp642 = 0.9792184733e-1 + tmp620;
  double tmp643 = 0.8522984760e-3 + sin(q[22] + 0.314159e1) * tmp634 + cos(q[22] + 0.314159e1) * tmp631 - 2 * tmp624;
  double tmp644 = -0.2429123485e-3 + sin(q[22] + 0.314159e1) * tmp635 + cos(q[22] + 0.314159e1) * tmp632 - tmp626;
  double tmp645 = 0.1125579025e-3 + sin(q[22] + 0.314159e1) * tmp637 + cos(q[22] + 0.314159e1) * tmp633 - tmp625 - tmp628;
  double tmp646 = -0.2429123485e-3 + 0.1000000000e1 * tmp636 - 0.3673205103e-5 * cos(q[22] + 0.314159e1) * tmp634 + 0.3673205103e-5 * sin(q[22] + 0.314159e1) * tmp631 - tmp626;
  double tmp647 = 0.1094083385e-1 + 0.1000000000e1 * tmp639 - 0.3673205103e-5 * cos(q[22] + 0.314159e1) * tmp635 + 0.3673205103e-5 * sin(q[22] + 0.314159e1) * tmp632 - 2 * tmp627;
  double tmp648 = 0.1125579025e-3 - 0.3673205103e-5 * tmp636 - 0.1000000000e1 * cos(q[22] + 0.314159e1) * tmp634 + 0.1000000000e1 * sin(q[22] + 0.314159e1) * tmp631 - tmp628 - tmp625;
  double tmp649 = 0.2323430947e-4 + 0.1000000000e1 * tmp638 - 0.3673205103e-5 * cos(q[22] + 0.314159e1) * tmp637 + 0.3673205103e-5 * sin(q[22] + 0.314159e1) * tmp633 - tmp629;
  double tmp650 = 0.1093925084e-1 - 0.3673205103e-5 * tmp638 - 0.1000000000e1 * cos(q[22] + 0.314159e1) * tmp637 + 0.1000000000e1 * sin(q[22] + 0.314159e1) * tmp633 - 2 * tmp630;
  double tmp651 = 0.2323430947e-4 - 0.3673205103e-5 * tmp639 - 0.1000000000e1 * cos(q[22] + 0.314159e1) * tmp635 + 0.1000000000e1 * sin(q[22] + 0.314159e1) * tmp632 - tmp629;
  double tmp652 = 0.6757839673e-3 - 0.1870217910e-11 * cos(q[22] + 0.314159e1) + 0.3706595349e-9 * sin(q[22] + 0.314159e1) + 0.95e-1 * tmp623 - 0.2e-1 * tmp622;
  double tmp653 = 0.509151506e-6 * sin(q[22] + 0.314159e1) + 0.1009090221e-3 * cos(q[22] + 0.314159e1) + 0.2e-1 * tmp621;
  double tmp654 = -0.2482293117e-8 - 0.5091515060e-6 * cos(q[22] + 0.314159e1) + 0.1009090221e-3 * sin(q[22] + 0.314159e1) - 0.95e-1 * tmp621;
  double tmp655 = -0.3673205103e-5 * tmp640 - 0.1000000000e1 * S21 * tmp641 - 0.1000000000e1 * C21 * tmp642;
  double tmp656 = C21 * tmp641 - S21 * tmp642;
  double tmp657 = 0.1000000000e1 * tmp640 - 0.3673205103e-5 * S21 * tmp641 - 0.3673205103e-5 * C21 * tmp642;
  double tmp658 = C21 * tmp621 - S21 * tmp622;
  double tmp659 = 0.1000000000e1 * tmp623 - 0.3673205103e-5 * S21 * tmp621 - 0.3673205103e-5 * C21 * tmp622;
  double tmp660 = 0.1000000000e1 * S21 * tmp642 - 0.1000000000e1 * C21 * tmp641;
  double tmp661 = -C21 * tmp642 - S21 * tmp641;
  double tmp662 = 0.3673205103e-5 * S21 * tmp642 - 0.3673205103e-5 * C21 * tmp641;
  double tmp663 = -0.3673205103e-5 * tmp623 - 0.1000000000e1 * S21 * tmp621 - 0.1000000000e1 * C21 * tmp622;
  double tmp664 = 0.1000000000e1 * tmp645 - 0.3673205103e-5 * tmp644 * S21 - 0.3673205103e-5 * tmp643 * C21;
  double tmp665 = tmp644 * C21 - tmp643 * S21;
  double tmp666 = -0.3673205103e-5 * tmp645 - 0.1000000000e1 * tmp644 * S21 - 0.1000000000e1 * tmp643 * C21;
  double tmp667 = 0.1000000000e1 * tmp649 - 0.3673205103e-5 * tmp647 * S21 - 0.3673205103e-5 * tmp646 * C21;
  double tmp668 = tmp647 * C21 - tmp646 * S21;
  double tmp669 = 0.1000000000e1 * tmp650 - 0.3673205103e-5 * tmp651 * S21 - 0.3673205103e-5 * tmp648 * C21;
  double tmp670 = -0.3673205103e-5 * tmp649 - 0.1000000000e1 * tmp647 * S21 - 0.1000000000e1 * tmp646 * C21;
  double tmp671 = -0.3673205103e-5 * tmp650 - 0.1000000000e1 * tmp651 * S21 - 0.1000000000e1 * tmp648 * C21;
  double tmp672 = tmp651 * C21 - tmp648 * S21;
  double tmp673 = 0.2301648936e-1 + tmp655;
  double tmp674 = -0.1912848153e-2 + tmp656;
  double tmp675 = -0.2006565028e-2 + tmp657;
  double tmp676 = 0.2160886646e-2 + 0.1000000000e1 * tmp669 - 0.3673205103e-5 * S21 * tmp667 - 0.3673205103e-5 * C21 * tmp664;
  double tmp677 = 0.9540099649e-5 + 0.1000000000e1 * tmp672 - 0.3673205103e-5 * S21 * tmp668 - 0.3673205103e-5 * C21 * tmp665;
  double tmp678 = -0.3632577826e-4 + 0.1000000000e1 * tmp671 - 0.3673205103e-5 * S21 * tmp670 - 0.3673205103e-5 * C21 * tmp666;
  double tmp679 = 0.9540099649e-5 + C21 * tmp667 - S21 * tmp664;
  double tmp680 = 0.2283388870e-2 + C21 * tmp668 - S21 * tmp665;
  double tmp681 = -0.3632577826e-4 - 0.3673205103e-5 * tmp669 - 0.1000000000e1 * S21 * tmp667 - 0.1000000000e1 * C21 * tmp664;
  double tmp682 = 0.1259753557e-3 + C21 * tmp670 - S21 * tmp666;
  double tmp683 = 0.3310056351e-3 - 0.3673205103e-5 * tmp671 - 0.1000000000e1 * S21 * tmp670 - 0.1000000000e1 * C21 * tmp666;
  double tmp684 = 0.1259753557e-3 - 0.3673205103e-5 * tmp672 - 0.1000000000e1 * S21 * tmp668 - 0.1000000000e1 * C21 * tmp665;
  double tmp685 = C21 * tmp652 - S21 * tmp653;
  double tmp686 = 0.1000000000e1 * tmp654 - 0.3673205103e-5 * S21 * tmp652 - 0.3673205103e-5 * C21 * tmp653;
  double tmp687 = -0.3673205103e-5 * tmp650 - 0.1000000000e1 * S21 * tmp649 - 0.1000000000e1 * C21 * tmp645;
  double tmp688 = C21 * tmp649 - S21 * tmp645;
  double tmp689 = 0.1000000000e1 * tmp650 - 0.3673205103e-5 * S21 * tmp649 - 0.3673205103e-5 * C21 * tmp645;
  double tmp690 = -0.3673205103e-5 * tmp654 - 0.1000000000e1 * S21 * tmp652 - 0.1000000000e1 * C21 * tmp653;
  double tmp691 = -0.3673205103e-5 * tmp673 + 0.1000000000e1 * S20 * tmp674 + 0.1000000000e1 * C20 * tmp675;
  double tmp692 = C20 * tmp674 - S20 * tmp675;
  double tmp693 = -0.1000000000e1 * tmp673 - 0.3673205103e-5 * S20 * tmp674 - 0.3673205103e-5 * C20 * tmp675;
  double tmp694 = C20 * tmp658 - S20 * tmp659;
  double tmp695 = -0.1000000000e1 * S20 * tmp675 + 0.1000000000e1 * C20 * tmp674;
  double tmp696 = -0.1000000000e1 * tmp663 - 0.3673205103e-5 * S20 * tmp658 - 0.3673205103e-5 * C20 * tmp659;
  double tmp697 = -0.3673205103e-5 * tmp660 + 0.1000000000e1 * S20 * tmp661 + 0.1000000000e1 * C20 * tmp662;
  double tmp698 = C20 * tmp661 - S20 * tmp662;
  double tmp699 = -0.1000000000e1 * tmp660 - 0.3673205103e-5 * S20 * tmp661 - 0.3673205103e-5 * C20 * tmp662;
  double tmp700 = -0.3673205103e-5 * tmp663 + 0.1000000000e1 * S20 * tmp658 + 0.1000000000e1 * C20 * tmp659;
  double tmp701 = 0.3673205103e-5 * S20 * tmp675 - 0.3673205103e-5 * C20 * tmp674;
  double tmp702 = -C20 * tmp675 - S20 * tmp674;
  double tmp703 = 0.25e0 * tmp692;
  double tmp704 = -0.25e0 * tmp693;
  double tmp705 = 0.25e0 * tmp691;
  double tmp706 = -0.25e0 * tmp693;
  double tmp707 = -0.1000000000e1 * tmp678 - 0.3673205103e-5 * tmp677 * S20 - 0.3673205103e-5 * tmp676 * C20;
  double tmp708 = tmp677 * C20 - tmp676 * S20;
  double tmp709 = -0.3673205103e-5 * tmp678 + 0.1000000000e1 * tmp677 * S20 + 0.1000000000e1 * tmp676 * C20;
  double tmp710 = -0.1000000000e1 * tmp682 - 0.3673205103e-5 * tmp680 * S20 - 0.3673205103e-5 * tmp679 * C20;
  double tmp711 = tmp680 * C20 - tmp679 * S20;
  double tmp712 = -0.1000000000e1 * tmp683 - 0.3673205103e-5 * tmp684 * S20 - 0.3673205103e-5 * tmp681 * C20;
  double tmp713 = -0.3673205103e-5 * tmp682 + 0.1000000000e1 * tmp680 * S20 + 0.1000000000e1 * tmp679 * C20;
  double tmp714 = -0.3673205103e-5 * tmp683 + 0.1000000000e1 * tmp684 * S20 + 0.1000000000e1 * tmp681 * C20;
  double tmp715 = tmp684 * C20 - tmp681 * S20;
  double tmp716 = -0.1256688890e-1 + tmp691;
  double tmp717 = -0.72051075e-5 + tmp692;
  double tmp718 = 0.4740184909e0 + tmp693;
  double tmp719 = 0.7668165533e-3 - 0.1000000000e1 * tmp712 - 0.3673205103e-5 * S20 * tmp710 - 0.3673205103e-5 * C20 * tmp707;
  double tmp720 = 0.7617710479e-6 - 0.1000000000e1 * tmp715 - 0.3673205103e-5 * S20 * tmp711 - 0.3673205103e-5 * C20 * tmp708 - tmp703;
  double tmp721 = 0.6369927847e-3 - 0.1000000000e1 * tmp714 - 0.3673205103e-5 * S20 * tmp713 - 0.3673205103e-5 * C20 * tmp709 - tmp705;
  double tmp722 = 0.7617710479e-6 + C20 * tmp710 - S20 * tmp707 - tmp703;
  double tmp723 = 0.1119065453e0 + C20 * tmp711 - S20 * tmp708 - 2 * tmp704;
  double tmp724 = 0.6369927847e-3 - 0.3673205103e-5 * tmp712 + 0.1000000000e1 * S20 * tmp710 + 0.1000000000e1 * C20 * tmp707 - tmp705;
  double tmp725 = -0.464950601e-7 + C20 * tmp713 - S20 * tmp709;
  double tmp726 = 0.1115014389e0 - 0.3673205103e-5 * tmp714 + 0.1000000000e1 * S20 * tmp713 + 0.1000000000e1 * C20 * tmp709 - 2 * tmp706;
  double tmp727 = -0.464950601e-7 - 0.3673205103e-5 * tmp715 + 0.1000000000e1 * S20 * tmp711 + 0.1000000000e1 * C20 * tmp708;
  double tmp728 = C20 * tmp685 - S20 * tmp686 + 0.25e0 * tmp700;
  double tmp729 = -0.3673205103e-5 * tmp683 + 0.1000000000e1 * S20 * tmp682 + 0.1000000000e1 * C20 * tmp678 - 0.25e0 * tmp702;
  double tmp730 = -0.1000000000e1 * tmp690 - 0.3673205103e-5 * S20 * tmp685 - 0.3673205103e-5 * C20 * tmp686;
  double tmp731 = -0.3673205103e-5 * tmp687 + 0.1000000000e1 * S20 * tmp688 + 0.1000000000e1 * C20 * tmp689 - 0.25e0 * tmp698;
  double tmp732 = C20 * tmp688 - S20 * tmp689 + 0.25e0 * tmp697;
  double tmp733 = -0.1000000000e1 * tmp687 - 0.3673205103e-5 * S20 * tmp688 - 0.3673205103e-5 * C20 * tmp689;
  double tmp734 = -0.3673205103e-5 * tmp690 + 0.1000000000e1 * S20 * tmp685 + 0.1000000000e1 * C20 * tmp686 - 0.25e0 * tmp694;
  double tmp735 = -0.1000000000e1 * tmp683 - 0.3673205103e-5 * S20 * tmp682 - 0.3673205103e-5 * C20 * tmp678;
  double tmp736 = C20 * tmp682 - S20 * tmp678 + 0.25e0 * tmp695;
  double tmp737 = -0.3673205103e-5 * tmp716 - 0.1000000000e1 * S19 * tmp717 - 0.1000000000e1 * C19 * tmp718;
  double tmp738 = C19 * tmp717 - S19 * tmp718;
  double tmp739 = 0.1000000000e1 * tmp716 - 0.3673205103e-5 * S19 * tmp717 - 0.3673205103e-5 * C19 * tmp718;
  double tmp740 = C19 * tmp694 - S19 * tmp696;
  double tmp741 = -0.3673205103e-5 * tmp695 - 0.1000000000e1 * S19 * tmp702 - 0.1000000000e1 * C19 * tmp701;
  double tmp742 = 0.1000000000e1 * tmp700 - 0.3673205103e-5 * S19 * tmp694 - 0.3673205103e-5 * C19 * tmp696;
  double tmp743 = -0.3673205103e-5 * tmp697 - 0.1000000000e1 * S19 * tmp698 - 0.1000000000e1 * C19 * tmp699;
  double tmp744 = C19 * tmp698 - S19 * tmp699;
  double tmp745 = 0.1000000000e1 * tmp697 - 0.3673205103e-5 * S19 * tmp698 - 0.3673205103e-5 * C19 * tmp699;
  double tmp746 = -0.3673205103e-5 * tmp700 - 0.1000000000e1 * S19 * tmp694 - 0.1000000000e1 * C19 * tmp696;
  double tmp747 = 0.1000000000e1 * S19 * tmp718 - 0.1000000000e1 * C19 * tmp717;
  double tmp748 = 0.3673205103e-5 * S19 * tmp718 - 0.3673205103e-5 * C19 * tmp717;
  double tmp749 = -C19 * tmp718 - S19 * tmp717;
  double tmp750 = 0.1000000000e1 * tmp695 - 0.3673205103e-5 * S19 * tmp702 - 0.3673205103e-5 * C19 * tmp701;
  double tmp751 = C19 * tmp702 - S19 * tmp701;
  double tmp752 = 0.25e0 * tmp737;
  double tmp753 = -0.25e0 * tmp739;
  double tmp754 = 0.25e0 * tmp737;
  double tmp755 = -0.25e0 * tmp738;
  double tmp756 = 0.1000000000e1 * tmp721 - 0.3673205103e-5 * tmp720 * S19 - 0.3673205103e-5 * tmp719 * C19;
  double tmp757 = tmp720 * C19 - tmp719 * S19;
  double tmp758 = -0.3673205103e-5 * tmp721 - 0.1000000000e1 * tmp720 * S19 - 0.1000000000e1 * tmp719 * C19;
  double tmp759 = 0.1000000000e1 * tmp725 - 0.3673205103e-5 * tmp723 * S19 - 0.3673205103e-5 * tmp722 * C19;
  double tmp760 = tmp723 * C19 - tmp722 * S19;
  double tmp761 = 0.1000000000e1 * tmp726 - 0.3673205103e-5 * tmp727 * S19 - 0.3673205103e-5 * tmp724 * C19;
  double tmp762 = -0.3673205103e-5 * tmp725 - 0.1000000000e1 * tmp723 * S19 - 0.1000000000e1 * tmp722 * C19;
  double tmp763 = -0.3673205103e-5 * tmp726 - 0.1000000000e1 * tmp727 * S19 - 0.1000000000e1 * tmp724 * C19;
  double tmp764 = tmp727 * C19 - tmp724 * S19;
  double tmp765 = -0.8864729709e0 + tmp737;
  double tmp766 = -0.8685296189e-2 + tmp738;
  double tmp767 = -0.7673345441e-2 + tmp739;
  double tmp768 = 0.2091842021e0 + 0.1000000000e1 * tmp761 - 0.3673205103e-5 * S19 * tmp759 - 0.3673205103e-5 * C19 * tmp756 - 2 * tmp752;
  double tmp769 = -0.9300179056e-4 + 0.1000000000e1 * tmp764 - 0.3673205103e-5 * S19 * tmp760 - 0.3673205103e-5 * C19 * tmp757;
  double tmp770 = -0.1142996500e-2 + 0.1000000000e1 * tmp763 - 0.3673205103e-5 * S19 * tmp762 - 0.3673205103e-5 * C19 * tmp758 - tmp753;
  double tmp771 = -0.9300179056e-4 + C19 * tmp759 - S19 * tmp756;
  double tmp772 = 0.2092006212e0 + C19 * tmp760 - S19 * tmp757 - 2 * tmp754;
  double tmp773 = -0.1142986500e-2 - 0.3673205103e-5 * tmp761 - 0.1000000000e1 * S19 * tmp759 - 0.1000000000e1 * C19 * tmp756 - tmp753;
  double tmp774 = -0.1648522746e-2 + C19 * tmp762 - S19 * tmp758 - tmp755;
  double tmp775 = 0.1437293893e-2 - 0.3673205103e-5 * tmp763 - 0.1000000000e1 * S19 * tmp762 - 0.1000000000e1 * C19 * tmp758;
  double tmp776 = -0.1648512746e-2 - 0.3673205103e-5 * tmp764 - 0.1000000000e1 * S19 * tmp760 - 0.1000000000e1 * C19 * tmp757 - tmp755;
  double tmp777 = C19 * tmp728 - S19 * tmp730 + 0.25e0 * tmp742;
  double tmp778 = -0.3673205103e-5 * tmp729 - 0.1000000000e1 * S19 * tmp736 - 0.1000000000e1 * C19 * tmp735;
  double tmp779 = 0.1000000000e1 * tmp734 - 0.3673205103e-5 * S19 * tmp728 - 0.3673205103e-5 * C19 * tmp730 - 0.25e0 * tmp740;
  double tmp780 = -0.3673205103e-5 * tmp731 - 0.1000000000e1 * S19 * tmp732 - 0.1000000000e1 * C19 * tmp733;
  double tmp781 = C19 * tmp732 - S19 * tmp733 + 0.25e0 * tmp745;
  double tmp782 = 0.1000000000e1 * tmp731 - 0.3673205103e-5 * S19 * tmp732 - 0.3673205103e-5 * C19 * tmp733 - 0.25e0 * tmp744;
  double tmp783 = -0.3673205103e-5 * tmp734 - 0.1000000000e1 * S19 * tmp728 - 0.1000000000e1 * C19 * tmp730;
  double tmp784 = -0.3673205103e-5 * tmp726 - 0.1000000000e1 * S19 * tmp725 - 0.1000000000e1 * C19 * tmp721;
  double tmp785 = 0.1000000000e1 * tmp726 - 0.3673205103e-5 * S19 * tmp725 - 0.3673205103e-5 * C19 * tmp721 - 0.25e0 * tmp749;
  double tmp786 = C19 * tmp725 - S19 * tmp721 + 0.25e0 * tmp748;
  double tmp787 = 0.1000000000e1 * tmp729 - 0.3673205103e-5 * S19 * tmp736 - 0.3673205103e-5 * C19 * tmp735 - 0.25e0 * tmp751;
  double tmp788 = C19 * tmp736 - S19 * tmp735 + 0.25e0 * tmp750;
  double tmp789 = -0.3673205103e-5 * tmp765 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp766 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp767;
  double tmp790 = cos(q[18] - 0.15708e1) * tmp766 - sin(q[18] - 0.15708e1) * tmp767;
  double tmp791 = 0.1000000000e1 * tmp765 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp766 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp767;
  double tmp792 = cos(q[18] - 0.15708e1) * tmp740 - sin(q[18] - 0.15708e1) * tmp742;
  double tmp793 = -0.3673205103e-5 * tmp741 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp751 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp750;
  double tmp794 = 0.1000000000e1 * tmp746 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp740 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp742;
  double tmp795 = -0.3673205103e-5 * tmp743 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp744 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp745;
  double tmp796 = -cos(q[18] - 0.15708e1) * tmp767 - sin(q[18] - 0.15708e1) * tmp766;
  double tmp797 = cos(q[18] - 0.15708e1) * tmp744 - sin(q[18] - 0.15708e1) * tmp745;
  double tmp798 = 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp767 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp766;
  double tmp799 = 0.1000000000e1 * tmp743 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp744 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp745;
  double tmp800 = -0.3673205103e-5 * tmp746 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp740 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp742;
  double tmp801 = -0.3673205103e-5 * tmp747 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp749 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp748;
  double tmp802 = 0.1000000000e1 * tmp747 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp749 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp748;
  double tmp803 = cos(q[18] - 0.15708e1) * tmp749 - sin(q[18] - 0.15708e1) * tmp748;
  double tmp804 = 0.1000000000e1 * tmp741 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp751 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp750;
  double tmp805 = 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp767 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp766;
  double tmp806 = cos(q[18] - 0.15708e1) * tmp751 - sin(q[18] - 0.15708e1) * tmp750;
  double tmp807 = 0.1000000000e1 * tmp770 - 0.3673205103e-5 * tmp769 * sin(q[18] - 0.15708e1) - 0.3673205103e-5 * tmp768 * cos(q[18] - 0.15708e1);
  double tmp808 = tmp769 * cos(q[18] - 0.15708e1) - tmp768 * sin(q[18] - 0.15708e1);
  double tmp809 = -0.3673205103e-5 * tmp770 - 0.1000000000e1 * tmp769 * sin(q[18] - 0.15708e1) - 0.1000000000e1 * tmp768 * cos(q[18] - 0.15708e1);
  double tmp810 = 0.1000000000e1 * tmp774 - 0.3673205103e-5 * tmp772 * sin(q[18] - 0.15708e1) - 0.3673205103e-5 * tmp771 * cos(q[18] - 0.15708e1);
  double tmp811 = tmp772 * cos(q[18] - 0.15708e1) - tmp771 * sin(q[18] - 0.15708e1);
  double tmp812 = 0.1000000000e1 * tmp775 - 0.3673205103e-5 * tmp776 * sin(q[18] - 0.15708e1) - 0.3673205103e-5 * tmp773 * cos(q[18] - 0.15708e1);
  double tmp813 = -0.3673205103e-5 * tmp774 - 0.1000000000e1 * tmp772 * sin(q[18] - 0.15708e1) - 0.1000000000e1 * tmp771 * cos(q[18] - 0.15708e1);
  double tmp814 = -0.3673205103e-5 * tmp775 - 0.1000000000e1 * tmp776 * sin(q[18] - 0.15708e1) - 0.1000000000e1 * tmp773 * cos(q[18] - 0.15708e1);
  double tmp815 = tmp776 * cos(q[18] - 0.15708e1) - tmp773 * sin(q[18] - 0.15708e1);
  double tmp816 = -0.1092886741e-1 + tmp789;
  double tmp817 = -0.1245824264e-1 + tmp790;
  double tmp818 = -0.9808484189e-2 + tmp791;
  double tmp819 = 0.1878683729e-2 + 0.1000000000e1 * tmp812 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp810 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp807;
  double tmp820 = 0.22864249e-5 + 0.1000000000e1 * tmp815 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp811 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp808;
  double tmp821 = -0.95527121e-5 + 0.1000000000e1 * tmp814 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp813 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp809;
  double tmp822 = 0.22864249e-5 + cos(q[18] - 0.15708e1) * tmp810 - sin(q[18] - 0.15708e1) * tmp807;
  double tmp823 = 0.1930618844e-2 + cos(q[18] - 0.15708e1) * tmp811 - sin(q[18] - 0.15708e1) * tmp808;
  double tmp824 = -0.95527121e-5 - 0.3673205103e-5 * tmp812 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp810 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp807;
  double tmp825 = 0.1495736498e-3 + cos(q[18] - 0.15708e1) * tmp813 - sin(q[18] - 0.15708e1) * tmp809;
  double tmp826 = 0.1464014347e-2 - 0.3673205103e-5 * tmp814 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp813 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp809;
  double tmp827 = 0.1495736498e-3 - 0.3673205103e-5 * tmp815 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp811 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp808;
  double tmp828 = cos(q[18] - 0.15708e1) * tmp777 - sin(q[18] - 0.15708e1) * tmp779;
  double tmp829 = -0.3673205103e-5 * tmp778 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp788 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp787;
  double tmp830 = 0.1000000000e1 * tmp783 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp777 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp779;
  double tmp831 = -0.3673205103e-5 * tmp780 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp781 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp782;
  double tmp832 = cos(q[18] - 0.15708e1) * tmp774 - sin(q[18] - 0.15708e1) * tmp770;
  double tmp833 = cos(q[18] - 0.15708e1) * tmp781 - sin(q[18] - 0.15708e1) * tmp782;
  double tmp834 = 0.1000000000e1 * tmp775 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp774 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp770;
  double tmp835 = 0.1000000000e1 * tmp780 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp781 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp782;
  double tmp836 = -0.3673205103e-5 * tmp783 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp777 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp779;
  double tmp837 = -0.3673205103e-5 * tmp784 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp786 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp785;
  double tmp838 = 0.1000000000e1 * tmp784 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp786 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp785;
  double tmp839 = cos(q[18] - 0.15708e1) * tmp786 - sin(q[18] - 0.15708e1) * tmp785;
  double tmp840 = 0.1000000000e1 * tmp778 - 0.3673205103e-5 * sin(q[18] - 0.15708e1) * tmp788 - 0.3673205103e-5 * cos(q[18] - 0.15708e1) * tmp787;
  double tmp841 = -0.3673205103e-5 * tmp775 - 0.1000000000e1 * sin(q[18] - 0.15708e1) * tmp774 - 0.1000000000e1 * cos(q[18] - 0.15708e1) * tmp770;
  double tmp842 = cos(q[18] - 0.15708e1) * tmp788 - sin(q[18] - 0.15708e1) * tmp787;
  double tmp843 = -0.3673205103e-5 * tmp816 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp817 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp818;
  double tmp844 = 0.1000000000e1 * tmp816 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp817 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp818;
  double tmp845 = sin(q[17] + 0.314159e1) * tmp817 + cos(q[17] + 0.314159e1) * tmp818;
  double tmp846 = 0.1000000000e1 * tmp800 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp792 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp794;
  double tmp847 = -0.3673205103e-5 * tmp793 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp806 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp804;
  double tmp848 = 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp818 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp817;
  double tmp849 = 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp818 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp817;
  double tmp850 = sin(q[17] + 0.314159e1) * tmp792 + cos(q[17] + 0.314159e1) * tmp794;
  double tmp851 = -0.3673205103e-5 * tmp795 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp797 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp799;
  double tmp852 = -sin(q[17] + 0.314159e1) * tmp818 + cos(q[17] + 0.314159e1) * tmp817;
  double tmp853 = 0.1000000000e1 * tmp805 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp796 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp798;
  double tmp854 = 0.1000000000e1 * tmp795 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp797 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp799;
  double tmp855 = sin(q[17] + 0.314159e1) * tmp796 + cos(q[17] + 0.314159e1) * tmp798;
  double tmp856 = sin(q[17] + 0.314159e1) * tmp797 + cos(q[17] + 0.314159e1) * tmp799;
  double tmp857 = -0.3673205103e-5 * tmp800 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp792 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp794;
  double tmp858 = -0.3673205103e-5 * tmp801 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp803 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp802;
  double tmp859 = sin(q[17] + 0.314159e1) * tmp803 + cos(q[17] + 0.314159e1) * tmp802;
  double tmp860 = 0.1000000000e1 * tmp801 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp803 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp802;
  double tmp861 = sin(q[17] + 0.314159e1) * tmp806 + cos(q[17] + 0.314159e1) * tmp804;
  double tmp862 = -0.3673205103e-5 * tmp805 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp796 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp798;
  double tmp863 = 0.1000000000e1 * tmp793 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp806 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp804;
  double tmp864 = tmp820 * sin(q[17] + 0.314159e1) + tmp819 * cos(q[17] + 0.314159e1);
  double tmp865 = 0.1000000000e1 * tmp821 - 0.3673205103e-5 * tmp820 * cos(q[17] + 0.314159e1) + 0.3673205103e-5 * tmp819 * sin(q[17] + 0.314159e1);
  double tmp866 = -0.3673205103e-5 * tmp821 - 0.1000000000e1 * tmp820 * cos(q[17] + 0.314159e1) + 0.1000000000e1 * tmp819 * sin(q[17] + 0.314159e1);
  double tmp867 = tmp823 * sin(q[17] + 0.314159e1) + tmp822 * cos(q[17] + 0.314159e1);
  double tmp868 = 0.1000000000e1 * tmp825 - 0.3673205103e-5 * tmp823 * cos(q[17] + 0.314159e1) + 0.3673205103e-5 * tmp822 * sin(q[17] + 0.314159e1);
  double tmp869 = tmp827 * sin(q[17] + 0.314159e1) + tmp824 * cos(q[17] + 0.314159e1);
  double tmp870 = -0.3673205103e-5 * tmp825 - 0.1000000000e1 * tmp823 * cos(q[17] + 0.314159e1) + 0.1000000000e1 * tmp822 * sin(q[17] + 0.314159e1);
  double tmp871 = -0.3673205103e-5 * tmp826 - 0.1000000000e1 * tmp827 * cos(q[17] + 0.314159e1) + 0.1000000000e1 * tmp824 * sin(q[17] + 0.314159e1);
  double tmp872 = 0.1000000000e1 * tmp826 - 0.3673205103e-5 * tmp827 * cos(q[17] + 0.314159e1) + 0.3673205103e-5 * tmp824 * sin(q[17] + 0.314159e1);
  double tmp873 = 0.3763013640e-1 + tmp843;
  double tmp874 = -0.8015280780e-2 + tmp844;
  double tmp875 = 0.1240712402e-3 + tmp845;
  double tmp876 = 0.5275044709e-2 + sin(q[17] + 0.314159e1) * tmp867 + cos(q[17] + 0.314159e1) * tmp864;
  double tmp877 = -0.242379595e-6 + sin(q[17] + 0.314159e1) * tmp868 + cos(q[17] + 0.314159e1) * tmp865;
  double tmp878 = -0.5243343169e-4 + sin(q[17] + 0.314159e1) * tmp870 + cos(q[17] + 0.314159e1) * tmp866;
  double tmp879 = -0.242379595e-6 + 0.1000000000e1 * tmp869 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp867 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp864;
  double tmp880 = 0.3959186677e-2 + 0.1000000000e1 * tmp872 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp868 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp865;
  double tmp881 = -0.5243343169e-4 - 0.3673205103e-5 * tmp869 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp867 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp864;
  double tmp882 = 0.680906319e-4 + 0.1000000000e1 * tmp871 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp870 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp866;
  double tmp883 = 0.1921216038e-2 - 0.3673205103e-5 * tmp871 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp870 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp866;
  double tmp884 = 0.680906319e-4 - 0.3673205103e-5 * tmp872 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp868 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp865;
  double tmp885 = 0.1000000000e1 * tmp836 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp828 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp830;
  double tmp886 = -0.3673205103e-5 * tmp829 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp842 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp840;
  double tmp887 = 0.1000000000e1 * tmp826 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp825 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp821;
  double tmp888 = -0.3673205103e-5 * tmp826 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp825 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp821;
  double tmp889 = sin(q[17] + 0.314159e1) * tmp828 + cos(q[17] + 0.314159e1) * tmp830;
  double tmp890 = -0.3673205103e-5 * tmp831 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp833 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp835;
  double tmp891 = sin(q[17] + 0.314159e1) * tmp825 + cos(q[17] + 0.314159e1) * tmp821;
  double tmp892 = 0.1000000000e1 * tmp841 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp832 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp834;
  double tmp893 = 0.1000000000e1 * tmp831 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp833 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp835;
  double tmp894 = sin(q[17] + 0.314159e1) * tmp832 + cos(q[17] + 0.314159e1) * tmp834;
  double tmp895 = sin(q[17] + 0.314159e1) * tmp833 + cos(q[17] + 0.314159e1) * tmp835;
  double tmp896 = -0.3673205103e-5 * tmp836 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp828 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp830;
  double tmp897 = -0.3673205103e-5 * tmp837 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp839 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp838;
  double tmp898 = sin(q[17] + 0.314159e1) * tmp839 + cos(q[17] + 0.314159e1) * tmp838;
  double tmp899 = 0.1000000000e1 * tmp837 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp839 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp838;
  double tmp900 = sin(q[17] + 0.314159e1) * tmp842 + cos(q[17] + 0.314159e1) * tmp840;
  double tmp901 = -0.3673205103e-5 * tmp841 - 0.1000000000e1 * cos(q[17] + 0.314159e1) * tmp832 + 0.1000000000e1 * sin(q[17] + 0.314159e1) * tmp834;
  double tmp902 = 0.1000000000e1 * tmp829 - 0.3673205103e-5 * cos(q[17] + 0.314159e1) * tmp842 + 0.3673205103e-5 * sin(q[17] + 0.314159e1) * tmp840;
  double tmp903 = C16 * tmp874 - S16 * tmp875;
  double tmp904 = S16 * tmp874 + C16 * tmp875;
  double tmp905 = C16 * tmp874 - S16 * tmp875;
  double tmp906 = C16 * tmp846 - S16 * tmp850;
  double tmp907 = C16 * tmp848 - S16 * tmp852;
  double tmp908 = S16 * tmp846 + C16 * tmp850;
  double tmp909 = -S16 * tmp874 - C16 * tmp875;
  double tmp910 = S16 * tmp848 + C16 * tmp852;
  double tmp911 = C16 * tmp853 - S16 * tmp855;
  double tmp912 = C16 * tmp854 - S16 * tmp856;
  double tmp913 = S16 * tmp853 + C16 * tmp855;
  double tmp914 = S16 * tmp854 + C16 * tmp856;
  double tmp915 = S16 * tmp860 + C16 * tmp859;
  double tmp916 = C16 * tmp860 - S16 * tmp859;
  double tmp917 = S16 * tmp863 + C16 * tmp861;
  double tmp918 = C16 * tmp863 - S16 * tmp861;
  double tmp919 = -0.8e-2 * tmp903 + 0.25e0 * tmp873;
  double tmp920 = 0.8e-2 * tmp904;
  double tmp921 = -0.25e0 * tmp904;
  double tmp922 = -0.181e0 * tmp903;
  double tmp923 = 0.181e0 * tmp904 + 0.25e0 * tmp873;
  double tmp924 = -0.181e0 * tmp873;
  double tmp925 = -0.25e0 * tmp903;
  double tmp926 = 0.181e0 * tmp904 - 0.8e-2 * tmp903;
  double tmp927 = 0.8e-2 * tmp873;
  double tmp928 = tmp877 * S16 + tmp876 * C16;
  double tmp929 = tmp877 * C16 - tmp876 * S16;
  double tmp930 = tmp880 * S16 + tmp879 * C16;
  double tmp931 = tmp880 * C16 - tmp879 * S16;
  double tmp932 = tmp884 * S16 + tmp881 * C16;
  double tmp933 = tmp884 * C16 - tmp881 * S16;
  double tmp934 = tmp600 + tmp873 - 0.148055775e1;
  double tmp935 = tmp601 + tmp903 + 0.47377848e-1;
  double tmp936 = tmp602 + tmp904 - 0.1071923811e1;
  double tmp937 = tmp603 + S16 * tmp930 + C16 * tmp928 + 0.3705184603e0 - 2 * tmp919;
  double tmp938 = tmp604 + S16 * tmp931 + C16 * tmp929 + 0.8575390488e-2 - tmp920 - tmp922;
  double tmp939 = tmp605 + S16 * tmp882 + C16 * tmp878 - 0.2679809528e0 - tmp921 - tmp924;
  double tmp940 = tmp606 + C16 * tmp930 - S16 * tmp928 + 0.8575390488e-2 - tmp922 - tmp920;
  double tmp941 = tmp607 + C16 * tmp931 - S16 * tmp929 + 0.5641576473e0 - 2 * tmp923;
  double tmp942 = tmp608 + tmp932 - 0.2679809528e0 - tmp924 - tmp921;
  double tmp943 = tmp609 + C16 * tmp882 - S16 * tmp878 + 0.1184446200e-1 - tmp925 - tmp927;
  double tmp944 = tmp610 + tmp883 + 0.1943972326e0 - 2 * tmp926;
  double tmp945 = tmp611 + tmp933 + 0.1184446200e-1 - tmp927 - tmp925;
  double tmp946 = S16 * tmp882 + C16 * tmp878 - 0.25e0 * tmp909;
  double tmp947 = C16 * tmp885 - S16 * tmp889 - 0.181e0 * tmp857 + 0.25e0 * tmp908;
  double tmp948 = tmp886 + 0.181e0 * tmp918 + 0.8e-2 * tmp917;
  double tmp949 = C16 * tmp887 - S16 * tmp891 - 0.181e0 * tmp849 + 0.25e0 * tmp910;
  double tmp950 = tmp888 + 0.181e0 * tmp907 + 0.8e-2 * tmp910;
  double tmp951 = S16 * tmp885 + C16 * tmp889 - 0.8e-2 * tmp857 - 0.25e0 * tmp906;
  double tmp952 = tmp890 + 0.181e0 * tmp912 + 0.8e-2 * tmp914;
  double tmp953 = C16 * tmp882 - S16 * tmp878 + 0.25e0 * tmp905;
  double tmp954 = S16 * tmp887 + C16 * tmp891 - 0.8e-2 * tmp849 - 0.25e0 * tmp907;
  double tmp955 = C16 * tmp892 - S16 * tmp894 - 0.181e0 * tmp862 + 0.25e0 * tmp913;
  double tmp956 = C16 * tmp893 - S16 * tmp895 - 0.181e0 * tmp851 + 0.25e0 * tmp914;
  double tmp957 = S16 * tmp892 + C16 * tmp894 - 0.8e-2 * tmp862 - 0.25e0 * tmp911;
  double tmp958 = S16 * tmp893 + C16 * tmp895 - 0.8e-2 * tmp851 - 0.25e0 * tmp912;
  double tmp959 = tmp883 + 0.181e0 * tmp909 + 0.8e-2 * tmp905;
  double tmp960 = tmp896 + 0.181e0 * tmp906 + 0.8e-2 * tmp908;
  double tmp961 = tmp897 + 0.181e0 * tmp916 + 0.8e-2 * tmp915;
  double tmp962 = S16 * tmp899 + C16 * tmp898 - 0.8e-2 * tmp858 - 0.25e0 * tmp916;
  double tmp963 = C16 * tmp899 - S16 * tmp898 - 0.181e0 * tmp858 + 0.25e0 * tmp915;
  double tmp964 = S16 * tmp902 + C16 * tmp900 - 0.8e-2 * tmp847 - 0.25e0 * tmp918;
  double tmp965 = tmp901 + 0.181e0 * tmp911 + 0.8e-2 * tmp913;
  double tmp966 = C16 * tmp902 - S16 * tmp900 - 0.181e0 * tmp847 + 0.25e0 * tmp917;
  double tmp967 = -0.7772649316e-8 - 0.7187638876e-3 * cos(q[29] + 0.314159e1) - 0.9188905377e-2 * sin(q[29] + 0.314159e1);
  double tmp968 = 0.2116040106e-2 - 0.2640167180e-8 * cos(q[29] + 0.314159e1) - 0.3375273412e-7 * sin(q[29] + 0.314159e1);
  double tmp969 = 0.7187638876e-3 * sin(q[29] + 0.314159e1) - 0.9188905377e-2 * cos(q[29] + 0.314159e1);
  double tmp970 = 0.7187638876e-3 * sin(q[29] + 0.314159e1) - 0.9188905377e-2 * cos(q[29] + 0.314159e1);
  double tmp971 = -0.3375273412e-7 * cos(q[29] + 0.314159e1) + 0.2640167180e-8 * sin(q[29] + 0.314159e1);
  double tmp972 = 0.9188905377e-2 * sin(q[29] + 0.314159e1) + 0.7187638876e-3 * cos(q[29] + 0.314159e1);
  double tmp973 = 0.2e-1 * tmp967;
  double tmp974 = -0.2e-1 * tmp969;
  double tmp975 = 0.95e-1 * tmp968;
  double tmp976 = -0.95e-1 * tmp969 + 0.2e-1 * tmp967;
  double tmp977 = 0.95e-1 * tmp967;
  double tmp978 = -0.2e-1 * tmp968;
  double tmp979 = -0.95e-1 * tmp969;
  double tmp980 = 0.4846081086e-4 * sin(q[29] + 0.314159e1) + 0.1068540576e-3 * cos(q[29] + 0.314159e1);
  double tmp981 = 0.1009090221e-3 - 0.1780064977e-9 * cos(q[29] + 0.314159e1) + 0.3924968697e-9 * sin(q[29] + 0.314159e1);
  double tmp982 = -0.3706595349e-9 - 0.4846081086e-4 * cos(q[29] + 0.314159e1) + 0.1068540576e-3 * sin(q[29] + 0.314159e1);
  double tmp983 = 0.7390581571e-3 * sin(q[29] + 0.314159e1) + 0.4846081086e-4 * cos(q[29] + 0.314159e1);
  double tmp984 = -0.5091515060e-6 - 0.2714712194e-8 * cos(q[29] + 0.314159e1) + 0.1780064977e-9 * sin(q[29] + 0.314159e1);
  double tmp985 = -0.509151506e-6 * sin(q[29] + 0.314159e1) + 0.1009090221e-3 * cos(q[29] + 0.314159e1);
  double tmp986 = 0.1870217910e-11 - 0.7390581571e-3 * cos(q[29] + 0.314159e1) + 0.4846081086e-4 * sin(q[29] + 0.314159e1);
  double tmp987 = -0.2482293117e-8 + 0.5091515060e-6 * cos(q[29] + 0.314159e1) + 0.1009090221e-3 * sin(q[29] + 0.314159e1);
  double tmp988 = 0.6757839673e-3 + 0.1870217910e-11 * cos(q[29] + 0.314159e1) + 0.3706595349e-9 * sin(q[29] + 0.314159e1);
  double tmp989 = -0.1029233145e-2 + tmp967;
  double tmp990 = 0.2024462280e-2 + tmp968;
  double tmp991 = 0.9792184733e-1 + tmp969;
  double tmp992 = 0.8522984760e-3 + sin(q[29] + 0.314159e1) * tmp983 + cos(q[29] + 0.314159e1) * tmp980 - 2 * tmp973;
  double tmp993 = -0.2429123485e-3 + sin(q[29] + 0.314159e1) * tmp984 + cos(q[29] + 0.314159e1) * tmp981 - tmp975;
  double tmp994 = -0.1125579025e-3 + sin(q[29] + 0.314159e1) * tmp986 + cos(q[29] + 0.314159e1) * tmp982 - tmp974 - tmp977;
  double tmp995 = -0.2429123485e-3 + 0.1000000000e1 * tmp985 - 0.3673205103e-5 * cos(q[29] + 0.314159e1) * tmp983 + 0.3673205103e-5 * sin(q[29] + 0.314159e1) * tmp980 - tmp975;
  double tmp996 = 0.1094083385e-1 + 0.1000000000e1 * tmp988 - 0.3673205103e-5 * cos(q[29] + 0.314159e1) * tmp984 + 0.3673205103e-5 * sin(q[29] + 0.314159e1) * tmp981 - 2 * tmp976;
  double tmp997 = -0.1125579025e-3 - 0.3673205103e-5 * tmp985 - 0.1000000000e1 * cos(q[29] + 0.314159e1) * tmp983 + 0.1000000000e1 * sin(q[29] + 0.314159e1) * tmp980 - tmp977 - tmp974;
  double tmp998 = -0.2323430947e-4 + 0.1000000000e1 * tmp987 - 0.3673205103e-5 * cos(q[29] + 0.314159e1) * tmp986 + 0.3673205103e-5 * sin(q[29] + 0.314159e1) * tmp982 - tmp978;
  double tmp999 = 0.1093925084e-1 - 0.3673205103e-5 * tmp987 - 0.1000000000e1 * cos(q[29] + 0.314159e1) * tmp986 + 0.1000000000e1 * sin(q[29] + 0.314159e1) * tmp982 - 2 * tmp979;
  double tmp1000 = -0.2323430947e-4 - 0.3673205103e-5 * tmp988 - 0.1000000000e1 * cos(q[29] + 0.314159e1) * tmp984 + 0.1000000000e1 * sin(q[29] + 0.314159e1) * tmp981 - tmp978;
  double tmp1001 = -0.2482293117e-8 + 0.5091515060e-6 * cos(q[29] + 0.314159e1) + 0.1009090221e-3 * sin(q[29] + 0.314159e1) - 0.95e-1 * tmp971;
  double tmp1002 = 0.6757839673e-3 + 0.1870217910e-11 * cos(q[29] + 0.314159e1) + 0.3706595349e-9 * sin(q[29] + 0.314159e1) + 0.95e-1 * tmp970 + 0.2e-1 * tmp972;
  double tmp1003 = -0.509151506e-6 * sin(q[29] + 0.314159e1) + 0.1009090221e-3 * cos(q[29] + 0.314159e1) - 0.2e-1 * tmp971;
  double tmp1004 = -0.3673205103e-5 * tmp989 - 0.1000000000e1 * S28 * tmp990 - 0.1000000000e1 * C28 * tmp991;
  double tmp1005 = C28 * tmp990 - S28 * tmp991;
  double tmp1006 = 0.1000000000e1 * tmp989 - 0.3673205103e-5 * S28 * tmp990 - 0.3673205103e-5 * C28 * tmp991;
  double tmp1007 = 0.3673205103e-5 * S28 * tmp991 - 0.3673205103e-5 * C28 * tmp990;
  double tmp1008 = -C28 * tmp991 - S28 * tmp990;
  double tmp1009 = 0.1000000000e1 * S28 * tmp991 - 0.1000000000e1 * C28 * tmp990;
  double tmp1010 = -0.3673205103e-5 * tmp970 - 0.1000000000e1 * S28 * tmp971 - 0.1000000000e1 * C28 * tmp972;
  double tmp1011 = C28 * tmp971 - S28 * tmp972;
  double tmp1012 = 0.1000000000e1 * tmp970 - 0.3673205103e-5 * S28 * tmp971 - 0.3673205103e-5 * C28 * tmp972;
  double tmp1013 = 0.1000000000e1 * tmp994 - 0.3673205103e-5 * tmp993 * S28 - 0.3673205103e-5 * tmp992 * C28;
  double tmp1014 = tmp993 * C28 - tmp992 * S28;
  double tmp1015 = -0.3673205103e-5 * tmp994 - 0.1000000000e1 * tmp993 * S28 - 0.1000000000e1 * tmp992 * C28;
  double tmp1016 = 0.1000000000e1 * tmp998 - 0.3673205103e-5 * tmp996 * S28 - 0.3673205103e-5 * tmp995 * C28;
  double tmp1017 = tmp996 * C28 - tmp995 * S28;
  double tmp1018 = 0.1000000000e1 * tmp999 - 0.3673205103e-5 * tmp1000 * S28 - 0.3673205103e-5 * tmp997 * C28;
  double tmp1019 = -0.3673205103e-5 * tmp998 - 0.1000000000e1 * tmp996 * S28 - 0.1000000000e1 * tmp995 * C28;
  double tmp1020 = -0.3673205103e-5 * tmp999 - 0.1000000000e1 * tmp1000 * S28 - 0.1000000000e1 * tmp997 * C28;
  double tmp1021 = tmp1000 * C28 - tmp997 * S28;
  double tmp1022 = 0.2301648936e-1 + tmp1004;
  double tmp1023 = -0.1912848153e-2 + tmp1005;
  double tmp1024 = 0.2006565028e-2 + tmp1006;
  double tmp1025 = 0.2160886646e-2 + 0.1000000000e1 * tmp1018 - 0.3673205103e-5 * S28 * tmp1016 - 0.3673205103e-5 * C28 * tmp1013;
  double tmp1026 = 0.2337990035e-4 + 0.1000000000e1 * tmp1021 - 0.3673205103e-5 * S28 * tmp1017 - 0.3673205103e-5 * C28 * tmp1014;
  double tmp1027 = -0.2028542217e-3 + 0.1000000000e1 * tmp1020 - 0.3673205103e-5 * S28 * tmp1019 - 0.3673205103e-5 * C28 * tmp1015;
  double tmp1028 = 0.2337990035e-4 + C28 * tmp1016 - S28 * tmp1013;
  double tmp1029 = 0.2283388870e-2 + C28 * tmp1017 - S28 * tmp1014;
  double tmp1030 = -0.2028542217e-3 - 0.3673205103e-5 * tmp1018 - 0.1000000000e1 * S28 * tmp1016 - 0.1000000000e1 * C28 * tmp1013;
  double tmp1031 = 0.3277535568e-4 + C28 * tmp1019 - S28 * tmp1015;
  double tmp1032 = 0.3310056351e-3 - 0.3673205103e-5 * tmp1020 - 0.1000000000e1 * S28 * tmp1019 - 0.1000000000e1 * C28 * tmp1015;
  double tmp1033 = 0.3277535568e-4 - 0.3673205103e-5 * tmp1021 - 0.1000000000e1 * S28 * tmp1017 - 0.1000000000e1 * C28 * tmp1014;
  double tmp1034 = 0.1000000000e1 * tmp999 - 0.3673205103e-5 * S28 * tmp998 - 0.3673205103e-5 * C28 * tmp994;
  double tmp1035 = C28 * tmp998 - S28 * tmp994;
  double tmp1036 = -0.3673205103e-5 * tmp999 - 0.1000000000e1 * S28 * tmp998 - 0.1000000000e1 * C28 * tmp994;
  double tmp1037 = -0.3673205103e-5 * tmp1001 - 0.1000000000e1 * S28 * tmp1002 - 0.1000000000e1 * C28 * tmp1003;
  double tmp1038 = C28 * tmp1002 - S28 * tmp1003;
  double tmp1039 = 0.1000000000e1 * tmp1001 - 0.3673205103e-5 * S28 * tmp1002 - 0.3673205103e-5 * C28 * tmp1003;
  double tmp1040 = -0.3673205103e-5 * tmp1022 + 0.1000000000e1 * S27 * tmp1023 + 0.1000000000e1 * C27 * tmp1024;
  double tmp1041 = C27 * tmp1023 - S27 * tmp1024;
  double tmp1042 = -0.1000000000e1 * tmp1022 - 0.3673205103e-5 * S27 * tmp1023 - 0.3673205103e-5 * C27 * tmp1024;
  double tmp1043 = 0.3673205103e-5 * S27 * tmp1024 - 0.3673205103e-5 * C27 * tmp1023;
  double tmp1044 = -C27 * tmp1024 - S27 * tmp1023;
  double tmp1045 = -0.1000000000e1 * tmp1009 - 0.3673205103e-5 * S27 * tmp1008 - 0.3673205103e-5 * C27 * tmp1007;
  double tmp1046 = C27 * tmp1008 - S27 * tmp1007;
  double tmp1047 = -0.3673205103e-5 * tmp1009 + 0.1000000000e1 * S27 * tmp1008 + 0.1000000000e1 * C27 * tmp1007;
  double tmp1048 = -0.3673205103e-5 * tmp1010 + 0.1000000000e1 * S27 * tmp1011 + 0.1000000000e1 * C27 * tmp1012;
  double tmp1049 = -0.1000000000e1 * S27 * tmp1024 + 0.1000000000e1 * C27 * tmp1023;
  double tmp1050 = C27 * tmp1011 - S27 * tmp1012;
  double tmp1051 = -0.1000000000e1 * tmp1010 - 0.3673205103e-5 * S27 * tmp1011 - 0.3673205103e-5 * C27 * tmp1012;
  double tmp1052 = 0.25e0 * tmp1041;
  double tmp1053 = -0.25e0 * tmp1042;
  double tmp1054 = 0.25e0 * tmp1040;
  double tmp1055 = -0.25e0 * tmp1042;
  double tmp1056 = -0.1000000000e1 * tmp1027 - 0.3673205103e-5 * tmp1026 * S27 - 0.3673205103e-5 * tmp1025 * C27;
  double tmp1057 = tmp1026 * C27 - tmp1025 * S27;
  double tmp1058 = -0.3673205103e-5 * tmp1027 + 0.1000000000e1 * tmp1026 * S27 + 0.1000000000e1 * tmp1025 * C27;
  double tmp1059 = -0.1000000000e1 * tmp1031 - 0.3673205103e-5 * tmp1029 * S27 - 0.3673205103e-5 * tmp1028 * C27;
  double tmp1060 = tmp1029 * C27 - tmp1028 * S27;
  double tmp1061 = -0.1000000000e1 * tmp1032 - 0.3673205103e-5 * tmp1033 * S27 - 0.3673205103e-5 * tmp1030 * C27;
  double tmp1062 = -0.3673205103e-5 * tmp1031 + 0.1000000000e1 * tmp1029 * S27 + 0.1000000000e1 * tmp1028 * C27;
  double tmp1063 = -0.3673205103e-5 * tmp1032 + 0.1000000000e1 * tmp1033 * S27 + 0.1000000000e1 * tmp1030 * C27;
  double tmp1064 = tmp1033 * C27 - tmp1030 * S27;
  double tmp1065 = 0.1256688890e-1 + tmp1040;
  double tmp1066 = -0.72051075e-5 + tmp1041;
  double tmp1067 = 0.4740184909e0 + tmp1042;
  double tmp1068 = 0.7668165533e-3 - 0.1000000000e1 * tmp1061 - 0.3673205103e-5 * S27 * tmp1059 - 0.3673205103e-5 * C27 * tmp1056;
  double tmp1069 = 0.7617710479e-6 - 0.1000000000e1 * tmp1064 - 0.3673205103e-5 * S27 * tmp1060 - 0.3673205103e-5 * C27 * tmp1057 - tmp1052;
  double tmp1070 = -0.6369927847e-3 - 0.1000000000e1 * tmp1063 - 0.3673205103e-5 * S27 * tmp1062 - 0.3673205103e-5 * C27 * tmp1058 - tmp1054;
  double tmp1071 = 0.7617710479e-6 + C27 * tmp1059 - S27 * tmp1056 - tmp1052;
  double tmp1072 = 0.1119065453e0 + C27 * tmp1060 - S27 * tmp1057 - 2 * tmp1053;
  double tmp1073 = -0.6369927847e-3 - 0.3673205103e-5 * tmp1061 + 0.1000000000e1 * S27 * tmp1059 + 0.1000000000e1 * C27 * tmp1056 - tmp1054;
  double tmp1074 = 0.464950601e-7 + C27 * tmp1062 - S27 * tmp1058;
  double tmp1075 = 0.1115014389e0 - 0.3673205103e-5 * tmp1063 + 0.1000000000e1 * S27 * tmp1062 + 0.1000000000e1 * C27 * tmp1058 - 2 * tmp1055;
  double tmp1076 = 0.464950601e-7 - 0.3673205103e-5 * tmp1064 + 0.1000000000e1 * S27 * tmp1060 + 0.1000000000e1 * C27 * tmp1057;
  double tmp1077 = -0.1000000000e1 * tmp1032 - 0.3673205103e-5 * S27 * tmp1031 - 0.3673205103e-5 * C27 * tmp1027;
  double tmp1078 = C27 * tmp1031 - S27 * tmp1027 + 0.25e0 * tmp1049;
  double tmp1079 = -0.1000000000e1 * tmp1036 - 0.3673205103e-5 * S27 * tmp1035 - 0.3673205103e-5 * C27 * tmp1034;
  double tmp1080 = C27 * tmp1035 - S27 * tmp1034 + 0.25e0 * tmp1047;
  double tmp1081 = -0.3673205103e-5 * tmp1036 + 0.1000000000e1 * S27 * tmp1035 + 0.1000000000e1 * C27 * tmp1034 - 0.25e0 * tmp1046;
  double tmp1082 = -0.3673205103e-5 * tmp1037 + 0.1000000000e1 * S27 * tmp1038 + 0.1000000000e1 * C27 * tmp1039 - 0.25e0 * tmp1050;
  double tmp1083 = -0.3673205103e-5 * tmp1032 + 0.1000000000e1 * S27 * tmp1031 + 0.1000000000e1 * C27 * tmp1027 - 0.25e0 * tmp1044;
  double tmp1084 = C27 * tmp1038 - S27 * tmp1039 + 0.25e0 * tmp1048;
  double tmp1085 = -0.1000000000e1 * tmp1037 - 0.3673205103e-5 * S27 * tmp1038 - 0.3673205103e-5 * C27 * tmp1039;
  double tmp1086 = -0.3673205103e-5 * tmp1065 - 0.1000000000e1 * S26 * tmp1066 - 0.1000000000e1 * C26 * tmp1067;
  double tmp1087 = C26 * tmp1066 - S26 * tmp1067;
  double tmp1088 = 0.1000000000e1 * tmp1065 - 0.3673205103e-5 * S26 * tmp1066 - 0.3673205103e-5 * C26 * tmp1067;
  double tmp1089 = 0.1000000000e1 * tmp1049 - 0.3673205103e-5 * S26 * tmp1044 - 0.3673205103e-5 * C26 * tmp1043;
  double tmp1090 = 0.1000000000e1 * S26 * tmp1067 - 0.1000000000e1 * C26 * tmp1066;
  double tmp1091 = C26 * tmp1044 - S26 * tmp1043;
  double tmp1092 = 0.1000000000e1 * tmp1047 - 0.3673205103e-5 * S26 * tmp1046 - 0.3673205103e-5 * C26 * tmp1045;
  double tmp1093 = C26 * tmp1046 - S26 * tmp1045;
  double tmp1094 = -0.3673205103e-5 * tmp1047 - 0.1000000000e1 * S26 * tmp1046 - 0.1000000000e1 * C26 * tmp1045;
  double tmp1095 = -0.3673205103e-5 * tmp1048 - 0.1000000000e1 * S26 * tmp1050 - 0.1000000000e1 * C26 * tmp1051;
  double tmp1096 = -0.3673205103e-5 * tmp1049 - 0.1000000000e1 * S26 * tmp1044 - 0.1000000000e1 * C26 * tmp1043;
  double tmp1097 = -C26 * tmp1067 - S26 * tmp1066;
  double tmp1098 = 0.3673205103e-5 * S26 * tmp1067 - 0.3673205103e-5 * C26 * tmp1066;
  double tmp1099 = C26 * tmp1050 - S26 * tmp1051;
  double tmp1100 = 0.1000000000e1 * tmp1048 - 0.3673205103e-5 * S26 * tmp1050 - 0.3673205103e-5 * C26 * tmp1051;
  double tmp1101 = 0.25e0 * tmp1086;
  double tmp1102 = -0.25e0 * tmp1088;
  double tmp1103 = 0.25e0 * tmp1086;
  double tmp1104 = -0.25e0 * tmp1087;
  double tmp1105 = 0.1000000000e1 * tmp1070 - 0.3673205103e-5 * tmp1069 * S26 - 0.3673205103e-5 * tmp1068 * C26;
  double tmp1106 = tmp1069 * C26 - tmp1068 * S26;
  double tmp1107 = -0.3673205103e-5 * tmp1070 - 0.1000000000e1 * tmp1069 * S26 - 0.1000000000e1 * tmp1068 * C26;
  double tmp1108 = 0.1000000000e1 * tmp1074 - 0.3673205103e-5 * tmp1072 * S26 - 0.3673205103e-5 * tmp1071 * C26;
  double tmp1109 = tmp1072 * C26 - tmp1071 * S26;
  double tmp1110 = 0.1000000000e1 * tmp1075 - 0.3673205103e-5 * tmp1076 * S26 - 0.3673205103e-5 * tmp1073 * C26;
  double tmp1111 = -0.3673205103e-5 * tmp1074 - 0.1000000000e1 * tmp1072 * S26 - 0.1000000000e1 * tmp1071 * C26;
  double tmp1112 = -0.3673205103e-5 * tmp1075 - 0.1000000000e1 * tmp1076 * S26 - 0.1000000000e1 * tmp1073 * C26;
  double tmp1113 = tmp1076 * C26 - tmp1073 * S26;
  double tmp1114 = -0.8864729709e0 + tmp1086;
  double tmp1115 = -0.8685296189e-2 + tmp1087;
  double tmp1116 = 0.7673345441e-2 + tmp1088;
  double tmp1117 = 0.2091842021e0 + 0.1000000000e1 * tmp1110 - 0.3673205103e-5 * S26 * tmp1108 - 0.3673205103e-5 * C26 * tmp1105 - 2 * tmp1101;
  double tmp1118 = 0.9300179056e-4 + 0.1000000000e1 * tmp1113 - 0.3673205103e-5 * S26 * tmp1109 - 0.3673205103e-5 * C26 * tmp1106;
  double tmp1119 = 0.1142996500e-2 + 0.1000000000e1 * tmp1112 - 0.3673205103e-5 * S26 * tmp1111 - 0.3673205103e-5 * C26 * tmp1107 - tmp1102;
  double tmp1120 = 0.9300179056e-4 + C26 * tmp1108 - S26 * tmp1105;
  double tmp1121 = 0.2092006212e0 + C26 * tmp1109 - S26 * tmp1106 - 2 * tmp1103;
  double tmp1122 = 0.1142986500e-2 - 0.3673205103e-5 * tmp1110 - 0.1000000000e1 * S26 * tmp1108 - 0.1000000000e1 * C26 * tmp1105 - tmp1102;
  double tmp1123 = -0.1648522746e-2 + C26 * tmp1111 - S26 * tmp1107 - tmp1104;
  double tmp1124 = 0.1437293893e-2 - 0.3673205103e-5 * tmp1112 - 0.1000000000e1 * S26 * tmp1111 - 0.1000000000e1 * C26 * tmp1107;
  double tmp1125 = -0.1648512746e-2 - 0.3673205103e-5 * tmp1113 - 0.1000000000e1 * S26 * tmp1109 - 0.1000000000e1 * C26 * tmp1106 - tmp1104;
  double tmp1126 = 0.1000000000e1 * tmp1083 - 0.3673205103e-5 * S26 * tmp1078 - 0.3673205103e-5 * C26 * tmp1077 - 0.25e0 * tmp1091;
  double tmp1127 = -0.3673205103e-5 * tmp1075 - 0.1000000000e1 * S26 * tmp1074 - 0.1000000000e1 * C26 * tmp1070;
  double tmp1128 = C26 * tmp1078 - S26 * tmp1077 + 0.25e0 * tmp1089;
  double tmp1129 = 0.1000000000e1 * tmp1081 - 0.3673205103e-5 * S26 * tmp1080 - 0.3673205103e-5 * C26 * tmp1079 - 0.25e0 * tmp1093;
  double tmp1130 = C26 * tmp1080 - S26 * tmp1079 + 0.25e0 * tmp1092;
  double tmp1131 = -0.3673205103e-5 * tmp1081 - 0.1000000000e1 * S26 * tmp1080 - 0.1000000000e1 * C26 * tmp1079;
  double tmp1132 = -0.3673205103e-5 * tmp1082 - 0.1000000000e1 * S26 * tmp1084 - 0.1000000000e1 * C26 * tmp1085;
  double tmp1133 = -0.3673205103e-5 * tmp1083 - 0.1000000000e1 * S26 * tmp1078 - 0.1000000000e1 * C26 * tmp1077;
  double tmp1134 = C26 * tmp1074 - S26 * tmp1070 + 0.25e0 * tmp1098;
  double tmp1135 = 0.1000000000e1 * tmp1075 - 0.3673205103e-5 * S26 * tmp1074 - 0.3673205103e-5 * C26 * tmp1070 - 0.25e0 * tmp1097;
  double tmp1136 = C26 * tmp1084 - S26 * tmp1085 + 0.25e0 * tmp1100;
  double tmp1137 = 0.1000000000e1 * tmp1082 - 0.3673205103e-5 * S26 * tmp1084 - 0.3673205103e-5 * C26 * tmp1085 - 0.25e0 * tmp1099;
  double tmp1138 = -0.3673205103e-5 * tmp1114 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1115 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1116;
  double tmp1139 = cos(q[25] - 0.15708e1) * tmp1115 - sin(q[25] - 0.15708e1) * tmp1116;
  double tmp1140 = 0.1000000000e1 * tmp1114 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1115 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1116;
  double tmp1141 = 0.1000000000e1 * tmp1096 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1091 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1089;
  double tmp1142 = -0.3673205103e-5 * tmp1090 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1097 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1098;
  double tmp1143 = cos(q[25] - 0.15708e1) * tmp1091 - sin(q[25] - 0.15708e1) * tmp1089;
  double tmp1144 = 0.1000000000e1 * tmp1094 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1093 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1092;
  double tmp1145 = 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1116 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1115;
  double tmp1146 = cos(q[25] - 0.15708e1) * tmp1093 - sin(q[25] - 0.15708e1) * tmp1092;
  double tmp1147 = -0.3673205103e-5 * tmp1094 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1093 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1092;
  double tmp1148 = -cos(q[25] - 0.15708e1) * tmp1116 - sin(q[25] - 0.15708e1) * tmp1115;
  double tmp1149 = -0.3673205103e-5 * tmp1095 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1099 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1100;
  double tmp1150 = 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1116 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1115;
  double tmp1151 = -0.3673205103e-5 * tmp1096 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1091 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1089;
  double tmp1152 = cos(q[25] - 0.15708e1) * tmp1097 - sin(q[25] - 0.15708e1) * tmp1098;
  double tmp1153 = 0.1000000000e1 * tmp1090 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1097 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1098;
  double tmp1154 = cos(q[25] - 0.15708e1) * tmp1099 - sin(q[25] - 0.15708e1) * tmp1100;
  double tmp1155 = 0.1000000000e1 * tmp1095 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1099 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1100;
  double tmp1156 = 0.1000000000e1 * tmp1119 - 0.3673205103e-5 * tmp1118 * sin(q[25] - 0.15708e1) - 0.3673205103e-5 * tmp1117 * cos(q[25] - 0.15708e1);
  double tmp1157 = tmp1118 * cos(q[25] - 0.15708e1) - tmp1117 * sin(q[25] - 0.15708e1);
  double tmp1158 = -0.3673205103e-5 * tmp1119 - 0.1000000000e1 * tmp1118 * sin(q[25] - 0.15708e1) - 0.1000000000e1 * tmp1117 * cos(q[25] - 0.15708e1);
  double tmp1159 = 0.1000000000e1 * tmp1123 - 0.3673205103e-5 * tmp1121 * sin(q[25] - 0.15708e1) - 0.3673205103e-5 * tmp1120 * cos(q[25] - 0.15708e1);
  double tmp1160 = tmp1121 * cos(q[25] - 0.15708e1) - tmp1120 * sin(q[25] - 0.15708e1);
  double tmp1161 = 0.1000000000e1 * tmp1124 - 0.3673205103e-5 * tmp1125 * sin(q[25] - 0.15708e1) - 0.3673205103e-5 * tmp1122 * cos(q[25] - 0.15708e1);
  double tmp1162 = -0.3673205103e-5 * tmp1123 - 0.1000000000e1 * tmp1121 * sin(q[25] - 0.15708e1) - 0.1000000000e1 * tmp1120 * cos(q[25] - 0.15708e1);
  double tmp1163 = -0.3673205103e-5 * tmp1124 - 0.1000000000e1 * tmp1125 * sin(q[25] - 0.15708e1) - 0.1000000000e1 * tmp1122 * cos(q[25] - 0.15708e1);
  double tmp1164 = tmp1125 * cos(q[25] - 0.15708e1) - tmp1122 * sin(q[25] - 0.15708e1);
  double tmp1165 = -0.1092886741e-1 + tmp1138;
  double tmp1166 = 0.1245824264e-1 + tmp1139;
  double tmp1167 = -0.9808484189e-2 + tmp1140;
  double tmp1168 = 0.1878683729e-2 + 0.1000000000e1 * tmp1161 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1159 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1156;
  double tmp1169 = -0.22864249e-5 + 0.1000000000e1 * tmp1164 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1160 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1157;
  double tmp1170 = -0.95527121e-5 + 0.1000000000e1 * tmp1163 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1162 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1158;
  double tmp1171 = -0.22864249e-5 + cos(q[25] - 0.15708e1) * tmp1159 - sin(q[25] - 0.15708e1) * tmp1156;
  double tmp1172 = 0.1930618844e-2 + cos(q[25] - 0.15708e1) * tmp1160 - sin(q[25] - 0.15708e1) * tmp1157;
  double tmp1173 = -0.95527121e-5 - 0.3673205103e-5 * tmp1161 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1159 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1156;
  double tmp1174 = -0.1495736498e-3 + cos(q[25] - 0.15708e1) * tmp1162 - sin(q[25] - 0.15708e1) * tmp1158;
  double tmp1175 = 0.1464014347e-2 - 0.3673205103e-5 * tmp1163 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1162 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1158;
  double tmp1176 = -0.1495736498e-3 - 0.3673205103e-5 * tmp1164 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1160 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1157;
  double tmp1177 = 0.1000000000e1 * tmp1133 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1128 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1126;
  double tmp1178 = -0.3673205103e-5 * tmp1127 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1134 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1135;
  double tmp1179 = cos(q[25] - 0.15708e1) * tmp1128 - sin(q[25] - 0.15708e1) * tmp1126;
  double tmp1180 = 0.1000000000e1 * tmp1131 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1130 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1129;
  double tmp1181 = -0.3673205103e-5 * tmp1124 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1123 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1119;
  double tmp1182 = cos(q[25] - 0.15708e1) * tmp1130 - sin(q[25] - 0.15708e1) * tmp1129;
  double tmp1183 = -0.3673205103e-5 * tmp1131 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1130 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1129;
  double tmp1184 = cos(q[25] - 0.15708e1) * tmp1123 - sin(q[25] - 0.15708e1) * tmp1119;
  double tmp1185 = -0.3673205103e-5 * tmp1132 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1136 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1137;
  double tmp1186 = 0.1000000000e1 * tmp1124 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1123 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1119;
  double tmp1187 = -0.3673205103e-5 * tmp1133 - 0.1000000000e1 * sin(q[25] - 0.15708e1) * tmp1128 - 0.1000000000e1 * cos(q[25] - 0.15708e1) * tmp1126;
  double tmp1188 = cos(q[25] - 0.15708e1) * tmp1134 - sin(q[25] - 0.15708e1) * tmp1135;
  double tmp1189 = 0.1000000000e1 * tmp1127 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1134 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1135;
  double tmp1190 = cos(q[25] - 0.15708e1) * tmp1136 - sin(q[25] - 0.15708e1) * tmp1137;
  double tmp1191 = 0.1000000000e1 * tmp1132 - 0.3673205103e-5 * sin(q[25] - 0.15708e1) * tmp1136 - 0.3673205103e-5 * cos(q[25] - 0.15708e1) * tmp1137;
  double tmp1192 = -0.3673205103e-5 * tmp1165 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1166 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1167;
  double tmp1193 = 0.1000000000e1 * tmp1165 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1166 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1167;
  double tmp1194 = sin(q[24] + 0.314159e1) * tmp1166 + cos(q[24] + 0.314159e1) * tmp1167;
  double tmp1195 = sin(q[24] + 0.314159e1) * tmp1143 + cos(q[24] + 0.314159e1) * tmp1141;
  double tmp1196 = -0.3673205103e-5 * tmp1142 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1152 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1153;
  double tmp1197 = 0.1000000000e1 * tmp1151 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1143 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1141;
  double tmp1198 = sin(q[24] + 0.314159e1) * tmp1146 + cos(q[24] + 0.314159e1) * tmp1144;
  double tmp1199 = -0.3673205103e-5 * tmp1145 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1148 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1150;
  double tmp1200 = 0.1000000000e1 * tmp1147 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1146 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1144;
  double tmp1201 = -sin(q[24] + 0.314159e1) * tmp1167 + cos(q[24] + 0.314159e1) * tmp1166;
  double tmp1202 = -0.3673205103e-5 * tmp1147 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1146 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1144;
  double tmp1203 = 0.1000000000e1 * tmp1145 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1148 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1150;
  double tmp1204 = -0.3673205103e-5 * tmp1149 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1154 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1155;
  double tmp1205 = 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1167 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1166;
  double tmp1206 = sin(q[24] + 0.314159e1) * tmp1148 + cos(q[24] + 0.314159e1) * tmp1150;
  double tmp1207 = -0.3673205103e-5 * tmp1151 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1143 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1141;
  double tmp1208 = 0.1000000000e1 * tmp1142 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1152 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1153;
  double tmp1209 = 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1167 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1166;
  double tmp1210 = sin(q[24] + 0.314159e1) * tmp1152 + cos(q[24] + 0.314159e1) * tmp1153;
  double tmp1211 = 0.1000000000e1 * tmp1149 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1154 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1155;
  double tmp1212 = sin(q[24] + 0.314159e1) * tmp1154 + cos(q[24] + 0.314159e1) * tmp1155;
  double tmp1213 = tmp1169 * sin(q[24] + 0.314159e1) + tmp1168 * cos(q[24] + 0.314159e1);
  double tmp1214 = 0.1000000000e1 * tmp1170 - 0.3673205103e-5 * tmp1169 * cos(q[24] + 0.314159e1) + 0.3673205103e-5 * tmp1168 * sin(q[24] + 0.314159e1);
  double tmp1215 = -0.3673205103e-5 * tmp1170 - 0.1000000000e1 * tmp1169 * cos(q[24] + 0.314159e1) + 0.1000000000e1 * tmp1168 * sin(q[24] + 0.314159e1);
  double tmp1216 = tmp1172 * sin(q[24] + 0.314159e1) + tmp1171 * cos(q[24] + 0.314159e1);
  double tmp1217 = 0.1000000000e1 * tmp1174 - 0.3673205103e-5 * tmp1172 * cos(q[24] + 0.314159e1) + 0.3673205103e-5 * tmp1171 * sin(q[24] + 0.314159e1);
  double tmp1218 = tmp1176 * sin(q[24] + 0.314159e1) + tmp1173 * cos(q[24] + 0.314159e1);
  double tmp1219 = -0.3673205103e-5 * tmp1174 - 0.1000000000e1 * tmp1172 * cos(q[24] + 0.314159e1) + 0.1000000000e1 * tmp1171 * sin(q[24] + 0.314159e1);
  double tmp1220 = -0.3673205103e-5 * tmp1175 - 0.1000000000e1 * tmp1176 * cos(q[24] + 0.314159e1) + 0.1000000000e1 * tmp1173 * sin(q[24] + 0.314159e1);
  double tmp1221 = 0.1000000000e1 * tmp1175 - 0.3673205103e-5 * tmp1176 * cos(q[24] + 0.314159e1) + 0.3673205103e-5 * tmp1173 * sin(q[24] + 0.314159e1);
  double tmp1222 = -0.3763013640e-1 + tmp1192;
  double tmp1223 = -0.8015280780e-2 + tmp1193;
  double tmp1224 = 0.1240712402e-3 + tmp1194;
  double tmp1225 = 0.5275044709e-2 + sin(q[24] + 0.314159e1) * tmp1216 + cos(q[24] + 0.314159e1) * tmp1213;
  double tmp1226 = -0.242379595e-6 + sin(q[24] + 0.314159e1) * tmp1217 + cos(q[24] + 0.314159e1) * tmp1214;
  double tmp1227 = 0.5243343169e-4 + sin(q[24] + 0.314159e1) * tmp1219 + cos(q[24] + 0.314159e1) * tmp1215;
  double tmp1228 = -0.242379595e-6 + 0.1000000000e1 * tmp1218 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1216 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1213;
  double tmp1229 = 0.3959186677e-2 + 0.1000000000e1 * tmp1221 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1217 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1214;
  double tmp1230 = 0.5243343169e-4 - 0.3673205103e-5 * tmp1218 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1216 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1213;
  double tmp1231 = -0.680906319e-4 + 0.1000000000e1 * tmp1220 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1219 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1215;
  double tmp1232 = 0.1921216038e-2 - 0.3673205103e-5 * tmp1220 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1219 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1215;
  double tmp1233 = -0.680906319e-4 - 0.3673205103e-5 * tmp1221 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1217 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1214;
  double tmp1234 = sin(q[24] + 0.314159e1) * tmp1179 + cos(q[24] + 0.314159e1) * tmp1177;
  double tmp1235 = -0.3673205103e-5 * tmp1178 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1188 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1189;
  double tmp1236 = 0.1000000000e1 * tmp1187 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1179 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1177;
  double tmp1237 = sin(q[24] + 0.314159e1) * tmp1182 + cos(q[24] + 0.314159e1) * tmp1180;
  double tmp1238 = -0.3673205103e-5 * tmp1181 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1184 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1186;
  double tmp1239 = 0.1000000000e1 * tmp1183 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1182 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1180;
  double tmp1240 = sin(q[24] + 0.314159e1) * tmp1174 + cos(q[24] + 0.314159e1) * tmp1170;
  double tmp1241 = -0.3673205103e-5 * tmp1183 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1182 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1180;
  double tmp1242 = 0.1000000000e1 * tmp1181 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1184 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1186;
  double tmp1243 = -0.3673205103e-5 * tmp1185 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1190 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1191;
  double tmp1244 = 0.1000000000e1 * tmp1175 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1174 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1170;
  double tmp1245 = sin(q[24] + 0.314159e1) * tmp1184 + cos(q[24] + 0.314159e1) * tmp1186;
  double tmp1246 = -0.3673205103e-5 * tmp1187 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1179 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1177;
  double tmp1247 = 0.1000000000e1 * tmp1178 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1188 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1189;
  double tmp1248 = -0.3673205103e-5 * tmp1175 - 0.1000000000e1 * cos(q[24] + 0.314159e1) * tmp1174 + 0.1000000000e1 * sin(q[24] + 0.314159e1) * tmp1170;
  double tmp1249 = sin(q[24] + 0.314159e1) * tmp1188 + cos(q[24] + 0.314159e1) * tmp1189;
  double tmp1250 = 0.1000000000e1 * tmp1185 - 0.3673205103e-5 * cos(q[24] + 0.314159e1) * tmp1190 + 0.3673205103e-5 * sin(q[24] + 0.314159e1) * tmp1191;
  double tmp1251 = sin(q[24] + 0.314159e1) * tmp1190 + cos(q[24] + 0.314159e1) * tmp1191;
  double tmp1252 = C23 * tmp1223 - S23 * tmp1224;
  double tmp1253 = S23 * tmp1223 + C23 * tmp1224;
  double tmp1254 = S23 * tmp1197 + C23 * tmp1195;
  double tmp1255 = C23 * tmp1197 - S23 * tmp1195;
  double tmp1256 = S23 * tmp1200 + C23 * tmp1198;
  double tmp1257 = C23 * tmp1200 - S23 * tmp1198;
  double tmp1258 = S23 * tmp1205 + C23 * tmp1201;
  double tmp1259 = C23 * tmp1203 - S23 * tmp1206;
  double tmp1260 = C23 * tmp1205 - S23 * tmp1201;
  double tmp1261 = S23 * tmp1203 + C23 * tmp1206;
  double tmp1262 = C23 * tmp1208 - S23 * tmp1210;
  double tmp1263 = C23 * tmp1223 - S23 * tmp1224;
  double tmp1264 = S23 * tmp1208 + C23 * tmp1210;
  double tmp1265 = C23 * tmp1211 - S23 * tmp1212;
  double tmp1266 = S23 * tmp1211 + C23 * tmp1212;
  double tmp1267 = -S23 * tmp1223 - C23 * tmp1224;
  double tmp1268 = -0.8e-2 * tmp1252 - 0.25e0 * tmp1222;
  double tmp1269 = 0.8e-2 * tmp1253;
  double tmp1270 = 0.25e0 * tmp1253;
  double tmp1271 = -0.181e0 * tmp1252;
  double tmp1272 = 0.181e0 * tmp1253 - 0.25e0 * tmp1222;
  double tmp1273 = -0.181e0 * tmp1222;
  double tmp1274 = 0.25e0 * tmp1252;
  double tmp1275 = 0.181e0 * tmp1253 - 0.8e-2 * tmp1252;
  double tmp1276 = 0.8e-2 * tmp1222;
  double tmp1277 = tmp1226 * S23 + tmp1225 * C23;
  double tmp1278 = tmp1226 * C23 - tmp1225 * S23;
  double tmp1279 = tmp1229 * S23 + tmp1228 * C23;
  double tmp1280 = tmp1229 * C23 - tmp1228 * S23;
  double tmp1281 = tmp1233 * S23 + tmp1230 * C23;
  double tmp1282 = tmp1233 * C23 - tmp1230 * S23;
  double tmp1283 = tmp934 + tmp1222 + 0.148055775e1;
  double tmp1284 = tmp935 + tmp1252 + 0.47377848e-1;
  double tmp1285 = tmp936 + tmp1253 - 0.1071923811e1;
  double tmp1286 = tmp937 + S23 * tmp1279 + C23 * tmp1277 + 0.3705184603e0 - 2 * tmp1268;
  double tmp1287 = tmp938 + S23 * tmp1280 + C23 * tmp1278 + 0.8575390488e-2 - tmp1269 - tmp1271;
  double tmp1288 = tmp939 + S23 * tmp1231 + C23 * tmp1227 + 0.2679809528e0 - tmp1270 - tmp1273;
  double tmp1289 = tmp940 + C23 * tmp1279 - S23 * tmp1277 + 0.8575390488e-2 - tmp1271 - tmp1269;
  double tmp1290 = tmp941 + C23 * tmp1280 - S23 * tmp1278 + 0.5641576473e0 - 2 * tmp1272;
  double tmp1291 = tmp942 + tmp1281 + 0.2679809528e0 - tmp1273 - tmp1270;
  double tmp1292 = tmp943 + C23 * tmp1231 - S23 * tmp1227 - 0.1184446200e-1 - tmp1274 - tmp1276;
  double tmp1293 = tmp944 + tmp1232 + 0.1943972326e0 - 2 * tmp1275;
  double tmp1294 = tmp945 + tmp1282 - 0.1184446200e-1 - tmp1276 - tmp1274;
  double tmp1295 = S23 * tmp1236 + C23 * tmp1234 - 0.8e-2 * tmp1207 + 0.25e0 * tmp1255;
  double tmp1296 = tmp1235 + 0.181e0 * tmp1262 + 0.8e-2 * tmp1264;
  double tmp1297 = C23 * tmp1236 - S23 * tmp1234 - 0.181e0 * tmp1207 - 0.25e0 * tmp1254;
  double tmp1298 = S23 * tmp1239 + C23 * tmp1237 - 0.8e-2 * tmp1202 + 0.25e0 * tmp1257;
  double tmp1299 = tmp1238 + 0.181e0 * tmp1259 + 0.8e-2 * tmp1261;
  double tmp1300 = C23 * tmp1239 - S23 * tmp1237 - 0.181e0 * tmp1202 - 0.25e0 * tmp1256;
  double tmp1301 = S23 * tmp1244 + C23 * tmp1240 - 0.8e-2 * tmp1209 + 0.25e0 * tmp1260;
  double tmp1302 = tmp1232 + 0.181e0 * tmp1267 + 0.8e-2 * tmp1263;
  double tmp1303 = tmp1241 + 0.181e0 * tmp1257 + 0.8e-2 * tmp1256;
  double tmp1304 = C23 * tmp1242 - S23 * tmp1245 - 0.181e0 * tmp1199 - 0.25e0 * tmp1261;
  double tmp1305 = tmp1243 + 0.181e0 * tmp1265 + 0.8e-2 * tmp1266;
  double tmp1306 = C23 * tmp1244 - S23 * tmp1240 - 0.181e0 * tmp1209 - 0.25e0 * tmp1258;
  double tmp1307 = S23 * tmp1242 + C23 * tmp1245 - 0.8e-2 * tmp1199 + 0.25e0 * tmp1259;
  double tmp1308 = tmp1246 + 0.181e0 * tmp1255 + 0.8e-2 * tmp1254;
  double tmp1309 = C23 * tmp1247 - S23 * tmp1249 - 0.181e0 * tmp1196 - 0.25e0 * tmp1264;
  double tmp1310 = S23 * tmp1231 + C23 * tmp1227 + 0.25e0 * tmp1267;
  double tmp1311 = tmp1248 + 0.181e0 * tmp1260 + 0.8e-2 * tmp1258;
  double tmp1312 = S23 * tmp1247 + C23 * tmp1249 - 0.8e-2 * tmp1196 + 0.25e0 * tmp1262;
  double tmp1313 = C23 * tmp1250 - S23 * tmp1251 - 0.181e0 * tmp1204 - 0.25e0 * tmp1266;
  double tmp1314 = S23 * tmp1250 + C23 * tmp1251 - 0.8e-2 * tmp1204 + 0.25e0 * tmp1265;
  double tmp1315 = C23 * tmp1231 - S23 * tmp1227 - 0.25e0 * tmp1263;
  double tmp1316 = -0.3673205103e-5 * tmp1283 - 0.1000000000e1 * S13 * tmp1284 - 0.1000000000e1 * C13 * tmp1285;
  double tmp1317 = C13 * tmp1284 - S13 * tmp1285;
  double tmp1318 = 0.1000000000e1 * tmp1283 - 0.3673205103e-5 * S13 * tmp1284 - 0.3673205103e-5 * C13 * tmp1285;
  double tmp1319 = -0.3673205103e-5 * S13 * tmp909 - 0.3673205103e-5 * C13 * tmp905;
  double tmp1320 = C13 * tmp906 - S13 * tmp908;
  double tmp1321 = 0.1000000000e1 * tmp1207 - 0.3673205103e-5 * S13 * tmp1255 - 0.3673205103e-5 * C13 * tmp1254;
  double tmp1322 = -0.3673205103e-5 * tmp847 - 0.1000000000e1 * S13 * tmp918 - 0.1000000000e1 * C13 * tmp917;
  double tmp1323 = C13 * tmp907 - S13 * tmp910;
  double tmp1324 = -0.3673205103e-5 * tmp849 - 0.1000000000e1 * S13 * tmp907 - 0.1000000000e1 * C13 * tmp910;
  double tmp1325 = 0.1000000000e1 * tmp857 - 0.3673205103e-5 * S13 * tmp906 - 0.3673205103e-5 * C13 * tmp908;
  double tmp1326 = -0.3673205103e-5 * tmp851 - 0.1000000000e1 * S13 * tmp912 - 0.1000000000e1 * C13 * tmp914;
  double tmp1327 = C13 * tmp909 - S13 * tmp905;
  double tmp1328 = 0.1000000000e1 * tmp849 - 0.3673205103e-5 * S13 * tmp907 - 0.3673205103e-5 * C13 * tmp910;
  double tmp1329 = -0.3673205103e-5 * tmp1196 - 0.1000000000e1 * S13 * tmp1262 - 0.1000000000e1 * C13 * tmp1264;
  double tmp1330 = C13 * tmp1255 - S13 * tmp1254;
  double tmp1331 = 0.1000000000e1 * tmp1202 - 0.3673205103e-5 * S13 * tmp1257 - 0.3673205103e-5 * C13 * tmp1256;
  double tmp1332 = C13 * tmp911 - S13 * tmp913;
  double tmp1333 = 0.1000000000e1 * tmp583 - 0.3673205103e-5 * S13 * tmp579 - 0.3673205103e-5 * C13 * tmp578;
  double tmp1334 = C13 * tmp912 - S13 * tmp914;
  double tmp1335 = 0.1000000000e1 * tmp862 - 0.3673205103e-5 * S13 * tmp911 - 0.3673205103e-5 * C13 * tmp913;
  double tmp1336 = 0.1000000000e1 * S13 * tmp1285 - 0.1000000000e1 * C13 * tmp1284;
  double tmp1337 = -0.3673205103e-5 * tmp1199 - 0.1000000000e1 * S13 * tmp1259 - 0.1000000000e1 * C13 * tmp1261;
  double tmp1338 = C13 * tmp1257 - S13 * tmp1256;
  double tmp1339 = 0.1000000000e1 * tmp851 - 0.3673205103e-5 * S13 * tmp912 - 0.3673205103e-5 * C13 * tmp914;
  double tmp1340 = -0.1000000000e1 * S13 * tmp909 - 0.1000000000e1 * C13 * tmp905;
  double tmp1341 = -0.3673205103e-5 * tmp857 - 0.1000000000e1 * S13 * tmp906 - 0.1000000000e1 * C13 * tmp908;
  double tmp1342 = C13 * tmp579 - S13 * tmp578;
  double tmp1343 = -0.3673205103e-5 * tmp858 - 0.1000000000e1 * S13 * tmp916 - 0.1000000000e1 * C13 * tmp915;
  double tmp1344 = 0.1000000000e1 * tmp1209 - 0.3673205103e-5 * S13 * tmp1260 - 0.3673205103e-5 * C13 * tmp1258;
  double tmp1345 = -0.1000000000e1 * S13 * tmp1267 - 0.1000000000e1 * C13 * tmp1263;
  double tmp1346 = C13 * tmp580 - S13 * tmp582;
  double tmp1347 = 0.1000000000e1 * tmp858 - 0.3673205103e-5 * S13 * tmp916 - 0.3673205103e-5 * C13 * tmp915;
  double tmp1348 = -0.3673205103e-5 * tmp581 - 0.1000000000e1 * S13 * tmp580 - 0.1000000000e1 * C13 * tmp582;
  double tmp1349 = -0.3673205103e-5 * tmp1202 - 0.1000000000e1 * S13 * tmp1257 - 0.1000000000e1 * C13 * tmp1256;
  double tmp1350 = C13 * tmp1259 - S13 * tmp1261;
  double tmp1351 = 0.1000000000e1 * tmp581 - 0.3673205103e-5 * S13 * tmp580 - 0.3673205103e-5 * C13 * tmp582;
  double tmp1352 = -0.3673205103e-5 * tmp1204 - 0.1000000000e1 * S13 * tmp1265 - 0.1000000000e1 * C13 * tmp1266;
  double tmp1353 = C13 * tmp1260 - S13 * tmp1258;
  double tmp1354 = 0.1000000000e1 * tmp1199 - 0.3673205103e-5 * S13 * tmp1259 - 0.3673205103e-5 * C13 * tmp1261;
  double tmp1355 = C13 * tmp916 - S13 * tmp915;
  double tmp1356 = -C13 * tmp1285 - S13 * tmp1284;
  double tmp1357 = 0.1000000000e1 * tmp847 - 0.3673205103e-5 * S13 * tmp918 - 0.3673205103e-5 * C13 * tmp917;
  double tmp1358 = -0.3673205103e-5 * tmp583 - 0.1000000000e1 * S13 * tmp579 - 0.1000000000e1 * C13 * tmp578;
  double tmp1359 = -0.3673205103e-5 * tmp1207 - 0.1000000000e1 * S13 * tmp1255 - 0.1000000000e1 * C13 * tmp1254;
  double tmp1360 = C13 * tmp1262 - S13 * tmp1264;
  double tmp1361 = -0.3673205103e-5 * tmp862 - 0.1000000000e1 * S13 * tmp911 - 0.1000000000e1 * C13 * tmp913;
  double tmp1362 = -0.3673205103e-5 * S13 * tmp1267 - 0.3673205103e-5 * C13 * tmp1263;
  double tmp1363 = -0.3673205103e-5 * tmp1209 - 0.1000000000e1 * S13 * tmp1260 - 0.1000000000e1 * C13 * tmp1258;
  double tmp1364 = 0.1000000000e1 * tmp1196 - 0.3673205103e-5 * S13 * tmp1262 - 0.3673205103e-5 * C13 * tmp1264;
  double tmp1365 = C13 * tmp918 - S13 * tmp917;
  double tmp1366 = 0.3673205103e-5 * S13 * tmp1285 - 0.3673205103e-5 * C13 * tmp1284;
  double tmp1367 = C13 * tmp1265 - S13 * tmp1266;
  double tmp1368 = 0.1000000000e1 * tmp1204 - 0.3673205103e-5 * S13 * tmp1265 - 0.3673205103e-5 * C13 * tmp1266;
  double tmp1369 = C13 * tmp1267 - S13 * tmp1263;
  double tmp1370 = 0.1000000000e1 * tmp1288 - 0.3673205103e-5 * tmp1287 * S13 - 0.3673205103e-5 * tmp1286 * C13;
  double tmp1371 = tmp1287 * C13 - tmp1286 * S13;
  double tmp1372 = -0.3673205103e-5 * tmp1288 - 0.1000000000e1 * tmp1287 * S13 - 0.1000000000e1 * tmp1286 * C13;
  double tmp1373 = 0.1000000000e1 * tmp1292 - 0.3673205103e-5 * tmp1290 * S13 - 0.3673205103e-5 * tmp1289 * C13;
  double tmp1374 = tmp1290 * C13 - tmp1289 * S13;
  double tmp1375 = 0.1000000000e1 * tmp1293 - 0.3673205103e-5 * tmp1294 * S13 - 0.3673205103e-5 * tmp1291 * C13;
  double tmp1376 = -0.3673205103e-5 * tmp1292 - 0.1000000000e1 * tmp1290 * S13 - 0.1000000000e1 * tmp1289 * C13;
  double tmp1377 = -0.3673205103e-5 * tmp1293 - 0.1000000000e1 * tmp1294 * S13 - 0.1000000000e1 * tmp1291 * C13;
  double tmp1378 = tmp1294 * C13 - tmp1291 * S13;
  double tmp1379 = -0.1981358923e-1 + tmp1316;
  double tmp1380 = -0.1242588839e-1 + tmp1317;
  double tmp1381 = 0.4164169857e-2 + tmp1318;
  double tmp1382 = 0.2546368056e-2 + 0.1000000000e1 * tmp1375 - 0.3673205103e-5 * S13 * tmp1373 - 0.3673205103e-5 * C13 * tmp1370;
  double tmp1383 = -0.741945359e-5 + 0.1000000000e1 * tmp1378 - 0.3673205103e-5 * S13 * tmp1374 - 0.3673205103e-5 * C13 * tmp1371;
  double tmp1384 = -0.25683270e-5 + 0.1000000000e1 * tmp1377 - 0.3673205103e-5 * S13 * tmp1376 - 0.3673205103e-5 * C13 * tmp1372;
  double tmp1385 = -0.741945359e-5 + C13 * tmp1373 - S13 * tmp1370;
  double tmp1386 = 0.2337450250e-2 + C13 * tmp1374 - S13 * tmp1371;
  double tmp1387 = -0.25683270e-5 - 0.3673205103e-5 * tmp1375 - 0.1000000000e1 * S13 * tmp1373 - 0.1000000000e1 * C13 * tmp1370;
  double tmp1388 = -0.5903964117e-3 + C13 * tmp1376 - S13 * tmp1372;
  double tmp1389 = 0.2550470030e-2 - 0.3673205103e-5 * tmp1377 - 0.1000000000e1 * S13 * tmp1376 - 0.1000000000e1 * C13 * tmp1372;
  double tmp1390 = -0.5903964117e-3 - 0.3673205103e-5 * tmp1378 - 0.1000000000e1 * S13 * tmp1374 - 0.1000000000e1 * C13 * tmp1371;
  double tmp1391 = 0.1000000000e1 * tmp959 - 0.3673205103e-5 * S13 * tmp953 - 0.3673205103e-5 * C13 * tmp946;
  double tmp1392 = C13 * tmp947 - S13 * tmp951;
  double tmp1393 = 0.1000000000e1 * tmp1308 - 0.3673205103e-5 * S13 * tmp1297 - 0.3673205103e-5 * C13 * tmp1295;
  double tmp1394 = -0.3673205103e-5 * tmp948 - 0.1000000000e1 * S13 * tmp966 - 0.1000000000e1 * C13 * tmp964;
  double tmp1395 = C13 * tmp949 - S13 * tmp954;
  double tmp1396 = -0.3673205103e-5 * tmp950 - 0.1000000000e1 * S13 * tmp949 - 0.1000000000e1 * C13 * tmp954;
  double tmp1397 = 0.1000000000e1 * tmp960 - 0.3673205103e-5 * S13 * tmp947 - 0.3673205103e-5 * C13 * tmp951;
  double tmp1398 = -0.3673205103e-5 * tmp952 - 0.1000000000e1 * S13 * tmp956 - 0.1000000000e1 * C13 * tmp958;
  double tmp1399 = C13 * tmp953 - S13 * tmp946;
  double tmp1400 = 0.1000000000e1 * tmp950 - 0.3673205103e-5 * S13 * tmp949 - 0.3673205103e-5 * C13 * tmp954;
  double tmp1401 = -0.3673205103e-5 * tmp1296 - 0.1000000000e1 * S13 * tmp1309 - 0.1000000000e1 * C13 * tmp1312;
  double tmp1402 = C13 * tmp1297 - S13 * tmp1295;
  double tmp1403 = 0.1000000000e1 * tmp1303 - 0.3673205103e-5 * S13 * tmp1300 - 0.3673205103e-5 * C13 * tmp1298;
  double tmp1404 = C13 * tmp955 - S13 * tmp957;
  double tmp1405 = 0.1000000000e1 * tmp617 - 0.3673205103e-5 * S13 * tmp613 - 0.3673205103e-5 * C13 * tmp612;
  double tmp1406 = C13 * tmp956 - S13 * tmp958;
  double tmp1407 = 0.1000000000e1 * tmp965 - 0.3673205103e-5 * S13 * tmp955 - 0.3673205103e-5 * C13 * tmp957;
  double tmp1408 = -0.3673205103e-5 * tmp1293 - 0.1000000000e1 * S13 * tmp1292 - 0.1000000000e1 * C13 * tmp1288;
  double tmp1409 = -0.3673205103e-5 * tmp1299 - 0.1000000000e1 * S13 * tmp1304 - 0.1000000000e1 * C13 * tmp1307;
  double tmp1410 = C13 * tmp1300 - S13 * tmp1298;
  double tmp1411 = 0.1000000000e1 * tmp952 - 0.3673205103e-5 * S13 * tmp956 - 0.3673205103e-5 * C13 * tmp958;
  double tmp1412 = -0.3673205103e-5 * tmp959 - 0.1000000000e1 * S13 * tmp953 - 0.1000000000e1 * C13 * tmp946;
  double tmp1413 = -0.3673205103e-5 * tmp960 - 0.1000000000e1 * S13 * tmp947 - 0.1000000000e1 * C13 * tmp951;
  double tmp1414 = C13 * tmp613 - S13 * tmp612;
  double tmp1415 = -0.3673205103e-5 * tmp961 - 0.1000000000e1 * S13 * tmp963 - 0.1000000000e1 * C13 * tmp962;
  double tmp1416 = 0.1000000000e1 * tmp1311 - 0.3673205103e-5 * S13 * tmp1306 - 0.3673205103e-5 * C13 * tmp1301;
  double tmp1417 = -0.3673205103e-5 * tmp1302 - 0.1000000000e1 * S13 * tmp1315 - 0.1000000000e1 * C13 * tmp1310;
  double tmp1418 = C13 * tmp614 - S13 * tmp616;
  double tmp1419 = 0.1000000000e1 * tmp961 - 0.3673205103e-5 * S13 * tmp963 - 0.3673205103e-5 * C13 * tmp962;
  double tmp1420 = -0.3673205103e-5 * tmp615 - 0.1000000000e1 * S13 * tmp614 - 0.1000000000e1 * C13 * tmp616;
  double tmp1421 = -0.3673205103e-5 * tmp1303 - 0.1000000000e1 * S13 * tmp1300 - 0.1000000000e1 * C13 * tmp1298;
  double tmp1422 = C13 * tmp1304 - S13 * tmp1307;
  double tmp1423 = 0.1000000000e1 * tmp615 - 0.3673205103e-5 * S13 * tmp614 - 0.3673205103e-5 * C13 * tmp616;
  double tmp1424 = -0.3673205103e-5 * tmp1305 - 0.1000000000e1 * S13 * tmp1313 - 0.1000000000e1 * C13 * tmp1314;
  double tmp1425 = C13 * tmp1306 - S13 * tmp1301;
  double tmp1426 = 0.1000000000e1 * tmp1299 - 0.3673205103e-5 * S13 * tmp1304 - 0.3673205103e-5 * C13 * tmp1307;
  double tmp1427 = C13 * tmp963 - S13 * tmp962;
  double tmp1428 = C13 * tmp1292 - S13 * tmp1288;
  double tmp1429 = 0.1000000000e1 * tmp948 - 0.3673205103e-5 * S13 * tmp966 - 0.3673205103e-5 * C13 * tmp964;
  double tmp1430 = -0.3673205103e-5 * tmp617 - 0.1000000000e1 * S13 * tmp613 - 0.1000000000e1 * C13 * tmp612;
  double tmp1431 = -0.3673205103e-5 * tmp1308 - 0.1000000000e1 * S13 * tmp1297 - 0.1000000000e1 * C13 * tmp1295;
  double tmp1432 = C13 * tmp1309 - S13 * tmp1312;
  double tmp1433 = -0.3673205103e-5 * tmp965 - 0.1000000000e1 * S13 * tmp955 - 0.1000000000e1 * C13 * tmp957;
  double tmp1434 = 0.1000000000e1 * tmp1302 - 0.3673205103e-5 * S13 * tmp1315 - 0.3673205103e-5 * C13 * tmp1310;
  double tmp1435 = -0.3673205103e-5 * tmp1311 - 0.1000000000e1 * S13 * tmp1306 - 0.1000000000e1 * C13 * tmp1301;
  double tmp1436 = 0.1000000000e1 * tmp1296 - 0.3673205103e-5 * S13 * tmp1309 - 0.3673205103e-5 * C13 * tmp1312;
  double tmp1437 = C13 * tmp966 - S13 * tmp964;
  double tmp1438 = 0.1000000000e1 * tmp1293 - 0.3673205103e-5 * S13 * tmp1292 - 0.3673205103e-5 * C13 * tmp1288;
  double tmp1439 = C13 * tmp1313 - S13 * tmp1314;
  double tmp1440 = 0.1000000000e1 * tmp1305 - 0.3673205103e-5 * S13 * tmp1313 - 0.3673205103e-5 * C13 * tmp1314;
  double tmp1441 = C13 * tmp1315 - S13 * tmp1310;
  double tmp1442 = -0.3673205103e-5 * tmp1379 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1380 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1381;
  double tmp1443 = cos(q[12] - 0.15708e1) * tmp1380 - sin(q[12] - 0.15708e1) * tmp1381;
  double tmp1444 = 0.1000000000e1 * tmp1379 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1380 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1381;
  double tmp1445 = 0.1000000000e1 * tmp1340 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1327 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1319;
  double tmp1446 = cos(q[12] - 0.15708e1) * tmp1320 - sin(q[12] - 0.15708e1) * tmp1325;
  double tmp1447 = 0.1000000000e1 * tmp1359 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1330 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1321;
  double tmp1448 = -0.3673205103e-5 * tmp1322 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1365 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1357;
  double tmp1449 = cos(q[12] - 0.15708e1) * tmp1323 - sin(q[12] - 0.15708e1) * tmp1328;
  double tmp1450 = -0.3673205103e-5 * tmp1324 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1323 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1328;
  double tmp1451 = 0.1000000000e1 * tmp1341 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1320 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1325;
  double tmp1452 = -0.3673205103e-5 * tmp1326 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1334 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1339;
  double tmp1453 = cos(q[12] - 0.15708e1) * tmp1327 - sin(q[12] - 0.15708e1) * tmp1319;
  double tmp1454 = 0.1000000000e1 * tmp1324 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1323 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1328;
  double tmp1455 = 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1381 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1380;
  double tmp1456 = -0.3673205103e-5 * tmp1329 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1360 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1364;
  double tmp1457 = cos(q[12] - 0.15708e1) * tmp1330 - sin(q[12] - 0.15708e1) * tmp1321;
  double tmp1458 = 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1381 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1380;
  double tmp1459 = 0.1000000000e1 * tmp1349 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1338 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1331;
  double tmp1460 = cos(q[12] - 0.15708e1) * tmp1332 - sin(q[12] - 0.15708e1) * tmp1335;
  double tmp1461 = 0.1000000000e1 * tmp1358 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1342 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1333;
  double tmp1462 = cos(q[12] - 0.15708e1) * tmp1334 - sin(q[12] - 0.15708e1) * tmp1339;
  double tmp1463 = 0.1000000000e1 * tmp1361 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1332 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1335;
  double tmp1464 = -0.3673205103e-5 * tmp1336 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1356 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1366;
  double tmp1465 = -0.3673205103e-5 * tmp1337 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1350 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1354;
  double tmp1466 = cos(q[12] - 0.15708e1) * tmp1338 - sin(q[12] - 0.15708e1) * tmp1331;
  double tmp1467 = -cos(q[12] - 0.15708e1) * tmp1381 - sin(q[12] - 0.15708e1) * tmp1380;
  double tmp1468 = 0.1000000000e1 * tmp1326 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1334 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1339;
  double tmp1469 = -0.3673205103e-5 * tmp1340 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1327 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1319;
  double tmp1470 = -0.3673205103e-5 * tmp1341 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1320 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1325;
  double tmp1471 = cos(q[12] - 0.15708e1) * tmp1342 - sin(q[12] - 0.15708e1) * tmp1333;
  double tmp1472 = -0.3673205103e-5 * tmp1343 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1355 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1347;
  double tmp1473 = 0.1000000000e1 * tmp1363 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1353 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1344;
  double tmp1474 = -0.3673205103e-5 * tmp1345 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1369 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1362;
  double tmp1475 = cos(q[12] - 0.15708e1) * tmp1346 - sin(q[12] - 0.15708e1) * tmp1351;
  double tmp1476 = 0.1000000000e1 * tmp1343 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1355 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1347;
  double tmp1477 = -0.3673205103e-5 * tmp1348 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1346 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1351;
  double tmp1478 = -0.3673205103e-5 * tmp1349 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1338 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1331;
  double tmp1479 = cos(q[12] - 0.15708e1) * tmp1350 - sin(q[12] - 0.15708e1) * tmp1354;
  double tmp1480 = 0.1000000000e1 * tmp1348 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1346 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1351;
  double tmp1481 = -0.3673205103e-5 * tmp1352 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1367 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1368;
  double tmp1482 = cos(q[12] - 0.15708e1) * tmp1353 - sin(q[12] - 0.15708e1) * tmp1344;
  double tmp1483 = 0.1000000000e1 * tmp1337 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1350 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1354;
  double tmp1484 = cos(q[12] - 0.15708e1) * tmp1355 - sin(q[12] - 0.15708e1) * tmp1347;
  double tmp1485 = cos(q[12] - 0.15708e1) * tmp1356 - sin(q[12] - 0.15708e1) * tmp1366;
  double tmp1486 = 0.1000000000e1 * tmp1322 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1365 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1357;
  double tmp1487 = -0.3673205103e-5 * tmp1358 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1342 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1333;
  double tmp1488 = -0.3673205103e-5 * tmp1359 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1330 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1321;
  double tmp1489 = cos(q[12] - 0.15708e1) * tmp1360 - sin(q[12] - 0.15708e1) * tmp1364;
  double tmp1490 = -0.3673205103e-5 * tmp1361 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1332 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1335;
  double tmp1491 = 0.1000000000e1 * tmp1345 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1369 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1362;
  double tmp1492 = -0.3673205103e-5 * tmp1363 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1353 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1344;
  double tmp1493 = 0.1000000000e1 * tmp1329 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1360 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1364;
  double tmp1494 = cos(q[12] - 0.15708e1) * tmp1365 - sin(q[12] - 0.15708e1) * tmp1357;
  double tmp1495 = 0.1000000000e1 * tmp1336 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1356 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1366;
  double tmp1496 = cos(q[12] - 0.15708e1) * tmp1367 - sin(q[12] - 0.15708e1) * tmp1368;
  double tmp1497 = 0.1000000000e1 * tmp1352 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1367 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1368;
  double tmp1498 = cos(q[12] - 0.15708e1) * tmp1369 - sin(q[12] - 0.15708e1) * tmp1362;
  double tmp1499 = -0.32e-1 * tmp1442;
  double tmp1500 = 0.32e-1 * tmp1444;
  double tmp1501 = 0.3507e0 * tmp1443;
  double tmp1502 = -0.3507e0 * tmp1444 - 0.32e-1 * tmp1442;
  double tmp1503 = 0.3507e0 * tmp1442;
  double tmp1504 = 0.32e-1 * tmp1443;
  double tmp1505 = -0.3507e0 * tmp1444;
  double tmp1506 = 0.1000000000e1 * tmp1384 - 0.3673205103e-5 * tmp1383 * sin(q[12] - 0.15708e1) - 0.3673205103e-5 * tmp1382 * cos(q[12] - 0.15708e1);
  double tmp1507 = tmp1383 * cos(q[12] - 0.15708e1) - tmp1382 * sin(q[12] - 0.15708e1);
  double tmp1508 = -0.3673205103e-5 * tmp1384 - 0.1000000000e1 * tmp1383 * sin(q[12] - 0.15708e1) - 0.1000000000e1 * tmp1382 * cos(q[12] - 0.15708e1);
  double tmp1509 = 0.1000000000e1 * tmp1388 - 0.3673205103e-5 * tmp1386 * sin(q[12] - 0.15708e1) - 0.3673205103e-5 * tmp1385 * cos(q[12] - 0.15708e1);
  double tmp1510 = tmp1386 * cos(q[12] - 0.15708e1) - tmp1385 * sin(q[12] - 0.15708e1);
  double tmp1511 = 0.1000000000e1 * tmp1389 - 0.3673205103e-5 * tmp1390 * sin(q[12] - 0.15708e1) - 0.3673205103e-5 * tmp1387 * cos(q[12] - 0.15708e1);
  double tmp1512 = -0.3673205103e-5 * tmp1388 - 0.1000000000e1 * tmp1386 * sin(q[12] - 0.15708e1) - 0.1000000000e1 * tmp1385 * cos(q[12] - 0.15708e1);
  double tmp1513 = -0.3673205103e-5 * tmp1389 - 0.1000000000e1 * tmp1390 * sin(q[12] - 0.15708e1) - 0.1000000000e1 * tmp1387 * cos(q[12] - 0.15708e1);
  double tmp1514 = tmp1390 * cos(q[12] - 0.15708e1) - tmp1387 * sin(q[12] - 0.15708e1);
  double tmp1515 = tmp515 + tmp1442 + 0.816753664e0;
  double tmp1516 = tmp516 + tmp1443;
  double tmp1517 = tmp517 + tmp1444 + 0.8951109686e1;
  double tmp1518 = tmp518 + 0.1000000000e1 * tmp1511 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1509 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1506 + 0.2613611725e-1 - 2 * tmp1499;
  double tmp1519 = tmp519 + 0.1000000000e1 * tmp1514 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1510 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1507 - tmp1501;
  double tmp1520 = tmp520 + 0.1000000000e1 * tmp1513 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1512 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1508 - 0.2864355100e0 - tmp1500 - tmp1503;
  double tmp1521 = tmp521 + cos(q[12] - 0.15708e1) * tmp1509 - sin(q[12] - 0.15708e1) * tmp1506 - tmp1501;
  double tmp1522 = tmp522 + cos(q[12] - 0.15708e1) * tmp1510 - sin(q[12] - 0.15708e1) * tmp1507 + 0.3165290284e1 - 2 * tmp1502;
  double tmp1523 = tmp523 - 0.3673205103e-5 * tmp1511 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1509 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1506 - 0.2864355100e0 - tmp1503 - tmp1500;
  double tmp1524 = tmp524 + cos(q[12] - 0.15708e1) * tmp1512 - sin(q[12] - 0.15708e1) * tmp1508 - tmp1504;
  double tmp1525 = tmp525 - 0.3673205103e-5 * tmp1513 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1512 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1508 + 0.3139154167e1 - 2 * tmp1505;
  double tmp1526 = tmp526 - 0.3673205103e-5 * tmp1514 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1510 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1507 - tmp1504;
  double tmp1527 = 0.1000000000e1 * tmp1412 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1399 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1391 + 0.32e-1 * tmp1453;
  double tmp1528 = cos(q[12] - 0.15708e1) * tmp1392 - sin(q[12] - 0.15708e1) * tmp1397 + 0.3507e0 * tmp1470 - 0.32e-1 * tmp1451;
  double tmp1529 = 0.1000000000e1 * tmp1431 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1402 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1393 + 0.32e-1 * tmp1457;
  double tmp1530 = -0.3673205103e-5 * tmp1394 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1437 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1429 - 0.3507e0 * tmp1494;
  double tmp1531 = cos(q[12] - 0.15708e1) * tmp1395 - sin(q[12] - 0.15708e1) * tmp1400 + 0.3507e0 * tmp1450 - 0.32e-1 * tmp1454;
  double tmp1532 = -0.3673205103e-5 * tmp1396 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1395 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1400 - 0.3507e0 * tmp1449;
  double tmp1533 = 0.1000000000e1 * tmp1413 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1392 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1397 + 0.32e-1 * tmp1446;
  double tmp1534 = -0.3673205103e-5 * tmp1398 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1406 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1411 - 0.3507e0 * tmp1462;
  double tmp1535 = cos(q[12] - 0.15708e1) * tmp1399 - sin(q[12] - 0.15708e1) * tmp1391 + 0.3507e0 * tmp1469 - 0.32e-1 * tmp1445;
  double tmp1536 = 0.1000000000e1 * tmp1396 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1395 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1400 + 0.32e-1 * tmp1449;
  double tmp1537 = -0.3673205103e-5 * tmp1389 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1388 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1384 - 0.3507e0 * tmp1467;
  double tmp1538 = -0.3673205103e-5 * tmp1401 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1432 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1436 - 0.3507e0 * tmp1489;
  double tmp1539 = cos(q[12] - 0.15708e1) * tmp1402 - sin(q[12] - 0.15708e1) * tmp1393 + 0.3507e0 * tmp1488 - 0.32e-1 * tmp1447;
  double tmp1540 = 0.1000000000e1 * tmp1389 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1388 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1384 + 0.32e-1 * tmp1467;
  double tmp1541 = 0.1000000000e1 * tmp1421 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1410 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1403 + 0.32e-1 * tmp1466;
  double tmp1542 = cos(q[12] - 0.15708e1) * tmp1404 - sin(q[12] - 0.15708e1) * tmp1407 + 0.3507e0 * tmp1490 - 0.32e-1 * tmp1463;
  double tmp1543 = 0.1000000000e1 * tmp1430 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1414 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1405 + 0.32e-1 * tmp1471;
  double tmp1544 = cos(q[12] - 0.15708e1) * tmp1406 - sin(q[12] - 0.15708e1) * tmp1411 + 0.3507e0 * tmp1452 - 0.32e-1 * tmp1468;
  double tmp1545 = 0.1000000000e1 * tmp1433 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1404 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1407 + 0.32e-1 * tmp1460;
  double tmp1546 = -0.3673205103e-5 * tmp1408 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1428 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1438 - 0.3507e0 * tmp1485;
  double tmp1547 = -0.3673205103e-5 * tmp1409 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1422 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1426 - 0.3507e0 * tmp1479;
  double tmp1548 = cos(q[12] - 0.15708e1) * tmp1410 - sin(q[12] - 0.15708e1) * tmp1403 + 0.3507e0 * tmp1478 - 0.32e-1 * tmp1459;
  double tmp1549 = cos(q[12] - 0.15708e1) * tmp1388 - sin(q[12] - 0.15708e1) * tmp1384 + 0.3507e0 * tmp1455 - 0.32e-1 * tmp1458;
  double tmp1550 = 0.1000000000e1 * tmp1398 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1406 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1411 + 0.32e-1 * tmp1462;
  double tmp1551 = -0.3673205103e-5 * tmp1412 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1399 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1391 - 0.3507e0 * tmp1453;
  double tmp1552 = -0.3673205103e-5 * tmp1413 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1392 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1397 - 0.3507e0 * tmp1446;
  double tmp1553 = cos(q[12] - 0.15708e1) * tmp1414 - sin(q[12] - 0.15708e1) * tmp1405 + 0.3507e0 * tmp1487 - 0.32e-1 * tmp1461;
  double tmp1554 = -0.3673205103e-5 * tmp1415 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1427 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1419 - 0.3507e0 * tmp1484;
  double tmp1555 = 0.1000000000e1 * tmp1435 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1425 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1416 + 0.32e-1 * tmp1482;
  double tmp1556 = -0.3673205103e-5 * tmp1417 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1441 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1434 - 0.3507e0 * tmp1498;
  double tmp1557 = cos(q[12] - 0.15708e1) * tmp1418 - sin(q[12] - 0.15708e1) * tmp1423 + 0.3507e0 * tmp1477 - 0.32e-1 * tmp1480;
  double tmp1558 = 0.1000000000e1 * tmp1415 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1427 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1419 + 0.32e-1 * tmp1484;
  double tmp1559 = -0.3673205103e-5 * tmp1420 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1418 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1423 - 0.3507e0 * tmp1475;
  double tmp1560 = -0.3673205103e-5 * tmp1421 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1410 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1403 - 0.3507e0 * tmp1466;
  double tmp1561 = cos(q[12] - 0.15708e1) * tmp1422 - sin(q[12] - 0.15708e1) * tmp1426 + 0.3507e0 * tmp1465 - 0.32e-1 * tmp1483;
  double tmp1562 = 0.1000000000e1 * tmp1420 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1418 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1423 + 0.32e-1 * tmp1475;
  double tmp1563 = -0.3673205103e-5 * tmp1424 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1439 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1440 - 0.3507e0 * tmp1496;
  double tmp1564 = cos(q[12] - 0.15708e1) * tmp1425 - sin(q[12] - 0.15708e1) * tmp1416 + 0.3507e0 * tmp1492 - 0.32e-1 * tmp1473;
  double tmp1565 = 0.1000000000e1 * tmp1409 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1422 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1426 + 0.32e-1 * tmp1479;
  double tmp1566 = cos(q[12] - 0.15708e1) * tmp1427 - sin(q[12] - 0.15708e1) * tmp1419 + 0.3507e0 * tmp1472 - 0.32e-1 * tmp1476;
  double tmp1567 = cos(q[12] - 0.15708e1) * tmp1428 - sin(q[12] - 0.15708e1) * tmp1438 + 0.3507e0 * tmp1464 - 0.32e-1 * tmp1495;
  double tmp1568 = 0.1000000000e1 * tmp1394 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1437 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1429 + 0.32e-1 * tmp1494;
  double tmp1569 = -0.3673205103e-5 * tmp1430 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1414 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1405 - 0.3507e0 * tmp1471;
  double tmp1570 = -0.3673205103e-5 * tmp1431 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1402 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1393 - 0.3507e0 * tmp1457;
  double tmp1571 = cos(q[12] - 0.15708e1) * tmp1432 - sin(q[12] - 0.15708e1) * tmp1436 + 0.3507e0 * tmp1456 - 0.32e-1 * tmp1493;
  double tmp1572 = -0.3673205103e-5 * tmp1433 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1404 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1407 - 0.3507e0 * tmp1460;
  double tmp1573 = 0.1000000000e1 * tmp1417 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1441 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1434 + 0.32e-1 * tmp1498;
  double tmp1574 = -0.3673205103e-5 * tmp1435 - 0.1000000000e1 * sin(q[12] - 0.15708e1) * tmp1425 - 0.1000000000e1 * cos(q[12] - 0.15708e1) * tmp1416 - 0.3507e0 * tmp1482;
  double tmp1575 = 0.1000000000e1 * tmp1401 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1432 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1436 + 0.32e-1 * tmp1489;
  double tmp1576 = cos(q[12] - 0.15708e1) * tmp1437 - sin(q[12] - 0.15708e1) * tmp1429 + 0.3507e0 * tmp1448 - 0.32e-1 * tmp1486;
  double tmp1577 = 0.1000000000e1 * tmp1408 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1428 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1438 + 0.32e-1 * tmp1485;
  double tmp1578 = cos(q[12] - 0.15708e1) * tmp1439 - sin(q[12] - 0.15708e1) * tmp1440 + 0.3507e0 * tmp1481 - 0.32e-1 * tmp1497;
  double tmp1579 = 0.1000000000e1 * tmp1424 - 0.3673205103e-5 * sin(q[12] - 0.15708e1) * tmp1439 - 0.3673205103e-5 * cos(q[12] - 0.15708e1) * tmp1440 + 0.32e-1 * tmp1496;
  double tmp1580 = cos(q[12] - 0.15708e1) * tmp1441 - sin(q[12] - 0.15708e1) * tmp1434 + 0.3507e0 * tmp1474 - 0.32e-1 * tmp1491;
  double tmp1581 = tmp213 * S35 * C34 + tmp229 * (S35 * S34 * S33 + C35 * C33) + tmp221 * (S35 * S34 * C33 - C35 * S33);
  double tmp1582 = -tmp224 * S34 + tmp219 * C34 * S33 + tmp212 * C34 * C33;
  double tmp1583 = tmp227 * S35 * C34 + tmp225 * (S35 * S34 * S33 + C35 * C33) + tmp217 * (S35 * S34 * C33 - C35 * S33);
  double tmp1584 = tmp1470 * S35 * C34 + tmp1446 * (S35 * S34 * S33 + C35 * C33) + tmp1451 * (S35 * S34 * C33 - C35 * S33);
  double tmp1585 = tmp501 * C35 * C34 + tmp496 * (C35 * S34 * S33 - S35 * C33) + tmp494 * (C35 * S34 * C33 + S35 * S33);
  double tmp1586 = tmp1455 * S35 * C34 + tmp1467 * (S35 * S34 * S33 + C35 * C33) + tmp1458 * (S35 * S34 * C33 - C35 * S33);
  double tmp1587 = tmp228 * S35 * C34 + tmp222 * (S35 * S34 * S33 + C35 * C33) + tmp214 * (S35 * S34 * C33 - C35 * S33);
  double tmp1588 = -tmp1481 * S34 + tmp1496 * C34 * S33 + tmp1497 * C34 * C33;
  double tmp1589 = tmp1452 * C35 * C34 + tmp1462 * (C35 * S34 * S33 - S35 * C33) + tmp1468 * (C35 * S34 * C33 + S35 * S33);
  double tmp1590 = tmp1472 * C35 * C34 + tmp1484 * (C35 * S34 * S33 - S35 * C33) + tmp1476 * (C35 * S34 * C33 + S35 * S33);
  double tmp1591 = tmp1474 * S35 * C34 + tmp1498 * (S35 * S34 * S33 + C35 * C33) + tmp1491 * (S35 * S34 * C33 - C35 * S33);
  double tmp1592 = tmp1470 * C35 * C34 + tmp1446 * (C35 * S34 * S33 - S35 * C33) + tmp1451 * (C35 * S34 * C33 + S35 * S33);
  double tmp1593 = -tmp1455 * S34 + tmp1467 * C34 * S33 + tmp1458 * C34 * C33;
  double tmp1594 = tmp213 * C35 * C34 + tmp229 * (C35 * S34 * S33 - S35 * C33) + tmp221 * (C35 * S34 * C33 + S35 * S33);
  double tmp1595 = -tmp1472 * S34 + tmp1484 * C34 * S33 + tmp1476 * C34 * C33;
  double tmp1596 = tmp1452 * S35 * C34 + tmp1462 * (S35 * S34 * S33 + C35 * C33) + tmp1468 * (S35 * S34 * C33 - C35 * S33);
  double tmp1597 = tmp1472 * S35 * C34 + tmp1484 * (S35 * S34 * S33 + C35 * C33) + tmp1476 * (S35 * S34 * C33 - C35 * S33);
  double tmp1598 = tmp1474 * C35 * C34 + tmp1498 * (C35 * S34 * S33 - S35 * C33) + tmp1491 * (C35 * S34 * C33 + S35 * S33);
  double tmp1599 = tmp1448 * C35 * C34 + tmp1494 * (C35 * S34 * S33 - S35 * C33) + tmp1486 * (C35 * S34 * C33 + S35 * S33);
  double tmp1600 = tmp228 * C35 * C34 + tmp222 * (C35 * S34 * S33 - S35 * C33) + tmp214 * (C35 * S34 * C33 + S35 * S33);
  double tmp1601 = tmp488 * S35 * C34 + tmp486 * (S35 * S34 * S33 + C35 * C33) + tmp484 * (S35 * S34 * C33 - C35 * S33);
  double tmp1602 = tmp1481 * C35 * C34 + tmp1496 * (C35 * S34 * S33 - S35 * C33) + tmp1497 * (C35 * S34 * C33 + S35 * S33);
  double tmp1603 = -tmp1465 * S34 + tmp1479 * C34 * S33 + tmp1483 * C34 * C33;
  double tmp1604 = tmp223 * S35 * C34 + tmp218 * (S35 * S34 * S33 + C35 * C33) + tmp216 * (S35 * S34 * C33 - C35 * S33);
  double tmp1605 = tmp224 * S35 * C34 + tmp219 * (S35 * S34 * S33 + C35 * C33) + tmp212 * (S35 * S34 * C33 - C35 * S33);
  double tmp1606 = -tmp227 * S34 + tmp225 * C34 * S33 + tmp217 * C34 * C33;
  double tmp1607 = tmp1469 * C35 * C34 + tmp1453 * (C35 * S34 * S33 - S35 * C33) + tmp1445 * (C35 * S34 * C33 + S35 * S33);
  double tmp1608 = tmp1492 * S35 * C34 + tmp1482 * (S35 * S34 * S33 + C35 * C33) + tmp1473 * (S35 * S34 * C33 - C35 * S33);
  double tmp1609 = -tmp488 * S34 + tmp486 * C34 * S33 + tmp484 * C34 * C33;
  double tmp1610 = tmp1481 * S35 * C34 + tmp1496 * (S35 * S34 * S33 + C35 * C33) + tmp1497 * (S35 * S34 * C33 - C35 * S33);
  double tmp1611 = tmp1448 * S35 * C34 + tmp1494 * (S35 * S34 * S33 + C35 * C33) + tmp1486 * (S35 * S34 * C33 - C35 * S33);
  double tmp1612 = tmp488 * C35 * C34 + tmp486 * (C35 * S34 * S33 - S35 * C33) + tmp484 * (C35 * S34 * C33 + S35 * S33);
  double tmp1613 = tmp1492 * C35 * C34 + tmp1482 * (C35 * S34 * S33 - S35 * C33) + tmp1473 * (C35 * S34 * C33 + S35 * S33);
  double tmp1614 = tmp1455 * C35 * C34 + tmp1467 * (C35 * S34 * S33 - S35 * C33) + tmp1458 * (C35 * S34 * C33 + S35 * S33);
  double tmp1615 = -tmp213 * S34 + tmp229 * C34 * S33 + tmp221 * C34 * C33;
  double tmp1616 = tmp1478 * C35 * C34 + tmp1466 * (C35 * S34 * S33 - S35 * C33) + tmp1459 * (C35 * S34 * C33 + S35 * S33);
  double tmp1617 = -tmp223 * S34 + tmp218 * C34 * S33 + tmp216 * C34 * C33;
  double tmp1618 = tmp495 * S35 * C34 + tmp493 * (S35 * S34 * S33 + C35 * C33) + tmp497 * (S35 * S34 * C33 - C35 * S33);
  double tmp1619 = -tmp1492 * S34 + tmp1482 * C34 * S33 + tmp1473 * C34 * C33;
  double tmp1620 = tmp1477 * S35 * C34 + tmp1475 * (S35 * S34 * S33 + C35 * C33) + tmp1480 * (S35 * S34 * C33 - C35 * S33);
  double tmp1621 = -tmp1478 * S34 + tmp1466 * C34 * S33 + tmp1459 * C34 * C33;
  double tmp1622 = tmp1469 * S35 * C34 + tmp1453 * (S35 * S34 * S33 + C35 * C33) + tmp1445 * (S35 * S34 * C33 - C35 * S33);
  double tmp1623 = tmp1465 * S35 * C34 + tmp1479 * (S35 * S34 * S33 + C35 * C33) + tmp1483 * (S35 * S34 * C33 - C35 * S33);
  double tmp1624 = tmp223 * C35 * C34 + tmp218 * (C35 * S34 * S33 - S35 * C33) + tmp216 * (C35 * S34 * C33 + S35 * S33);
  double tmp1625 = tmp1456 * C35 * C34 + tmp1489 * (C35 * S34 * S33 - S35 * C33) + tmp1493 * (C35 * S34 * C33 + S35 * S33);
  double tmp1626 = -tmp1470 * S34 + tmp1446 * C34 * S33 + tmp1451 * C34 * C33;
  double tmp1627 = tmp1488 * C35 * C34 + tmp1457 * (C35 * S34 * S33 - S35 * C33) + tmp1447 * (C35 * S34 * C33 + S35 * S33);
  double tmp1628 = tmp1450 * S35 * C34 + tmp1449 * (S35 * S34 * S33 + C35 * C33) + tmp1454 * (S35 * S34 * C33 - C35 * S33);
  double tmp1629 = -tmp220 * S34 + tmp226 * C34 * S33 + tmp215 * C34 * C33;
  double tmp1630 = -tmp1464 * S34 + tmp1485 * C34 * S33 + tmp1495 * C34 * C33;
  double tmp1631 = tmp1477 * C35 * C34 + tmp1475 * (C35 * S34 * S33 - S35 * C33) + tmp1480 * (C35 * S34 * C33 + S35 * S33);
  double tmp1632 = tmp1478 * S35 * C34 + tmp1466 * (S35 * S34 * S33 + C35 * C33) + tmp1459 * (S35 * S34 * C33 - C35 * S33);
  double tmp1633 = -tmp1469 * S34 + tmp1453 * C34 * S33 + tmp1445 * C34 * C33;
  double tmp1634 = tmp1465 * C35 * C34 + tmp1479 * (C35 * S34 * S33 - S35 * C33) + tmp1483 * (C35 * S34 * C33 + S35 * S33);
  double tmp1635 = tmp224 * C35 * C34 + tmp219 * (C35 * S34 * S33 - S35 * C33) + tmp212 * (C35 * S34 * C33 + S35 * S33);
  double tmp1636 = tmp1456 * S35 * C34 + tmp1489 * (S35 * S34 * S33 + C35 * C33) + tmp1493 * (S35 * S34 * C33 - C35 * S33);
  double tmp1637 = tmp495 * C35 * C34 + tmp493 * (C35 * S34 * S33 - S35 * C33) + tmp497 * (C35 * S34 * C33 + S35 * S33);
  double tmp1638 = tmp1464 * C35 * C34 + tmp1485 * (C35 * S34 * S33 - S35 * C33) + tmp1495 * (C35 * S34 * C33 + S35 * S33);
  double tmp1639 = -tmp490 * S34 + tmp499 * C34 * S33 + tmp491 * C34 * C33;
  double tmp1640 = tmp220 * S35 * C34 + tmp226 * (S35 * S34 * S33 + C35 * C33) + tmp215 * (S35 * S34 * C33 - C35 * S33);
  double tmp1641 = -tmp492 * S34 + tmp498 * C34 * S33 + tmp500 * C34 * C33;
  double tmp1642 = -tmp485 * S34 + tmp489 * C34 * S33 + tmp487 * C34 * C33;
  double tmp1643 = tmp1464 * S35 * C34 + tmp1485 * (S35 * S34 * S33 + C35 * C33) + tmp1495 * (S35 * S34 * C33 - C35 * S33);
  double tmp1644 = tmp1450 * C35 * C34 + tmp1449 * (C35 * S34 * S33 - S35 * C33) + tmp1454 * (C35 * S34 * C33 + S35 * S33);
  double tmp1645 = -tmp1488 * S34 + tmp1457 * C34 * S33 + tmp1447 * C34 * C33;
  double tmp1646 = -tmp1474 * S34 + tmp1498 * C34 * S33 + tmp1491 * C34 * C33;
  double tmp1647 = tmp1487 * S35 * C34 + tmp1471 * (S35 * S34 * S33 + C35 * C33) + tmp1461 * (S35 * S34 * C33 - C35 * S33);
  double tmp1648 = tmp490 * S35 * C34 + tmp499 * (S35 * S34 * S33 + C35 * C33) + tmp491 * (S35 * S34 * C33 - C35 * S33);
  double tmp1649 = tmp1490 * C35 * C34 + tmp1460 * (C35 * S34 * S33 - S35 * C33) + tmp1463 * (C35 * S34 * C33 + S35 * S33);
  double tmp1650 = tmp220 * C35 * C34 + tmp226 * (C35 * S34 * S33 - S35 * C33) + tmp215 * (C35 * S34 * C33 + S35 * S33);
  double tmp1651 = tmp492 * S35 * C34 + tmp498 * (S35 * S34 * S33 + C35 * C33) + tmp500 * (S35 * S34 * C33 - C35 * S33);
  double tmp1652 = tmp485 * S35 * C34 + tmp489 * (S35 * S34 * S33 + C35 * C33) + tmp487 * (S35 * S34 * C33 - C35 * S33);
  double tmp1653 = tmp1490 * S35 * C34 + tmp1460 * (S35 * S34 * S33 + C35 * C33) + tmp1463 * (S35 * S34 * C33 - C35 * S33);
  double tmp1654 = tmp501 * S35 * C34 + tmp496 * (S35 * S34 * S33 + C35 * C33) + tmp494 * (S35 * S34 * C33 - C35 * S33);
  double tmp1655 = -tmp1487 * S34 + tmp1471 * C34 * S33 + tmp1461 * C34 * C33;
  double tmp1656 = -tmp1456 * S34 + tmp1489 * C34 * S33 + tmp1493 * C34 * C33;
  double tmp1657 = tmp490 * C35 * C34 + tmp499 * (C35 * S34 * S33 - S35 * C33) + tmp491 * (C35 * S34 * C33 + S35 * S33);
  double tmp1658 = -tmp228 * S34 + tmp222 * C34 * S33 + tmp214 * C34 * C33;
  double tmp1659 = tmp492 * C35 * C34 + tmp498 * (C35 * S34 * S33 - S35 * C33) + tmp500 * (C35 * S34 * C33 + S35 * S33);
  double tmp1660 = tmp485 * C35 * C34 + tmp489 * (C35 * S34 * S33 - S35 * C33) + tmp487 * (C35 * S34 * C33 + S35 * S33);
  double tmp1661 = tmp1488 * S35 * C34 + tmp1457 * (S35 * S34 * S33 + C35 * C33) + tmp1447 * (S35 * S34 * C33 - C35 * S33);
  double tmp1662 = -tmp1452 * S34 + tmp1462 * C34 * S33 + tmp1468 * C34 * C33;
  double tmp1663 = -tmp1450 * S34 + tmp1449 * C34 * S33 + tmp1454 * C34 * C33;
  double tmp1664 = tmp1487 * C35 * C34 + tmp1471 * (C35 * S34 * S33 - S35 * C33) + tmp1461 * (C35 * S34 * C33 + S35 * S33);
  double tmp1665 = -tmp1477 * S34 + tmp1475 * C34 * S33 + tmp1480 * C34 * C33;
  double tmp1666 = -tmp1448 * S34 + tmp1494 * C34 * S33 + tmp1486 * C34 * C33;
  double tmp1667 = tmp227 * C35 * C34 + tmp225 * (C35 * S34 * S33 - S35 * C33) + tmp217 * (C35 * S34 * C33 + S35 * S33);
  double tmp1668 = -tmp495 * S34 + tmp493 * C34 * S33 + tmp497 * C34 * C33;
  double tmp1669 = -tmp1490 * S34 + tmp1460 * C34 * S33 + tmp1463 * C34 * C33;
  double tmp1670 = -tmp501 * S34 + tmp496 * C34 * S33 + tmp494 * C34 * C33;
  double tmp1671 = tmp542 * C33 - tmp534 * S33;
  double tmp1672 = tmp1561 * C33 - tmp1565 * S33;
  double tmp1673 = tmp529 * C33 - tmp527 * S33;
  double tmp1674 = tmp1549 * C33 - tmp1540 * S33;
  double tmp1675 = -tmp531 * S34 + tmp529 * C34 * S33 + tmp527 * C34 * C33;
  double tmp1676 = -tmp533 * S34 + tmp542 * C34 * S33 + tmp534 * C34 * C33;
  double tmp1677 = -tmp1551 * S34 + tmp1535 * C34 * S33 + tmp1527 * C34 * C33;
  double tmp1678 = -tmp1547 * S34 + tmp1561 * C34 * S33 + tmp1565 * C34 * C33;
  double tmp1679 = tmp261 * C33 - tmp259 * S33;
  double tmp1680 = -tmp266 * S34 + tmp261 * C34 * S33 + tmp259 * C34 * C33;
  double tmp1681 = -tmp544 * S34 + tmp539 * C34 * S33 + tmp537 * C34 * C33;
  double tmp1682 = -tmp1560 * S34 + tmp1548 * C34 * S33 + tmp1541 * C34 * C33;
  double tmp1683 = -tmp1538 * S34 + tmp1571 * C34 * S33 + tmp1575 * C34 * C33;
  double tmp1684 = tmp536 * C33 - tmp540 * S33;
  double tmp1685 = tmp1535 * C33 - tmp1527 * S33;
  double tmp1686 = -tmp1554 * S34 + tmp1566 * C34 * S33 + tmp1558 * C34 * C33;
  double tmp1687 = tmp1531 * C33 - tmp1536 * S33;
  double tmp1688 = -tmp270 * S34 + tmp268 * C34 * S33 + tmp260 * C34 * C33;
  double tmp1689 = -tmp538 * S34 + tmp536 * C34 * S33 + tmp540 * C34 * C33;
  double tmp1690 = tmp262 * C33 - tmp255 * S33;
  double tmp1691 = -tmp1537 * S34 + tmp1549 * C34 * S33 + tmp1540 * C34 * C33;
  double tmp1692 = tmp1571 * C33 - tmp1575 * S33;
  double tmp1693 = -tmp1572 * S34 + tmp1542 * C34 * S33 + tmp1545 * C34 * C33;
  double tmp1694 = -tmp1532 * S34 + tmp1531 * C34 * S33 + tmp1536 * C34 * C33;
  double tmp1695 = tmp1566 * C33 - tmp1558 * S33;
  double tmp1696 = tmp265 * C33 - tmp257 * S33;
  double tmp1697 = tmp541 * C33 - tmp543 * S33;
  double tmp1698 = tmp532 * C33 - tmp530 * S33;
  double tmp1699 = -tmp1530 * S34 + tmp1576 * C34 * S33 + tmp1568 * C34 * C33;
  double tmp1700 = tmp272 * C33 - tmp264 * S33;
  double tmp1701 = -tmp1570 * S34 + tmp1539 * C34 * S33 + tmp1529 * C34 * C33;
  double tmp1702 = tmp1553 * C33 - tmp1543 * S33;
  double tmp1703 = -tmp1534 * S34 + tmp1544 * C34 * S33 + tmp1550 * C34 * C33;
  double tmp1704 = tmp1580 * C33 - tmp1573 * S33;
  double tmp1705 = -tmp267 * S34 + tmp262 * C34 * S33 + tmp255 * C34 * C33;
  double tmp1706 = tmp1576 * C33 - tmp1568 * S33;
  double tmp1707 = -tmp256 * S34 + tmp272 * C34 * S33 + tmp264 * C34 * C33;
  double tmp1708 = tmp1567 * C33 - tmp1577 * S33;
  double tmp1709 = -tmp1569 * S34 + tmp1553 * C34 * S33 + tmp1543 * C34 * C33;
  double tmp1710 = tmp1542 * C33 - tmp1545 * S33;
  double tmp1711 = tmp269 * C33 - tmp258 * S33;
  double tmp1712 = -tmp528 * S34 + tmp532 * C34 * S33 + tmp530 * C34 * C33;
  double tmp1713 = tmp539 * C33 - tmp537 * S33;
  double tmp1714 = tmp268 * C33 - tmp260 * S33;
  double tmp1715 = tmp1544 * C33 - tmp1550 * S33;
  double tmp1716 = -tmp1556 * S34 + tmp1580 * C34 * S33 + tmp1573 * C34 * C33;
  double tmp1717 = -tmp1563 * S34 + tmp1578 * C34 * S33 + tmp1579 * C34 * C33;
  double tmp1718 = tmp1528 * C33 - tmp1533 * S33;
  double tmp1719 = tmp1557 * C33 - tmp1562 * S33;
  double tmp1720 = tmp1564 * C33 - tmp1555 * S33;
  double tmp1721 = -tmp271 * S34 + tmp265 * C34 * S33 + tmp257 * C34 * C33;
  double tmp1722 = -tmp263 * S34 + tmp269 * C34 * S33 + tmp258 * C34 * C33;
  double tmp1723 = -tmp535 * S34 + tmp541 * C34 * S33 + tmp543 * C34 * C33;
  double tmp1724 = -tmp1546 * S34 + tmp1567 * C34 * S33 + tmp1577 * C34 * C33;
  double tmp1725 = tmp1548 * C33 - tmp1541 * S33;
  double tmp1726 = tmp1578 * C33 - tmp1579 * S33;
  double tmp1727 = -tmp1552 * S34 + tmp1528 * C34 * S33 + tmp1533 * C34 * C33;
  double tmp1728 = -tmp1559 * S34 + tmp1557 * C34 * S33 + tmp1562 * C34 * C33;
  double tmp1729 = tmp1539 * C33 - tmp1529 * S33;
  double tmp1730 = -tmp1574 * S34 + tmp1564 * C34 * S33 + tmp1555 * C34 * C33;
  double tmp1731 = 0.56867992e2 * C34 * C33;
  double tmp1732 = 0.56867992e2 * S35 * C34;
  double tmp1733 = 0.56867992e2 * S35 * S34 * S33 + 0.56867992e2 * C35 * C33;
  double tmp1734 = 0.56867992e2 * C35 * S34 * S33 - 0.56867992e2 * S35 * C33;
  double tmp1735 = 0.56867992e2 * S35 * S34 * C33 - 0.56867992e2 * C35 * S33;
  double tmp1736 = -0.56867992e2 * S34;
  double tmp1737 = tmp1517 * C34 * S33 - tmp1516 * C34 * C33;
  double tmp1738 = -tmp1515 * C33;
  double tmp1739 = -tmp1515 * S33;
  double tmp1740 = -tmp1516 * S34 - tmp1515 * C34 * S33;
  double tmp1741 = 0.56867992e2 * C35 * S34 * C33 + 0.56867992e2 * S35 * S33;
  double tmp1742 = tmp1517 * C33 + tmp1516 * S33;
  double tmp1743 = tmp1517 * S34 + tmp1515 * C34 * C33;
  double tmp1744 = 0.56867992e2 * C34 * S33;
  double tmp1745 = 0.56867992e2 * C35 * C34;
  double tmp1746 = tmp1516 * S34 + tmp1515 * C34 * S33;
  double tmp1747 = -tmp1517 * (S35 * S34 * S33 + C35 * C33) + tmp1516 * (S35 * S34 * C33 - C35 * S33);
  double tmp1748 = tmp1517 * S35 * C34 - tmp1515 * (S35 * S34 * C33 - C35 * S33);
  double tmp1749 = tmp1517 * C35 * C34 - tmp1515 * (C35 * S34 * C33 + S35 * S33);
  double tmp1750 = -tmp1516 * S35 * C34 + tmp1515 * (S35 * S34 * S33 + C35 * C33);
  double tmp1751 = -tmp1517 * C34 * S33 + tmp1516 * C34 * C33;
  double tmp1752 = -tmp1525 * S34 + tmp1526 * C34 * S33 + tmp1523 * C34 * C33;
  double tmp1753 = tmp1519 * C33 - tmp1518 * S33;
  double tmp1754 = tmp1522 * C33 - tmp1521 * S33;
  double tmp1755 = -tmp1520 * S34 + tmp1519 * C34 * S33 + tmp1518 * C34 * C33;
  double tmp1756 = -tmp1516 * C35 * C34 + tmp1515 * (C35 * S34 * S33 - S35 * C33);
  double tmp1757 = tmp1526 * C33 - tmp1523 * S33;
  double tmp1758 = -tmp1524 * S34 + tmp1522 * C34 * S33 + tmp1521 * C34 * C33;
  double tmp1759 = -tmp1517 * S34 - tmp1515 * C34 * C33;
  double tmp1760 = -tmp1517 * (C35 * S34 * S33 - S35 * C33) + tmp1516 * (C35 * S34 * C33 + S35 * S33);
  double t1 = cos(q[35]);
  double t3 = cos(q[34]);
  double t5 = sin(q[34]);
  double t6 = t1 * t5;
  double t7 = sin(q[33]);
  double t9 = sin(q[35]);
  double t10 = cos(q[33]);
  double t12 = t6 * t7 - t9 * t10;
  double t16 = t6 * t10 + t9 * t7;
  double t21 = t9 * t5;
  double t24 = t21 * t7 + t1 * t10;
  double t28 = t21 * t10 - t1 * t7;
  M[0] = tmp192;
  M[1] = tmp207;
  M[2] = tmp205;
  M[3] = tmp201;
  M[4] = tmp195;
  M[5] = tmp204;
  M[6] = 0.0e0;
  M[7] = 0.0e0;
  M[8] = 0.0e0;
  M[9] = 0.0e0;
  M[10] = 0.0e0;
  M[11] = 0.0e0;
  M[12] = 0.0e0;
  M[13] = 0.0e0;
  M[14] = 0.0e0;
  M[15] = 0.0e0;
  M[16] = 0.0e0;
  M[17] = 0.0e0;
  M[18] = 0.0e0;
  M[19] = 0.0e0;
  M[20] = 0.0e0;
  M[21] = 0.0e0;
  M[22] = 0.0e0;
  M[23] = 0.0e0;
  M[24] = 0.0e0;
  M[25] = 0.0e0;
  M[26] = 0.0e0;
  M[27] = 0.0e0;
  M[28] = 0.0e0;
  M[29] = 0.0e0;
  M[30] = tmp1667;
  M[31] = tmp1583;
  M[32] = tmp1606;
  M[33] = tmp270;
  M[34] = tmp1714;
  M[35] = tmp1688;
  M[36] = tmp207;
  M[37] = tmp141;
  M[38] = tmp152;
  M[39] = tmp149;
  M[40] = tmp144;
  M[41] = tmp151;
  M[42] = 0.0e0;
  M[43] = 0.0e0;
  M[44] = 0.0e0;
  M[45] = 0.0e0;
  M[46] = 0.0e0;
  M[47] = 0.0e0;
  M[48] = 0.0e0;
  M[49] = 0.0e0;
  M[50] = 0.0e0;
  M[51] = 0.0e0;
  M[52] = 0.0e0;
  M[53] = 0.0e0;
  M[54] = 0.0e0;
  M[55] = 0.0e0;
  M[56] = 0.0e0;
  M[57] = 0.0e0;
  M[58] = 0.0e0;
  M[59] = 0.0e0;
  M[60] = 0.0e0;
  M[61] = 0.0e0;
  M[62] = 0.0e0;
  M[63] = 0.0e0;
  M[64] = 0.0e0;
  M[65] = 0.0e0;
  M[66] = tmp1600;
  M[67] = tmp1587;
  M[68] = tmp1658;
  M[69] = tmp271;
  M[70] = tmp1696;
  M[71] = tmp1721;
  M[72] = tmp205;
  M[73] = tmp152;
  M[74] = tmp96;
  M[75] = tmp102;
  M[76] = tmp98;
  M[77] = tmp104;
  M[78] = 0.0e0;
  M[79] = 0.0e0;
  M[80] = 0.0e0;
  M[81] = 0.0e0;
  M[82] = 0.0e0;
  M[83] = 0.0e0;
  M[84] = 0.0e0;
  M[85] = 0.0e0;
  M[86] = 0.0e0;
  M[87] = 0.0e0;
  M[88] = 0.0e0;
  M[89] = 0.0e0;
  M[90] = 0.0e0;
  M[91] = 0.0e0;
  M[92] = 0.0e0;
  M[93] = 0.0e0;
  M[94] = 0.0e0;
  M[95] = 0.0e0;
  M[96] = 0.0e0;
  M[97] = 0.0e0;
  M[98] = 0.0e0;
  M[99] = 0.0e0;
  M[100] = 0.0e0;
  M[101] = 0.0e0;
  M[102] = tmp1635;
  M[103] = tmp1605;
  M[104] = tmp1582;
  M[105] = tmp267;
  M[106] = tmp1690;
  M[107] = tmp1705;
  M[108] = tmp201;
  M[109] = tmp149;
  M[110] = tmp102;
  M[111] = tmp60;
  M[112] = tmp62;
  M[113] = tmp66;
  M[114] = 0.0e0;
  M[115] = 0.0e0;
  M[116] = 0.0e0;
  M[117] = 0.0e0;
  M[118] = 0.0e0;
  M[119] = 0.0e0;
  M[120] = 0.0e0;
  M[121] = 0.0e0;
  M[122] = 0.0e0;
  M[123] = 0.0e0;
  M[124] = 0.0e0;
  M[125] = 0.0e0;
  M[126] = 0.0e0;
  M[127] = 0.0e0;
  M[128] = 0.0e0;
  M[129] = 0.0e0;
  M[130] = 0.0e0;
  M[131] = 0.0e0;
  M[132] = 0.0e0;
  M[133] = 0.0e0;
  M[134] = 0.0e0;
  M[135] = 0.0e0;
  M[136] = 0.0e0;
  M[137] = 0.0e0;
  M[138] = tmp1650;
  M[139] = tmp1640;
  M[140] = tmp1629;
  M[141] = tmp263;
  M[142] = tmp1711;
  M[143] = tmp1722;
  M[144] = tmp195;
  M[145] = tmp144;
  M[146] = tmp98;
  M[147] = tmp62;
  M[148] = tmp26;
  M[149] = tmp30;
  M[150] = 0.0e0;
  M[151] = 0.0e0;
  M[152] = 0.0e0;
  M[153] = 0.0e0;
  M[154] = 0.0e0;
  M[155] = 0.0e0;
  M[156] = 0.0e0;
  M[157] = 0.0e0;
  M[158] = 0.0e0;
  M[159] = 0.0e0;
  M[160] = 0.0e0;
  M[161] = 0.0e0;
  M[162] = 0.0e0;
  M[163] = 0.0e0;
  M[164] = 0.0e0;
  M[165] = 0.0e0;
  M[166] = 0.0e0;
  M[167] = 0.0e0;
  M[168] = 0.0e0;
  M[169] = 0.0e0;
  M[170] = 0.0e0;
  M[171] = 0.0e0;
  M[172] = 0.0e0;
  M[173] = 0.0e0;
  M[174] = tmp1594;
  M[175] = tmp1581;
  M[176] = tmp1615;
  M[177] = tmp256;
  M[178] = tmp1700;
  M[179] = tmp1707;
  M[180] = tmp204;
  M[181] = tmp151;
  M[182] = tmp104;
  M[183] = tmp66;
  M[184] = tmp30;
  M[185] = 0.1104206826e-1;
  M[186] = 0.0e0;
  M[187] = 0.0e0;
  M[188] = 0.0e0;
  M[189] = 0.0e0;
  M[190] = 0.0e0;
  M[191] = 0.0e0;
  M[192] = 0.0e0;
  M[193] = 0.0e0;
  M[194] = 0.0e0;
  M[195] = 0.0e0;
  M[196] = 0.0e0;
  M[197] = 0.0e0;
  M[198] = 0.0e0;
  M[199] = 0.0e0;
  M[200] = 0.0e0;
  M[201] = 0.0e0;
  M[202] = 0.0e0;
  M[203] = 0.0e0;
  M[204] = 0.0e0;
  M[205] = 0.0e0;
  M[206] = 0.0e0;
  M[207] = 0.0e0;
  M[208] = 0.0e0;
  M[209] = 0.0e0;
  M[210] = tmp1624;
  M[211] = tmp1604;
  M[212] = tmp1617;
  M[213] = tmp266;
  M[214] = tmp1679;
  M[215] = tmp1680;
  M[216] = 0.0e0;
  M[217] = 0.0e0;
  M[218] = 0.0e0;
  M[219] = 0.0e0;
  M[220] = 0.0e0;
  M[221] = 0.0e0;
  M[222] = tmp464;
  M[223] = tmp469;
  M[224] = tmp480;
  M[225] = tmp474;
  M[226] = tmp471;
  M[227] = tmp466;
  M[228] = 0.0e0;
  M[229] = 0.0e0;
  M[230] = 0.0e0;
  M[231] = 0.0e0;
  M[232] = 0.0e0;
  M[233] = 0.0e0;
  M[234] = 0.0e0;
  M[235] = 0.0e0;
  M[236] = 0.0e0;
  M[237] = 0.0e0;
  M[238] = 0.0e0;
  M[239] = 0.0e0;
  M[240] = 0.0e0;
  M[241] = 0.0e0;
  M[242] = 0.0e0;
  M[243] = 0.0e0;
  M[244] = 0.0e0;
  M[245] = 0.0e0;
  M[246] = tmp1612;
  M[247] = tmp1601;
  M[248] = tmp1609;
  M[249] = tmp531;
  M[250] = tmp1673;
  M[251] = tmp1675;
  M[252] = 0.0e0;
  M[253] = 0.0e0;
  M[254] = 0.0e0;
  M[255] = 0.0e0;
  M[256] = 0.0e0;
  M[257] = 0.0e0;
  M[258] = tmp469;
  M[259] = tmp413;
  M[260] = tmp426;
  M[261] = tmp421;
  M[262] = tmp418;
  M[263] = tmp415;
  M[264] = 0.0e0;
  M[265] = 0.0e0;
  M[266] = 0.0e0;
  M[267] = 0.0e0;
  M[268] = 0.0e0;
  M[269] = 0.0e0;
  M[270] = 0.0e0;
  M[271] = 0.0e0;
  M[272] = 0.0e0;
  M[273] = 0.0e0;
  M[274] = 0.0e0;
  M[275] = 0.0e0;
  M[276] = 0.0e0;
  M[277] = 0.0e0;
  M[278] = 0.0e0;
  M[279] = 0.0e0;
  M[280] = 0.0e0;
  M[281] = 0.0e0;
  M[282] = tmp1657;
  M[283] = tmp1648;
  M[284] = tmp1639;
  M[285] = tmp533;
  M[286] = tmp1671;
  M[287] = tmp1676;
  M[288] = 0.0e0;
  M[289] = 0.0e0;
  M[290] = 0.0e0;
  M[291] = 0.0e0;
  M[292] = 0.0e0;
  M[293] = 0.0e0;
  M[294] = tmp480;
  M[295] = tmp426;
  M[296] = tmp368;
  M[297] = tmp375;
  M[298] = tmp373;
  M[299] = tmp370;
  M[300] = 0.0e0;
  M[301] = 0.0e0;
  M[302] = 0.0e0;
  M[303] = 0.0e0;
  M[304] = 0.0e0;
  M[305] = 0.0e0;
  M[306] = 0.0e0;
  M[307] = 0.0e0;
  M[308] = 0.0e0;
  M[309] = 0.0e0;
  M[310] = 0.0e0;
  M[311] = 0.0e0;
  M[312] = 0.0e0;
  M[313] = 0.0e0;
  M[314] = 0.0e0;
  M[315] = 0.0e0;
  M[316] = 0.0e0;
  M[317] = 0.0e0;
  M[318] = tmp1585;
  M[319] = tmp1654;
  M[320] = tmp1670;
  M[321] = tmp544;
  M[322] = tmp1713;
  M[323] = tmp1681;
  M[324] = 0.0e0;
  M[325] = 0.0e0;
  M[326] = 0.0e0;
  M[327] = 0.0e0;
  M[328] = 0.0e0;
  M[329] = 0.0e0;
  M[330] = tmp474;
  M[331] = tmp421;
  M[332] = tmp375;
  M[333] = tmp332;
  M[334] = tmp337;
  M[335] = tmp334;
  M[336] = 0.0e0;
  M[337] = 0.0e0;
  M[338] = 0.0e0;
  M[339] = 0.0e0;
  M[340] = 0.0e0;
  M[341] = 0.0e0;
  M[342] = 0.0e0;
  M[343] = 0.0e0;
  M[344] = 0.0e0;
  M[345] = 0.0e0;
  M[346] = 0.0e0;
  M[347] = 0.0e0;
  M[348] = 0.0e0;
  M[349] = 0.0e0;
  M[350] = 0.0e0;
  M[351] = 0.0e0;
  M[352] = 0.0e0;
  M[353] = 0.0e0;
  M[354] = tmp1637;
  M[355] = tmp1618;
  M[356] = tmp1668;
  M[357] = tmp538;
  M[358] = tmp1684;
  M[359] = tmp1689;
  M[360] = 0.0e0;
  M[361] = 0.0e0;
  M[362] = 0.0e0;
  M[363] = 0.0e0;
  M[364] = 0.0e0;
  M[365] = 0.0e0;
  M[366] = tmp471;
  M[367] = tmp418;
  M[368] = tmp373;
  M[369] = tmp337;
  M[370] = tmp298;
  M[371] = tmp300;
  M[372] = 0.0e0;
  M[373] = 0.0e0;
  M[374] = 0.0e0;
  M[375] = 0.0e0;
  M[376] = 0.0e0;
  M[377] = 0.0e0;
  M[378] = 0.0e0;
  M[379] = 0.0e0;
  M[380] = 0.0e0;
  M[381] = 0.0e0;
  M[382] = 0.0e0;
  M[383] = 0.0e0;
  M[384] = 0.0e0;
  M[385] = 0.0e0;
  M[386] = 0.0e0;
  M[387] = 0.0e0;
  M[388] = 0.0e0;
  M[389] = 0.0e0;
  M[390] = tmp1659;
  M[391] = tmp1651;
  M[392] = tmp1641;
  M[393] = tmp535;
  M[394] = tmp1697;
  M[395] = tmp1723;
  M[396] = 0.0e0;
  M[397] = 0.0e0;
  M[398] = 0.0e0;
  M[399] = 0.0e0;
  M[400] = 0.0e0;
  M[401] = 0.0e0;
  M[402] = tmp466;
  M[403] = tmp415;
  M[404] = tmp370;
  M[405] = tmp334;
  M[406] = tmp300;
  M[407] = 0.1104206826e-1;
  M[408] = 0.0e0;
  M[409] = 0.0e0;
  M[410] = 0.0e0;
  M[411] = 0.0e0;
  M[412] = 0.0e0;
  M[413] = 0.0e0;
  M[414] = 0.0e0;
  M[415] = 0.0e0;
  M[416] = 0.0e0;
  M[417] = 0.0e0;
  M[418] = 0.0e0;
  M[419] = 0.0e0;
  M[420] = 0.0e0;
  M[421] = 0.0e0;
  M[422] = 0.0e0;
  M[423] = 0.0e0;
  M[424] = 0.0e0;
  M[425] = 0.0e0;
  M[426] = tmp1660;
  M[427] = tmp1652;
  M[428] = tmp1642;
  M[429] = tmp528;
  M[430] = tmp1698;
  M[431] = tmp1712;
  M[432] = 0.0e0;
  M[433] = 0.0e0;
  M[434] = 0.0e0;
  M[435] = 0.0e0;
  M[436] = 0.0e0;
  M[437] = 0.0e0;
  M[438] = 0.0e0;
  M[439] = 0.0e0;
  M[440] = 0.0e0;
  M[441] = 0.0e0;
  M[442] = 0.0e0;
  M[443] = 0.0e0;
  M[444] = tmp1389;
  M[445] = tmp1408;
  M[446] = tmp1420;
  M[447] = tmp1430;
  M[448] = tmp1412;
  M[449] = tmp1396;
  M[450] = tmp1433;
  M[451] = tmp1415;
  M[452] = tmp1394;
  M[453] = tmp1398;
  M[454] = tmp1413;
  M[455] = tmp1417;
  M[456] = tmp1435;
  M[457] = tmp1409;
  M[458] = tmp1401;
  M[459] = tmp1431;
  M[460] = tmp1421;
  M[461] = tmp1424;
  M[462] = tmp1614;
  M[463] = tmp1586;
  M[464] = tmp1593;
  M[465] = tmp1537;
  M[466] = tmp1674;
  M[467] = tmp1691;
  M[468] = 0.0e0;
  M[469] = 0.0e0;
  M[470] = 0.0e0;
  M[471] = 0.0e0;
  M[472] = 0.0e0;
  M[473] = 0.0e0;
  M[474] = 0.0e0;
  M[475] = 0.0e0;
  M[476] = 0.0e0;
  M[477] = 0.0e0;
  M[478] = 0.0e0;
  M[479] = 0.0e0;
  M[480] = tmp1408;
  M[481] = tmp1293;
  M[482] = tmp615;
  M[483] = tmp617;
  M[484] = tmp959;
  M[485] = tmp950;
  M[486] = tmp965;
  M[487] = tmp961;
  M[488] = tmp948;
  M[489] = tmp952;
  M[490] = tmp960;
  M[491] = tmp1302;
  M[492] = tmp1311;
  M[493] = tmp1299;
  M[494] = tmp1296;
  M[495] = tmp1308;
  M[496] = tmp1303;
  M[497] = tmp1305;
  M[498] = tmp1638;
  M[499] = tmp1643;
  M[500] = tmp1630;
  M[501] = tmp1546;
  M[502] = tmp1708;
  M[503] = tmp1724;
  M[504] = 0.0e0;
  M[505] = 0.0e0;
  M[506] = 0.0e0;
  M[507] = 0.0e0;
  M[508] = 0.0e0;
  M[509] = 0.0e0;
  M[510] = 0.0e0;
  M[511] = 0.0e0;
  M[512] = 0.0e0;
  M[513] = 0.0e0;
  M[514] = 0.0e0;
  M[515] = 0.0e0;
  M[516] = tmp1420;
  M[517] = tmp615;
  M[518] = tmp570;
  M[519] = tmp574;
  M[520] = 0.0e0;
  M[521] = 0.0e0;
  M[522] = 0.0e0;
  M[523] = 0.0e0;
  M[524] = 0.0e0;
  M[525] = 0.0e0;
  M[526] = 0.0e0;
  M[527] = 0.0e0;
  M[528] = 0.0e0;
  M[529] = 0.0e0;
  M[530] = 0.0e0;
  M[531] = 0.0e0;
  M[532] = 0.0e0;
  M[533] = 0.0e0;
  M[534] = tmp1631;
  M[535] = tmp1620;
  M[536] = tmp1665;
  M[537] = tmp1559;
  M[538] = tmp1719;
  M[539] = tmp1728;
  M[540] = 0.0e0;
  M[541] = 0.0e0;
  M[542] = 0.0e0;
  M[543] = 0.0e0;
  M[544] = 0.0e0;
  M[545] = 0.0e0;
  M[546] = 0.0e0;
  M[547] = 0.0e0;
  M[548] = 0.0e0;
  M[549] = 0.0e0;
  M[550] = 0.0e0;
  M[551] = 0.0e0;
  M[552] = tmp1430;
  M[553] = tmp617;
  M[554] = tmp574;
  M[555] = 0.1090452175e-1;
  M[556] = 0.0e0;
  M[557] = 0.0e0;
  M[558] = 0.0e0;
  M[559] = 0.0e0;
  M[560] = 0.0e0;
  M[561] = 0.0e0;
  M[562] = 0.0e0;
  M[563] = 0.0e0;
  M[564] = 0.0e0;
  M[565] = 0.0e0;
  M[566] = 0.0e0;
  M[567] = 0.0e0;
  M[568] = 0.0e0;
  M[569] = 0.0e0;
  M[570] = tmp1664;
  M[571] = tmp1647;
  M[572] = tmp1655;
  M[573] = tmp1569;
  M[574] = tmp1702;
  M[575] = tmp1709;
  M[576] = 0.0e0;
  M[577] = 0.0e0;
  M[578] = 0.0e0;
  M[579] = 0.0e0;
  M[580] = 0.0e0;
  M[581] = 0.0e0;
  M[582] = 0.0e0;
  M[583] = 0.0e0;
  M[584] = 0.0e0;
  M[585] = 0.0e0;
  M[586] = 0.0e0;
  M[587] = 0.0e0;
  M[588] = tmp1412;
  M[589] = tmp959;
  M[590] = 0.0e0;
  M[591] = 0.0e0;
  M[592] = tmp883;
  M[593] = tmp888;
  M[594] = tmp901;
  M[595] = tmp897;
  M[596] = tmp886;
  M[597] = tmp890;
  M[598] = tmp896;
  M[599] = 0.0e0;
  M[600] = 0.0e0;
  M[601] = 0.0e0;
  M[602] = 0.0e0;
  M[603] = 0.0e0;
  M[604] = 0.0e0;
  M[605] = 0.0e0;
  M[606] = tmp1607;
  M[607] = tmp1622;
  M[608] = tmp1633;
  M[609] = tmp1551;
  M[610] = tmp1685;
  M[611] = tmp1677;
  M[612] = 0.0e0;
  M[613] = 0.0e0;
  M[614] = 0.0e0;
  M[615] = 0.0e0;
  M[616] = 0.0e0;
  M[617] = 0.0e0;
  M[618] = 0.0e0;
  M[619] = 0.0e0;
  M[620] = 0.0e0;
  M[621] = 0.0e0;
  M[622] = 0.0e0;
  M[623] = 0.0e0;
  M[624] = tmp1396;
  M[625] = tmp950;
  M[626] = 0.0e0;
  M[627] = 0.0e0;
  M[628] = tmp888;
  M[629] = tmp826;
  M[630] = tmp841;
  M[631] = tmp837;
  M[632] = tmp829;
  M[633] = tmp831;
  M[634] = tmp836;
  M[635] = 0.0e0;
  M[636] = 0.0e0;
  M[637] = 0.0e0;
  M[638] = 0.0e0;
  M[639] = 0.0e0;
  M[640] = 0.0e0;
  M[641] = 0.0e0;
  M[642] = tmp1644;
  M[643] = tmp1628;
  M[644] = tmp1663;
  M[645] = tmp1532;
  M[646] = tmp1687;
  M[647] = tmp1694;
  M[648] = 0.0e0;
  M[649] = 0.0e0;
  M[650] = 0.0e0;
  M[651] = 0.0e0;
  M[652] = 0.0e0;
  M[653] = 0.0e0;
  M[654] = 0.0e0;
  M[655] = 0.0e0;
  M[656] = 0.0e0;
  M[657] = 0.0e0;
  M[658] = 0.0e0;
  M[659] = 0.0e0;
  M[660] = tmp1433;
  M[661] = tmp965;
  M[662] = 0.0e0;
  M[663] = 0.0e0;
  M[664] = tmp901;
  M[665] = tmp841;
  M[666] = tmp775;
  M[667] = tmp784;
  M[668] = tmp778;
  M[669] = tmp780;
  M[670] = tmp783;
  M[671] = 0.0e0;
  M[672] = 0.0e0;
  M[673] = 0.0e0;
  M[674] = 0.0e0;
  M[675] = 0.0e0;
  M[676] = 0.0e0;
  M[677] = 0.0e0;
  M[678] = tmp1649;
  M[679] = tmp1653;
  M[680] = tmp1669;
  M[681] = tmp1572;
  M[682] = tmp1710;
  M[683] = tmp1693;
  M[684] = 0.0e0;
  M[685] = 0.0e0;
  M[686] = 0.0e0;
  M[687] = 0.0e0;
  M[688] = 0.0e0;
  M[689] = 0.0e0;
  M[690] = 0.0e0;
  M[691] = 0.0e0;
  M[692] = 0.0e0;
  M[693] = 0.0e0;
  M[694] = 0.0e0;
  M[695] = 0.0e0;
  M[696] = tmp1415;
  M[697] = tmp961;
  M[698] = 0.0e0;
  M[699] = 0.0e0;
  M[700] = tmp897;
  M[701] = tmp837;
  M[702] = tmp784;
  M[703] = tmp726;
  M[704] = tmp729;
  M[705] = tmp731;
  M[706] = tmp734;
  M[707] = 0.0e0;
  M[708] = 0.0e0;
  M[709] = 0.0e0;
  M[710] = 0.0e0;
  M[711] = 0.0e0;
  M[712] = 0.0e0;
  M[713] = 0.0e0;
  M[714] = tmp1590;
  M[715] = tmp1597;
  M[716] = tmp1595;
  M[717] = tmp1554;
  M[718] = tmp1695;
  M[719] = tmp1686;
  M[720] = 0.0e0;
  M[721] = 0.0e0;
  M[722] = 0.0e0;
  M[723] = 0.0e0;
  M[724] = 0.0e0;
  M[725] = 0.0e0;
  M[726] = 0.0e0;
  M[727] = 0.0e0;
  M[728] = 0.0e0;
  M[729] = 0.0e0;
  M[730] = 0.0e0;
  M[731] = 0.0e0;
  M[732] = tmp1394;
  M[733] = tmp948;
  M[734] = 0.0e0;
  M[735] = 0.0e0;
  M[736] = tmp886;
  M[737] = tmp829;
  M[738] = tmp778;
  M[739] = tmp729;
  M[740] = tmp683;
  M[741] = tmp687;
  M[742] = tmp690;
  M[743] = 0.0e0;
  M[744] = 0.0e0;
  M[745] = 0.0e0;
  M[746] = 0.0e0;
  M[747] = 0.0e0;
  M[748] = 0.0e0;
  M[749] = 0.0e0;
  M[750] = tmp1599;
  M[751] = tmp1611;
  M[752] = tmp1666;
  M[753] = tmp1530;
  M[754] = tmp1706;
  M[755] = tmp1699;
  M[756] = 0.0e0;
  M[757] = 0.0e0;
  M[758] = 0.0e0;
  M[759] = 0.0e0;
  M[760] = 0.0e0;
  M[761] = 0.0e0;
  M[762] = 0.0e0;
  M[763] = 0.0e0;
  M[764] = 0.0e0;
  M[765] = 0.0e0;
  M[766] = 0.0e0;
  M[767] = 0.0e0;
  M[768] = tmp1398;
  M[769] = tmp952;
  M[770] = 0.0e0;
  M[771] = 0.0e0;
  M[772] = tmp890;
  M[773] = tmp831;
  M[774] = tmp780;
  M[775] = tmp731;
  M[776] = tmp687;
  M[777] = tmp650;
  M[778] = tmp654;
  M[779] = 0.0e0;
  M[780] = 0.0e0;
  M[781] = 0.0e0;
  M[782] = 0.0e0;
  M[783] = 0.0e0;
  M[784] = 0.0e0;
  M[785] = 0.0e0;
  M[786] = tmp1589;
  M[787] = tmp1596;
  M[788] = tmp1662;
  M[789] = tmp1534;
  M[790] = tmp1715;
  M[791] = tmp1703;
  M[792] = 0.0e0;
  M[793] = 0.0e0;
  M[794] = 0.0e0;
  M[795] = 0.0e0;
  M[796] = 0.0e0;
  M[797] = 0.0e0;
  M[798] = 0.0e0;
  M[799] = 0.0e0;
  M[800] = 0.0e0;
  M[801] = 0.0e0;
  M[802] = 0.0e0;
  M[803] = 0.0e0;
  M[804] = tmp1413;
  M[805] = tmp960;
  M[806] = 0.0e0;
  M[807] = 0.0e0;
  M[808] = tmp896;
  M[809] = tmp836;
  M[810] = tmp783;
  M[811] = tmp734;
  M[812] = tmp690;
  M[813] = tmp654;
  M[814] = 0.6757839673e-3;
  M[815] = 0.0e0;
  M[816] = 0.0e0;
  M[817] = 0.0e0;
  M[818] = 0.0e0;
  M[819] = 0.0e0;
  M[820] = 0.0e0;
  M[821] = 0.0e0;
  M[822] = tmp1592;
  M[823] = tmp1584;
  M[824] = tmp1626;
  M[825] = tmp1552;
  M[826] = tmp1718;
  M[827] = tmp1727;
  M[828] = 0.0e0;
  M[829] = 0.0e0;
  M[830] = 0.0e0;
  M[831] = 0.0e0;
  M[832] = 0.0e0;
  M[833] = 0.0e0;
  M[834] = 0.0e0;
  M[835] = 0.0e0;
  M[836] = 0.0e0;
  M[837] = 0.0e0;
  M[838] = 0.0e0;
  M[839] = 0.0e0;
  M[840] = tmp1417;
  M[841] = tmp1302;
  M[842] = 0.0e0;
  M[843] = 0.0e0;
  M[844] = 0.0e0;
  M[845] = 0.0e0;
  M[846] = 0.0e0;
  M[847] = 0.0e0;
  M[848] = 0.0e0;
  M[849] = 0.0e0;
  M[850] = 0.0e0;
  M[851] = tmp1232;
  M[852] = tmp1248;
  M[853] = tmp1238;
  M[854] = tmp1235;
  M[855] = tmp1246;
  M[856] = tmp1241;
  M[857] = tmp1243;
  M[858] = tmp1598;
  M[859] = tmp1591;
  M[860] = tmp1646;
  M[861] = tmp1556;
  M[862] = tmp1704;
  M[863] = tmp1716;
  M[864] = 0.0e0;
  M[865] = 0.0e0;
  M[866] = 0.0e0;
  M[867] = 0.0e0;
  M[868] = 0.0e0;
  M[869] = 0.0e0;
  M[870] = 0.0e0;
  M[871] = 0.0e0;
  M[872] = 0.0e0;
  M[873] = 0.0e0;
  M[874] = 0.0e0;
  M[875] = 0.0e0;
  M[876] = tmp1435;
  M[877] = tmp1311;
  M[878] = 0.0e0;
  M[879] = 0.0e0;
  M[880] = 0.0e0;
  M[881] = 0.0e0;
  M[882] = 0.0e0;
  M[883] = 0.0e0;
  M[884] = 0.0e0;
  M[885] = 0.0e0;
  M[886] = 0.0e0;
  M[887] = tmp1248;
  M[888] = tmp1175;
  M[889] = tmp1181;
  M[890] = tmp1178;
  M[891] = tmp1187;
  M[892] = tmp1183;
  M[893] = tmp1185;
  M[894] = tmp1613;
  M[895] = tmp1608;
  M[896] = tmp1619;
  M[897] = tmp1574;
  M[898] = tmp1720;
  M[899] = tmp1730;
  M[900] = 0.0e0;
  M[901] = 0.0e0;
  M[902] = 0.0e0;
  M[903] = 0.0e0;
  M[904] = 0.0e0;
  M[905] = 0.0e0;
  M[906] = 0.0e0;
  M[907] = 0.0e0;
  M[908] = 0.0e0;
  M[909] = 0.0e0;
  M[910] = 0.0e0;
  M[911] = 0.0e0;
  M[912] = tmp1409;
  M[913] = tmp1299;
  M[914] = 0.0e0;
  M[915] = 0.0e0;
  M[916] = 0.0e0;
  M[917] = 0.0e0;
  M[918] = 0.0e0;
  M[919] = 0.0e0;
  M[920] = 0.0e0;
  M[921] = 0.0e0;
  M[922] = 0.0e0;
  M[923] = tmp1238;
  M[924] = tmp1181;
  M[925] = tmp1124;
  M[926] = tmp1127;
  M[927] = tmp1133;
  M[928] = tmp1131;
  M[929] = tmp1132;
  M[930] = tmp1634;
  M[931] = tmp1623;
  M[932] = tmp1603;
  M[933] = tmp1547;
  M[934] = tmp1672;
  M[935] = tmp1678;
  M[936] = 0.0e0;
  M[937] = 0.0e0;
  M[938] = 0.0e0;
  M[939] = 0.0e0;
  M[940] = 0.0e0;
  M[941] = 0.0e0;
  M[942] = 0.0e0;
  M[943] = 0.0e0;
  M[944] = 0.0e0;
  M[945] = 0.0e0;
  M[946] = 0.0e0;
  M[947] = 0.0e0;
  M[948] = tmp1401;
  M[949] = tmp1296;
  M[950] = 0.0e0;
  M[951] = 0.0e0;
  M[952] = 0.0e0;
  M[953] = 0.0e0;
  M[954] = 0.0e0;
  M[955] = 0.0e0;
  M[956] = 0.0e0;
  M[957] = 0.0e0;
  M[958] = 0.0e0;
  M[959] = tmp1235;
  M[960] = tmp1178;
  M[961] = tmp1127;
  M[962] = tmp1075;
  M[963] = tmp1083;
  M[964] = tmp1081;
  M[965] = tmp1082;
  M[966] = tmp1625;
  M[967] = tmp1636;
  M[968] = tmp1656;
  M[969] = tmp1538;
  M[970] = tmp1692;
  M[971] = tmp1683;
  M[972] = 0.0e0;
  M[973] = 0.0e0;
  M[974] = 0.0e0;
  M[975] = 0.0e0;
  M[976] = 0.0e0;
  M[977] = 0.0e0;
  M[978] = 0.0e0;
  M[979] = 0.0e0;
  M[980] = 0.0e0;
  M[981] = 0.0e0;
  M[982] = 0.0e0;
  M[983] = 0.0e0;
  M[984] = tmp1431;
  M[985] = tmp1308;
  M[986] = 0.0e0;
  M[987] = 0.0e0;
  M[988] = 0.0e0;
  M[989] = 0.0e0;
  M[990] = 0.0e0;
  M[991] = 0.0e0;
  M[992] = 0.0e0;
  M[993] = 0.0e0;
  M[994] = 0.0e0;
  M[995] = tmp1246;
  M[996] = tmp1187;
  M[997] = tmp1133;
  M[998] = tmp1083;
  M[999] = tmp1032;
  M[1000] = tmp1036;
  M[1001] = tmp1037;
  M[1002] = tmp1627;
  M[1003] = tmp1661;
  M[1004] = tmp1645;
  M[1005] = tmp1570;
  M[1006] = tmp1729;
  M[1007] = tmp1701;
  M[1008] = 0.0e0;
  M[1009] = 0.0e0;
  M[1010] = 0.0e0;
  M[1011] = 0.0e0;
  M[1012] = 0.0e0;
  M[1013] = 0.0e0;
  M[1014] = 0.0e0;
  M[1015] = 0.0e0;
  M[1016] = 0.0e0;
  M[1017] = 0.0e0;
  M[1018] = 0.0e0;
  M[1019] = 0.0e0;
  M[1020] = tmp1421;
  M[1021] = tmp1303;
  M[1022] = 0.0e0;
  M[1023] = 0.0e0;
  M[1024] = 0.0e0;
  M[1025] = 0.0e0;
  M[1026] = 0.0e0;
  M[1027] = 0.0e0;
  M[1028] = 0.0e0;
  M[1029] = 0.0e0;
  M[1030] = 0.0e0;
  M[1031] = tmp1241;
  M[1032] = tmp1183;
  M[1033] = tmp1131;
  M[1034] = tmp1081;
  M[1035] = tmp1036;
  M[1036] = tmp999;
  M[1037] = tmp1001;
  M[1038] = tmp1616;
  M[1039] = tmp1632;
  M[1040] = tmp1621;
  M[1041] = tmp1560;
  M[1042] = tmp1725;
  M[1043] = tmp1682;
  M[1044] = 0.0e0;
  M[1045] = 0.0e0;
  M[1046] = 0.0e0;
  M[1047] = 0.0e0;
  M[1048] = 0.0e0;
  M[1049] = 0.0e0;
  M[1050] = 0.0e0;
  M[1051] = 0.0e0;
  M[1052] = 0.0e0;
  M[1053] = 0.0e0;
  M[1054] = 0.0e0;
  M[1055] = 0.0e0;
  M[1056] = tmp1424;
  M[1057] = tmp1305;
  M[1058] = 0.0e0;
  M[1059] = 0.0e0;
  M[1060] = 0.0e0;
  M[1061] = 0.0e0;
  M[1062] = 0.0e0;
  M[1063] = 0.0e0;
  M[1064] = 0.0e0;
  M[1065] = 0.0e0;
  M[1066] = 0.0e0;
  M[1067] = tmp1243;
  M[1068] = tmp1185;
  M[1069] = tmp1132;
  M[1070] = tmp1082;
  M[1071] = tmp1037;
  M[1072] = tmp1001;
  M[1073] = 0.6757839673e-3;
  M[1074] = tmp1602;
  M[1075] = tmp1610;
  M[1076] = tmp1588;
  M[1077] = tmp1563;
  M[1078] = tmp1726;
  M[1079] = tmp1717;
  M[1080] = tmp1667;
  M[1081] = tmp1600;
  M[1082] = tmp1635;
  M[1083] = tmp1650;
  M[1084] = tmp1594;
  M[1085] = tmp1624;
  M[1086] = tmp1612;
  M[1087] = tmp1657;
  M[1088] = tmp1585;
  M[1089] = tmp1637;
  M[1090] = tmp1659;
  M[1091] = tmp1660;
  M[1092] = tmp1614;
  M[1093] = tmp1638;
  M[1094] = tmp1631;
  M[1095] = tmp1664;
  M[1096] = tmp1607;
  M[1097] = tmp1644;
  M[1098] = tmp1649;
  M[1099] = tmp1590;
  M[1100] = tmp1599;
  M[1101] = tmp1589;
  M[1102] = tmp1592;
  M[1103] = tmp1598;
  M[1104] = tmp1613;
  M[1105] = tmp1634;
  M[1106] = tmp1625;
  M[1107] = tmp1627;
  M[1108] = tmp1616;
  M[1109] = tmp1602;
  M[1110] = tmp1745 * t1 * t3 + tmp1734 * t12 + tmp1741 * t16;
  M[1111] = tmp1745 * t9 * t3 + tmp1734 * t24 + tmp1741 * t28;
  M[1112] = -tmp1745 * t5 + tmp1734 * t3 * t7 + tmp1741 * t3 * t10;
  M[1113] = tmp1760;
  M[1114] = tmp1749 * t10 - tmp1756 * t7;
  M[1115] = -tmp1760 * t5 + tmp1749 * t3 * t7 + tmp1756 * t3 * t10;
  M[1116] = tmp1583;
  M[1117] = tmp1587;
  M[1118] = tmp1605;
  M[1119] = tmp1640;
  M[1120] = tmp1581;
  M[1121] = tmp1604;
  M[1122] = tmp1601;
  M[1123] = tmp1648;
  M[1124] = tmp1654;
  M[1125] = tmp1618;
  M[1126] = tmp1651;
  M[1127] = tmp1652;
  M[1128] = tmp1586;
  M[1129] = tmp1643;
  M[1130] = tmp1620;
  M[1131] = tmp1647;
  M[1132] = tmp1622;
  M[1133] = tmp1628;
  M[1134] = tmp1653;
  M[1135] = tmp1597;
  M[1136] = tmp1611;
  M[1137] = tmp1596;
  M[1138] = tmp1584;
  M[1139] = tmp1591;
  M[1140] = tmp1608;
  M[1141] = tmp1623;
  M[1142] = tmp1636;
  M[1143] = tmp1661;
  M[1144] = tmp1632;
  M[1145] = tmp1610;
  M[1146] = tmp1732 * t1 * t3 + tmp1733 * t12 + tmp1735 * t16;
  M[1147] = tmp1732 * t9 * t3 + tmp1733 * t24 + tmp1735 * t28;
  M[1148] = -tmp1732 * t5 + tmp1733 * t3 * t7 + tmp1735 * t3 * t10;
  M[1149] = tmp1747;
  M[1150] = tmp1748 * t10 - tmp1750 * t7;
  M[1151] = -tmp1747 * t5 + tmp1748 * t3 * t7 + tmp1750 * t3 * t10;
  M[1152] = tmp1606;
  M[1153] = tmp1658;
  M[1154] = tmp1582;
  M[1155] = tmp1629;
  M[1156] = tmp1615;
  M[1157] = tmp1617;
  M[1158] = tmp1609;
  M[1159] = tmp1639;
  M[1160] = tmp1670;
  M[1161] = tmp1668;
  M[1162] = tmp1641;
  M[1163] = tmp1642;
  M[1164] = tmp1593;
  M[1165] = tmp1630;
  M[1166] = tmp1665;
  M[1167] = tmp1655;
  M[1168] = tmp1633;
  M[1169] = tmp1663;
  M[1170] = tmp1669;
  M[1171] = tmp1595;
  M[1172] = tmp1666;
  M[1173] = tmp1662;
  M[1174] = tmp1626;
  M[1175] = tmp1646;
  M[1176] = tmp1619;
  M[1177] = tmp1603;
  M[1178] = tmp1656;
  M[1179] = tmp1645;
  M[1180] = tmp1621;
  M[1181] = tmp1588;
  M[1182] = tmp1736 * t1 * t3 + tmp1744 * t12 + tmp1731 * t16;
  M[1183] = tmp1736 * t9 * t3 + tmp1744 * t24 + tmp1731 * t28;
  M[1184] = -tmp1736 * t5 + tmp1744 * t3 * t7 + tmp1731 * t3 * t10;
  M[1185] = tmp1751;
  M[1186] = tmp1759 * t10 - tmp1746 * t7;
  M[1187] = -tmp1751 * t5 + tmp1759 * t3 * t7 + tmp1746 * t3 * t10;
  M[1188] = tmp270;
  M[1189] = tmp271;
  M[1190] = tmp267;
  M[1191] = tmp263;
  M[1192] = tmp256;
  M[1193] = tmp266;
  M[1194] = tmp531;
  M[1195] = tmp533;
  M[1196] = tmp544;
  M[1197] = tmp538;
  M[1198] = tmp535;
  M[1199] = tmp528;
  M[1200] = tmp1537;
  M[1201] = tmp1546;
  M[1202] = tmp1559;
  M[1203] = tmp1569;
  M[1204] = tmp1551;
  M[1205] = tmp1532;
  M[1206] = tmp1572;
  M[1207] = tmp1554;
  M[1208] = tmp1530;
  M[1209] = tmp1534;
  M[1210] = tmp1552;
  M[1211] = tmp1556;
  M[1212] = tmp1574;
  M[1213] = tmp1547;
  M[1214] = tmp1538;
  M[1215] = tmp1570;
  M[1216] = tmp1560;
  M[1217] = tmp1563;
  M[1218] = -tmp1517 * t12 + tmp1516 * t16;
  M[1219] = -tmp1517 * t24 + tmp1516 * t28;
  M[1220] = -tmp1517 * t3 * t7 + tmp1516 * t3 * t10;
  M[1221] = tmp1525;
  M[1222] = tmp1524 * t10 - tmp1520 * t7;
  M[1223] = -tmp1525 * t5 + tmp1524 * t3 * t7 + tmp1520 * t3 * t10;
  M[1224] = tmp1714;
  M[1225] = tmp1696;
  M[1226] = tmp1690;
  M[1227] = tmp1711;
  M[1228] = tmp1700;
  M[1229] = tmp1679;
  M[1230] = tmp1673;
  M[1231] = tmp1671;
  M[1232] = tmp1713;
  M[1233] = tmp1684;
  M[1234] = tmp1697;
  M[1235] = tmp1698;
  M[1236] = tmp1674;
  M[1237] = tmp1708;
  M[1238] = tmp1719;
  M[1239] = tmp1702;
  M[1240] = tmp1685;
  M[1241] = tmp1687;
  M[1242] = tmp1710;
  M[1243] = tmp1695;
  M[1244] = tmp1706;
  M[1245] = tmp1715;
  M[1246] = tmp1718;
  M[1247] = tmp1704;
  M[1248] = tmp1720;
  M[1249] = tmp1672;
  M[1250] = tmp1692;
  M[1251] = tmp1729;
  M[1252] = tmp1725;
  M[1253] = tmp1726;
  M[1254] = tmp1742 * t1 * t3 + tmp1739 * t12 + tmp1738 * t16;
  M[1255] = tmp1742 * t9 * t3 + tmp1739 * t24 + tmp1738 * t28;
  M[1256] = -tmp1742 * t5 + tmp1739 * t3 * t7 + tmp1738 * t3 * t10;
  M[1257] = tmp1757;
  M[1258] = tmp1754 * t10 - tmp1753 * t7;
  M[1259] = -tmp1757 * t5 + tmp1754 * t3 * t7 + tmp1753 * t3 * t10;
  M[1260] = tmp1688;
  M[1261] = tmp1721;
  M[1262] = tmp1705;
  M[1263] = tmp1722;
  M[1264] = tmp1707;
  M[1265] = tmp1680;
  M[1266] = tmp1675;
  M[1267] = tmp1676;
  M[1268] = tmp1681;
  M[1269] = tmp1689;
  M[1270] = tmp1723;
  M[1271] = tmp1712;
  M[1272] = tmp1691;
  M[1273] = tmp1724;
  M[1274] = tmp1728;
  M[1275] = tmp1709;
  M[1276] = tmp1677;
  M[1277] = tmp1694;
  M[1278] = tmp1693;
  M[1279] = tmp1686;
  M[1280] = tmp1699;
  M[1281] = tmp1703;
  M[1282] = tmp1727;
  M[1283] = tmp1716;
  M[1284] = tmp1730;
  M[1285] = tmp1678;
  M[1286] = tmp1683;
  M[1287] = tmp1701;
  M[1288] = tmp1682;
  M[1289] = tmp1717;
  M[1290] = tmp1737 * t1 * t3 + tmp1743 * t12 + tmp1740 * t16;
  M[1291] = tmp1737 * t9 * t3 + tmp1743 * t24 + tmp1740 * t28;
  M[1292] = -tmp1737 * t5 + tmp1743 * t3 * t7 + tmp1740 * t3 * t10;
  M[1293] = tmp1752;
  M[1294] = tmp1758 * t10 - tmp1755 * t7;
  M[1295] = -tmp1752 * t5 + tmp1758 * t3 * t7 + tmp1755 * t3 * t10;

  if ((MAL_MATRIX_NB_COLS(m_InertiaMatrix)!=numberDof()) ||
      (MAL_MATRIX_NB_ROWS(m_InertiaMatrix)!=numberDof()))
    MAL_MATRIX_RESIZE(m_InertiaMatrix,numberDof(),numberDof());

  MAL_MATRIX_FILL(m_InertiaMatrix,0.0);
  unsigned int rightHand = m_isKineoOrder ? (6+16+7) : (6+16+7+7);

  for(int i=0;i<6;i++)
    {
      // root(6)
      for(int j=0;j<6;j++)
	m_InertiaMatrix(i,j) = M[(i+30)*36+j+30];

      // legs(12), waist(2), neck(2) and right_arm(7)
      for(int j=0;j<16+7;j++)
	m_InertiaMatrix(i,j+6) = M[(i+30)*36+j];

      // left_arm(7)
      for(int j=0;j<7;j++)
	m_InertiaMatrix(i,leftArm+j) = M[(i+30)*36+16+7+j];

      // hands(5,5)
      if (MAL_MATRIX_NB_ROWS(m_InertiaMatrix)>36)
	for(unsigned int j=0;j<5;j++){
	  m_InertiaMatrix(i,rightHand+j) = 0.0;
	  m_InertiaMatrix(i,LEFT_HAND+j) = 0.0;
	}

    }

  for(int i=0;i<30;i++)
    {
      // root(6)
      for(int j=0;j<6;j++)
	m_InertiaMatrix(i+6,j) = M[i*36+j+30];

      // legs(12), waist(2), neck(2) and right_arm(7)
      for(int j=0;j<16+7;j++)
	  m_InertiaMatrix(i+6,j+6) = M[i*36+j];

      // left_arm(7)
      for(int j=0;j<7;j++)
	  m_InertiaMatrix(i+6,leftArm+j) = M[i*36+16+7+j];

      // hands(5,5)
      if (MAL_MATRIX_NB_ROWS(m_InertiaMatrix)>36)
	for(unsigned int j=0;j<5;j++){
	  m_InertiaMatrix(i+6,rightHand+j) = 0.0;
	  m_InertiaMatrix(i+6,LEFT_HAND+j) = 0.0;
	}
    }

}

void Chrp2OptHumanoidDynamicRobot::getWaistFootKinematics(const matrix4d & jointRootPosition,
							  const matrix4d & jointEndPosition,
							  vectorN &q,
							  vector3d Dt)
{
  double _epsilon=1.0e-6;
  // definition des variables relatif au design du robot
  double A = 0.3;//m_FemurLength;
  double B = 0.3;//m_TibiaLength;
  double C = 0.0;
  double c5 = 0.0;
  double q6a = 0.0;

  vector3d r;

  /* Build sub-matrices */
  matrix3d Foot_R,Body_R;
  vector3d Foot_P,Body_P;
  for(unsigned int i=0;i<3;i++)
    {
      for(unsigned int j=0;j<3;j++)
	{
	  MAL_S3x3_MATRIX_ACCESS_I_J(Body_R,i,j) =
	    MAL_S4x4_MATRIX_ACCESS_I_J(jointRootPosition,i,j);
	  MAL_S3x3_MATRIX_ACCESS_I_J(Foot_R,i,j) =
	    MAL_S4x4_MATRIX_ACCESS_I_J(jointEndPosition,i,j);
	}
      Body_P(i) = MAL_S4x4_MATRIX_ACCESS_I_J(jointRootPosition,i,3);
      Foot_P(i) = MAL_S4x4_MATRIX_ACCESS_I_J(jointEndPosition,i,3);
    }

  matrix3d Foot_Rt;
  MAL_S3x3_TRANSPOSE_A_in_At(Foot_R,Foot_Rt);

  // Initialisation of q
  if (MAL_VECTOR_SIZE(q)!=6)
    MAL_VECTOR_RESIZE(q,6);

  for(unsigned int i=0;i<6;i++)
    q(i)=0.0;

  double OppSignOfDtY = Dt(1) < 0.0 ? 1.0 : -1.0; // if Dt(1)<0.0 then Opp=1.0 else Opp=-1.0

  vector3d d2,d3;
  d2 = Body_P + Body_R * Dt;
  d3 = d2 - Foot_P;

  double l0 = sqrt(d3(0)*d3(0)+d3(1)*d3(1)+d3(2)*d3(2) - 0.035*0.035);
  c5 = 0.5 * (l0*l0-A*A-B*B) / (A*B);
  if (c5 > 1.0-_epsilon)
    {
      q[3] = 0.0;
    }
  if (c5 < -1.0+_epsilon)
    {
      q[3] = M_PI;
    }
  if (c5 >= -1.0+_epsilon && c5 <= 1.0-_epsilon)
    {
      q[3] = acos(c5);
    }

  vector3d r3;
  r3 = Foot_Rt * d3;

  q6a = asin((A/l0)*sin(M_PI- q[3]));

  double l3 = sqrt(r3(1)*r3(1) + r3(2)*r3(2));
  double l4 = sqrt(l3*l3 - 0.035*0.035);

  double phi = atan2(r3(0), l4);
  q[4] = -phi - q6a;

  double psi1 = atan2(r3(1), r3(2)) * OppSignOfDtY;
  double psi2 = 0.5*M_PI - psi1;
  double psi3 = atan2(l4, 0.035);
  q[5] = (psi3 - psi2) * OppSignOfDtY;

  if (q[5] > 0.5*M_PI)
    {
      q[5] -= M_PI;
    }
  else if (q[5] < -0.5*M_PI)
    {
      q[5] += M_PI;
    }

  matrix3d R;
  matrix3d BRt;
  MAL_S3x3_TRANSPOSE_A_in_At(Body_R,BRt);

  matrix3d Rroll;
  double c = cos(q[5]);
  double s = sin(q[5]);

  MAL_S3x3_MATRIX_ACCESS_I_J(Rroll,0,0) = 1.0;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rroll,0,1) = 0.0;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rroll,0,2) = 0.0;

  MAL_S3x3_MATRIX_ACCESS_I_J(Rroll,1,0) = 0.0;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rroll,1,1) = c;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rroll,1,2) = s;

  MAL_S3x3_MATRIX_ACCESS_I_J(Rroll,2,0) = 0.0;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rroll,2,1) = -s;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rroll,2,2) = c;

  matrix3d Rpitch;
  c = cos(q[4]+q[3]);
  s = sin(q[4]+q[3]);

  MAL_S3x3_MATRIX_ACCESS_I_J(Rpitch,0,0) = c;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rpitch,0,1) = 0.0;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rpitch,0,2) = -s;

  MAL_S3x3_MATRIX_ACCESS_I_J(Rpitch,1,0) = 0.0;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rpitch,1,1) = 1.0;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rpitch,1,2) = 0.0;

  MAL_S3x3_MATRIX_ACCESS_I_J(Rpitch,2,0) = s;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rpitch,2,1) = 0.0;
  MAL_S3x3_MATRIX_ACCESS_I_J(Rpitch,2,2) = c;

  R = BRt * Foot_R * Rroll * Rpitch;
  q[0] = atan2(-R(0,1),R(1,1));

  double cz = cos(q[0]);
  double sz = sin(q[0]);

  q[1] = atan2(R(2,1), -R(0,1)*sz+R(1,1)*cz);
  q[2] = atan2( -R(2,0), R(2,2));
}

double Chrp2OptHumanoidDynamicRobot::ComputeXmax(double & Z)
{
  double A=0.25,
    B=0.25;
  double Xmax;
  if (Z<0.0)
    Z = 2*A*cos(15*M_PI/180.0);
  Xmax = sqrt(A*A - (Z - B)*(Z-B));
  return Xmax;
}

void Chrp2OptHumanoidDynamicRobot::getShoulderWristKinematics(const matrix4d & jointRootPosition,
							      const matrix4d & jointEndPosition,
							      vectorN &q,
							      int side)
{

  // Initialisation of q
  if (MAL_VECTOR_SIZE(q)!=6)
    MAL_VECTOR_RESIZE(q,6);

  double Alpha,Beta;
  for(unsigned int i=0;i<6;i++)
    q(i)=0.0;

  double X = MAL_S4x4_MATRIX_ACCESS_I_J(jointEndPosition,0,3) - MAL_S4x4_MATRIX_ACCESS_I_J(jointRootPosition,0,3);
  double Z = MAL_S4x4_MATRIX_ACCESS_I_J(jointEndPosition,2,3) - MAL_S4x4_MATRIX_ACCESS_I_J(jointRootPosition,2,3);

  double Xmax = ComputeXmax(Z);
  X = X*Xmax;

  double A=0.25, B=0.25;

  double C=0.0,Gamma=0.0,Theta=0.0;
  C = sqrt(X*X+Z*Z);

  Beta = acos((A*A+B*B-C*C)/(2*A*B))- M_PI;
  Gamma = asin((B*sin(M_PI+Beta))/C);
  Theta = atan2(X,Z);
  Alpha = Gamma - Theta;

  // Fill in the joint values.
  q(0)= Alpha;
  q(1)= 10.0*M_PI/180.0;
  q(2)= 0.0;
  q(3)= Beta;
  q(4)= 0.0;
  q(5)= 0.0;

  if (side==-1)
    q(1) = -q(1);


}
void Chrp2OptHumanoidDynamicRobot::DetectAutomaticallyShoulders()
{
  CjrlHand *aHand = leftHand();
  DetectAutomaticallyOneShoulder(aHand,m_LeftShoulder);
  aHand = rightHand();
  DetectAutomaticallyOneShoulder(aHand,m_RightShoulder);
}

void Chrp2OptHumanoidDynamicRobot::DetectAutomaticallyOneShoulder(CjrlHand *aHand,
								  CjrlJoint *& aShoulder)
{
  std::vector<CjrlJoint *>FromRootToJoint;
  CjrlJoint *Chest = chest();

  FromRootToJoint.clear();
  FromRootToJoint = aHand->associatedWrist()->jointsFromRootToThis();

  std::vector<CjrlJoint *>::iterator itJoint = FromRootToJoint.begin();
  bool found=false;
  while(itJoint!=FromRootToJoint.end())
    {
      std::vector<CjrlJoint *>::iterator current = itJoint;
      if (*current==Chest)
	  found=true;
      else
	{
	  if (found)
	    {
	      aShoulder = *current;
	      return;
	    }
	}
      itJoint++;

    }
}

bool Chrp2OptHumanoidDynamicRobot::getSpecializedInverseKinematics(const CjrlJoint &jointRoot,
								   const CjrlJoint &jointEnd,
								   const matrix4d & jointRootPosition,
								   const matrix4d & jointEndPosition,
								   vectorN &q)
{

  /*! Try to find out which kinematics chain the user
    send to the method.*/
  if (&jointRoot==waist())
    {
      /* Consider here the legs. */
      vector3d Dt;
      bool ok=false;
      if (&jointEnd==leftAnkle())
	{
	  Dt(0)=0.0;Dt(1)=0.06;Dt(2)=0.0;
	  ok=true;
	}
      else if (&jointEnd==rightAnkle())
	{
	  Dt(0)=0.0;Dt(1)=-0.06;Dt(2)=0.0;
	  ok=true;
	}
      if (ok)
	{
	  getWaistFootKinematics(jointRootPosition,
				 jointEndPosition,
				 q,Dt);
	  return true;
	}
    }
  else
    {
      if ((m_LeftShoulder==0) ||
	  (m_RightShoulder==0))
	{
	  DetectAutomaticallyShoulders();
	}

      /* Here consider the arms */
      if (&jointRoot==m_LeftShoulder)
	{
	  int Side;
	  bool ok=false;
	  if (&jointEnd==leftWrist())
	    {
	      Side = 1;
	      ok=true;
	    }
	  if (ok)
	    {
	      getShoulderWristKinematics(jointRootPosition,
					 jointEndPosition,
					 q,Side);
	      return true;
	    }
	}

      if (&jointRoot==m_RightShoulder)
	{
	  int Side;
	  bool ok=false;

	  if (&jointEnd==rightWrist())
	    {
	      Side = -1;
	      ok=true;
	    }
	  if (ok)
	    {
	      getShoulderWristKinematics(jointRootPosition,
					 jointEndPosition,
					 q,Side);
	      return true;
	    }
	}
    }

  return false;
}

